// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(d) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function me(e, n) {
        return n.indexOf(e) >= 0;
    }
    function te(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function Q(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = Q(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function o(e, n) {
        this.message = e;
        this.defs = n;
    }
    o.prototype = Object.create(Error.prototype);
    o.prototype.constructor = o;
    o.prototype.name = "DefaultsError";
    n(o);
    function re(e, n, t) {
        if (e === true) e = {};
        var r = e || {};
        if (t) for (var i in r) if (se(r, i) && !se(n, i)) {
            throw new o("`" + i + "` is not a supported option", n);
        }
        for (var i in n) if (se(n, i)) {
            r[i] = e && se(e, i) ? e[i] : n[i];
        }
        return r;
    }
    function t(e, n) {
        var t = 0;
        for (var r in n) if (se(n, r)) {
            e[r] = n[r];
            t++;
        }
        return t;
    }
    function ie() {}
    function ge() {
        return false;
    }
    function oe() {
        return true;
    }
    function N() {
        return this;
    }
    function R() {
        return null;
    }
    var be = function() {
        function e(t, r, i) {
            var o = [], a = [], s;
            function e() {
                var e = r(t[s], s);
                var n = e instanceof l;
                if (n) e = e.v;
                if (e instanceof u) {
                    e = e.v;
                    if (e instanceof c) {
                        a.push.apply(a, i ? e.v.slice().reverse() : e.v);
                    } else {
                        a.push(e);
                    }
                } else if (e !== f) {
                    if (e instanceof c) {
                        o.push.apply(o, i ? e.v.slice().reverse() : e.v);
                    } else {
                        o.push(e);
                    }
                }
                return n;
            }
            if (Array.isArray(t)) {
                if (i) {
                    for (s = t.length; --s >= 0; ) if (e()) break;
                    o.reverse();
                    a.reverse();
                } else {
                    for (s = 0; s < t.length; ++s) if (e()) break;
                }
            } else {
                for (s in t) if (se(t, s)) if (e()) break;
            }
            return a.concat(o);
        }
        e.at_top = function(e) {
            return new u(e);
        };
        e.splice = function(e) {
            return new c(e);
        };
        e.last = function(e) {
            return new l(e);
        };
        var f = e.skip = {};
        function u(e) {
            this.v = e;
        }
        function c(e) {
            this.v = e;
        }
        function l(e) {
            this.v = e;
        }
        return e;
    }();
    function v(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function P(e, t) {
        return e.replace(/\{(.+?)\}/g, function(e, n) {
            return t && t[n];
        });
    }
    function I(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function ae(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function ye(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function xe() {
        this._values = Object.create(null);
        this._size = 0;
    }
    xe.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new xe();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    xe.fromObject = function(e) {
        var n = new xe();
        n._size = t(n._values, e);
        return n;
    };
    function se(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function we(e) {
        var n = e.parent(-1);
        for (var t = 0, r; r = e.parent(t++); n = r) {
            if (r.TYPE == "Call") {
                if (r.expression === n) continue;
            } else if (r instanceof yn) {
                if (r.left === n) continue;
            } else if (r instanceof xn) {
                if (r.condition === n) continue;
            } else if (r instanceof dn) {
                if (r.expression === n) continue;
            } else if (r instanceof hn) {
                if (r.expressions[0] === n) continue;
            } else if (r instanceof Ee) {
                return r.body === n;
            } else if (r instanceof bn) {
                if (r.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function r(e, n, t, r) {
        if (typeof r === "undefined") r = Ae;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = r && new r();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = r;
        }
        if (r) r.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (se(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof d !== "undefined") {
            d["AST_" + e] = s;
        }
        return s;
    }
    var Z = r("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var Ae = r("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new it(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        _walk: function(e) {
            return e._visit(this);
        },
        walk: function(e) {
            return this._walk(e);
        }
    }, null);
    (Ae.log_function = function(n, e) {
        var t = Object.create(null);
        if (n) {
            Ae.info = e ? function(e, n) {
                r("INFO: " + P(e, n));
            } : ie;
            Ae.warn = function(e, n) {
                r("WARN: " + P(e, n));
            };
        } else {
            Ae.info = Ae.warn = ie;
        }
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var Ee = r("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var ke = r("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Ee);
    var De = r("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        }
    }, Ee);
    var Fe = r("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
            });
        }
    }, Ee);
    function Ce(e, n) {
        e.body.forEach(function(e) {
            e._walk(n);
        });
    }
    var Be = r("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                Ce(this, e);
            });
        }
    }, Ee);
    var Se = r("BlockStatement", null, {
        $documentation: "A block statement"
    }, Be);
    var Te = r("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Ee);
    var _ = r("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        }
    }, Ee);
    var Oe = r("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.label._walk(e);
                this.body._walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Jn(function(e) {
                    if (e instanceof Xe && e.label && e.label.thedef === r) {
                        e.label.thedef = t;
                        t.references.push(e);
                    }
                }));
            }
            return n;
        }
    }, _);
    var ze = r("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, _);
    var $e = r("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        }
    }, ze);
    var Me = r("Do", null, {
        $documentation: "A `do` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
                this.condition._walk(e);
            });
        }
    }, $e);
    var qe = r("While", null, {
        $documentation: "A `while` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
            });
        }
    }, $e);
    var je = r("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                if (this.init) this.init._walk(e);
                if (this.condition) this.condition._walk(e);
                if (this.step) this.step._walk(e);
                this.body._walk(e);
            });
        }
    }, ze);
    var He = r("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.init._walk(e);
                this.object._walk(e);
                this.body._walk(e);
            });
        }
    }, ze);
    var Ne = r("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.body._walk(e);
            });
        }
    }, _);
    var Re = r("Scope", "variables functions uses_with uses_eval parent_scope enclosed cname", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            cname: "[integer/S] current index for mangling variables (used internally by the mangler)"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.variables) n.variables = this.variables.clone();
            if (this.functions) n.functions = this.functions.clone();
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            return n;
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        }
    }, Be);
    var Pe = r("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return rt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new it(function(e) {
                if (e instanceof De && e.value == "$ORIG") {
                    return be.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return rt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new it(function(e) {
                if (e instanceof De && e.value == "$ORIG") {
                    return be.splice(t);
                }
            }));
        }
    }, Re);
    var Ie = r("Lambda", "name argnames uses_arguments length_read", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[AST_SymbolFunarg*] array of function arguments",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                if (this.name) this.name._walk(n);
                this.argnames.forEach(function(e) {
                    e._walk(n);
                });
                Ce(this, n);
            });
        }
    }, Re);
    var Ue = r("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null."
    }, Ie);
    var Le = r("Function", "inlined", {
        $documentation: "A function expression"
    }, Ie);
    var Ye = r("Defun", "inlined", {
        $documentation: "A function definition"
    }, Ie);
    var Ve = r("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Ee);
    var We = r("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        _walk: function(e) {
            return e._visit(this, this.value && function() {
                this.value._walk(e);
            });
        }
    }, Ve);
    var Je = r("Return", null, {
        $documentation: "A `return` statement"
    }, We);
    var Ge = r("Throw", null, {
        $documentation: "A `throw` statement"
    }, We);
    var Xe = r("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        _walk: function(e) {
            return e._visit(this, this.label && function() {
                this.label._walk(e);
            });
        }
    }, Ve);
    var Ke = r("Break", null, {
        $documentation: "A `break` statement"
    }, Xe);
    var Qe = r("Continue", null, {
        $documentation: "A `continue` statement"
    }, Xe);
    var Ze = r("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
                if (this.alternative) this.alternative._walk(e);
            });
        }
    }, _);
    var en = r("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                Ce(this, e);
            });
        }
    }, Be);
    var nn = r("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, Be);
    var tn = r("Default", null, {
        $documentation: "A `default` switch branch"
    }, nn);
    var rn = r("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                Ce(this, e);
            });
        }
    }, nn);
    var on = r("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                Ce(this, e);
                if (this.bcatch) this.bcatch._walk(e);
                if (this.bfinally) this.bfinally._walk(e);
            });
        }
    }, Be);
    var an = r("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch] symbol for the exception"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.argname._walk(e);
                Ce(this, e);
            });
        }
    }, Be);
    var sn = r("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Be);
    var fn = r("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.definitions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    }, Ee);
    var un = r("Var", null, {
        $documentation: "A `var` statement"
    }, fn);
    var cn = r("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.name._walk(e);
                if (this.value) this.value._walk(e);
            });
        }
    });
    var ln = r("Call", "expression args", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expression._walk(n);
                this.args.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var pn = r("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, ln);
    var hn = r("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expressions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var dn = r("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof qn) {
                return e.value;
            }
            if (e instanceof gn && e.operator == "void" && e.expression instanceof qn) {
                return;
            }
            return e;
        }
    });
    var vn = r("Dot", null, {
        $documentation: "A dotted property access expression",
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    }, dn);
    var _n = r("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.property._walk(e);
            });
        }
    }, dn);
    var mn = r("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    });
    var gn = r("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, mn);
    var bn = r("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, mn);
    var yn = r("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.left._walk(e);
                this.right._walk(e);
            });
        }
    });
    var xn = r("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.consequent._walk(e);
                this.alternative._walk(e);
            });
        }
    });
    var wn = r("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`"
    }, yn);
    var An = r("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.elements.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var En = r("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.properties.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var kn = r("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_SymbolAccessor] property name. For ObjectKeyVal this is a string. For getters and setters this is an AST_SymbolAccessor.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.value._walk(e);
            });
        }
    });
    var Dn = r("ObjectKeyVal", "quote", {
        $documentation: "A key: value object property",
        $propdoc: {
            quote: "[string] the original quote character"
        }
    }, kn);
    var fe = r("ObjectSetter", null, {
        $documentation: "An object setter property"
    }, kn);
    var ue = r("ObjectGetter", null, {
        $documentation: "An object getter property"
    }, kn);
    var Fn = r("Symbol", "scope name thedef", {
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        $documentation: "Base class for all symbols"
    });
    var ce = r("SymbolAccessor", null, {
        $documentation: "The name of a property accessor (setter/getter function)"
    }, Fn);
    var Cn = r("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Fn);
    var Bn = r("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Cn);
    var Sn = r("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, Bn);
    var Tn = r("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Cn);
    var On = r("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Cn);
    var zn = r("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Cn);
    var le = r("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Fn);
    var $n = r("SymbolRef", "fixed", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Fn);
    var pe = r("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Fn);
    var Mn = r("This", null, {
        $documentation: "The `this` symbol"
    }, Fn);
    var qn = r("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var jn = r("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        }
    }, qn);
    var Hn = r("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        }
    }, qn);
    var Nn = r("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        }
    }, qn);
    var a = r("Atom", null, {
        $documentation: "Base class for atoms"
    }, qn);
    var Rn = r("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, a);
    var Pn = r("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, a);
    var In = r("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, a);
    var Un = r("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, a);
    var Ln = r("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, a);
    var Yn = r("Boolean", null, {
        $documentation: "Base class for booleans"
    }, a);
    var Vn = r("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Yn);
    var Wn = r("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Yn);
    function Jn(e) {
        this.visit = e;
        this.stack = [];
        this.directives = Object.create(null);
    }
    Jn.prototype = {
        _visit: function(e, n) {
            this.push(e);
            var t = this.visit(e, n ? function() {
                n.call(e);
            } : ie);
            if (!t && n) {
                n.call(e);
            }
            this.pop();
            return t;
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Ie) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof De && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof Ie) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Re) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof De)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof Oe && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof ze || e instanceof Ke && r instanceof en) return r;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof xn && t.condition === e || t instanceof $e && t.condition === e || t instanceof je && t.condition === e || t instanceof Ze && t.condition === e || t instanceof Je && t.in_bool || t instanceof hn && t.tail_node() !== e || t instanceof Fe || t instanceof gn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof yn && (t.operator == "&&" || t.operator == "||") || t instanceof xn || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof Je) {
                    var r;
                    do {
                        r = this.parent(++n);
                        if (!r) return false;
                    } while (!(r instanceof Ie));
                    if (r.name) return false;
                    e = this.parent(++n);
                    if (!e || e.TYPE != "Call" || e.expression !== r) return false;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var he = "break case catch const continue debugger default delete do else finally for function if in instanceof new return switch throw try typeof var void while with";
    var O = "false null true";
    var m = "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield" + " " + O + " " + he;
    var z = "return new delete throw else case";
    he = ae(he);
    m = ae(m);
    z = ae(z);
    O = ae(O);
    var $ = ae(e("+-*&%=<>!?|~^"));
    var i = /^0x[0-9a-f]+$/i;
    var M = /^0[0-7]+$/;
    var q = ae([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var j = ae(e("  \n\r\t\f\v​           \u2028\u2029  　\ufeff"));
    var H = ae(e("\n\r\u2028\u2029"));
    var U = ae(e("[{(,;:"));
    var L = ae(e("[]{}(),;:"));
    var s = {
        letter: new RegExp("[\\u0041-\\u005A\\u0061-\\u007A\\u00AA\\u00B5\\u00BA\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0370-\\u0374\\u0376\\u0377\\u037A-\\u037D\\u037F\\u0386\\u0388-\\u038A\\u038C\\u038E-\\u03A1\\u03A3-\\u03F5\\u03F7-\\u0481\\u048A-\\u052F\\u0531-\\u0556\\u0559\\u0561-\\u0587\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06E5\\u06E6\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u07F4\\u07F5\\u07FA\\u0800-\\u0815\\u081A\\u0824\\u0828\\u0840-\\u0858\\u08A0-\\u08B2\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0971-\\u0980\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E46\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EC6\\u0EDC-\\u0EDF\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10A0-\\u10C5\\u10C7\\u10CD\\u10D0-\\u10FA\\u10FC-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u16EE-\\u16F8\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17D7\\u17DC\\u1820-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191E\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1AA7\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BBA-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C7D\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u1CF5\\u1CF6\\u1D00-\\u1DBF\\u1E00-\\u1F15\\u1F18-\\u1F1D\\u1F20-\\u1F45\\u1F48-\\u1F4D\\u1F50-\\u1F57\\u1F59\\u1F5B\\u1F5D\\u1F5F-\\u1F7D\\u1F80-\\u1FB4\\u1FB6-\\u1FBC\\u1FBE\\u1FC2-\\u1FC4\\u1FC6-\\u1FCC\\u1FD0-\\u1FD3\\u1FD6-\\u1FDB\\u1FE0-\\u1FEC\\u1FF2-\\u1FF4\\u1FF6-\\u1FFC\\u2071\\u207F\\u2090-\\u209C\\u2102\\u2107\\u210A-\\u2113\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u212F-\\u2139\\u213C-\\u213F\\u2145-\\u2149\\u214E\\u2160-\\u2188\\u2C00-\\u2C2E\\u2C30-\\u2C5E\\u2C60-\\u2CE4\\u2CEB-\\u2CEE\\u2CF2\\u2CF3\\u2D00-\\u2D25\\u2D27\\u2D2D\\u2D30-\\u2D67\\u2D6F\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u2E2F\\u3005-\\u3007\\u3021-\\u3029\\u3031-\\u3035\\u3038-\\u303C\\u3041-\\u3096\\u309D-\\u309F\\u30A1-\\u30FA\\u30FC-\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400-\\u4DB5\\u4E00-\\u9FCC\\uA000-\\uA48C\\uA4D0-\\uA4FD\\uA500-\\uA60C\\uA610-\\uA61F\\uA62A\\uA62B\\uA640-\\uA66E\\uA67F-\\uA69D\\uA6A0-\\uA6EF\\uA717-\\uA71F\\uA722-\\uA788\\uA78B-\\uA78E\\uA790-\\uA7AD\\uA7B0\\uA7B1\\uA7F7-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uA9CF\\uA9E0-\\uA9E4\\uA9E6-\\uA9EF\\uA9FA-\\uA9FE\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA76\\uAA7A\\uAA7E-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB-\\uAADD\\uAAE0-\\uAAEA\\uAAF2-\\uAAF4\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uAB30-\\uAB5A\\uAB5C-\\uAB5F\\uAB64\\uAB65\\uABC0-\\uABE2\\uAC00-\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA6D\\uFA70-\\uFAD9\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF21-\\uFF3A\\uFF41-\\uFF5A\\uFF66-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC]"),
        digit: new RegExp("[\\u0030-\\u0039\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0DE6-\\u0DEF\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uA9F0-\\uA9F9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]"),
        non_spacing_mark: new RegExp("[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065E\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0900-\\u0902\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0955\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F90-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFD-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26]"),
        space_combining_mark: new RegExp("[\\u0903\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]"),
        connector_punctuation: new RegExp("[\\u005F\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]")
    };
    function f(e) {
        return e >= 97 && e <= 122 || e >= 65 && e <= 90 || e >= 170 && s.letter.test(String.fromCharCode(e));
    }
    function ee(e) {
        return e >= 55296 && e <= 56319;
    }
    function ne(e) {
        return e >= 56320 && e <= 57343;
    }
    function Y(e) {
        return e >= 48 && e <= 57;
    }
    function V(e) {
        return Y(e) || f(e);
    }
    function u(e) {
        return s.digit.test(String.fromCharCode(e));
    }
    function c(e) {
        return s.non_spacing_mark.test(e) || s.space_combining_mark.test(e);
    }
    function l(e) {
        return s.connector_punctuation.test(e);
    }
    function W(e) {
        return e == 36 || e == 95 || f(e);
    }
    function de(e) {
        var n = e.charCodeAt(0);
        return W(n) || Y(n) || n == 8204 || n == 8205 || c(e) || l(e) || u(n);
    }
    function Gn(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function J(e) {
        if (i.test(e)) {
            return parseInt(e.substr(2), 16);
        } else if (M.test(e)) {
            return parseInt(e.substr(1), 8);
        } else {
            var n = parseFloat(e);
            if (n == e) return n;
        }
    }
    function Xn(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    Xn.prototype = Object.create(Error.prototype);
    Xn.prototype.constructor = Xn;
    Xn.prototype.name = "SyntaxError";
    n(Xn);
    function ve(e, n, t, r, i) {
        throw new Xn(e, n, t, r, i);
    }
    function _e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var G = {};
    function Kn(i, o, a, s) {
        var f = {
            text: i,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw G;
            if (H[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function h(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function d() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (H[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw G;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function _(e, n, t) {
            f.regex_allowed = e == "operator" && !Zn[n] || e == "keyword" && z[n] || e == "punc" && U[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var r = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = i.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = f.comments_before;
                r.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Z(r);
        }
        function m() {
            while (j[c()]) l();
        }
        function t(e) {
            var n = "", t, r = 0;
            while ((t = c()) && e(t, r++)) n += l();
            return n;
        }
        function g(e) {
            ve(e, o, f.tokline, f.tokcol, f.tokpos);
        }
        function b(r) {
            var i = false, o = false, a = false, s = r == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : i ? false : i = o = true;

                  case 45:
                    return o || n == 0 && !r;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !i ? s = true : false;
                }
                return V(t);
            });
            if (r) e = r + e;
            if (M.test(e) && T.has_directive("use strict")) {
                g("Legacy octal literals are not allowed in strict mode");
            }
            var n = J(e);
            if (!isNaN(n)) return _("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(w(2));

              case 117:
                return String.fromCharCode(w(4));

              case 10:
                return "";

              case 13:
                if (c() == "\n") {
                    l(true, e);
                    return "";
                }
            }
            if (n >= "0" && n <= "7") return x(n);
            return n;
        }
        function x(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && T.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function w(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var A = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var r = l(true, true);
                if (r == "\\") r = y(true); else if (H[r]) g("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = _("string", t);
            i.quote = e;
            return i;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = d(), r;
            if (t == -1) {
                r = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                r = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(_(e, r, true));
            f.regex_allowed = n;
            return T;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = r("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(_("comment2", t, true));
            f.regex_allowed = e;
            return T;
        });
        function k() {
            var e = false, n = "", t, r = false, i;
            while ((t = c()) != null) {
                if (!e) {
                    if (t == "\\") r = e = true, l(); else if (de(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!de(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (he[n] && r) {
                i = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(i.length) + i + n.slice(1);
            }
            return n;
        }
        var D = n("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = l(true)) if (H[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = k();
            try {
                var o = new RegExp(e, i);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function F(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (q[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || l()));
        }
        function C() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? D("") : F("/");
        }
        function B() {
            l();
            return Y(c().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function S() {
            var e = k();
            if (u) return _("name", e);
            return O[e] ? _("atom", e) : !he[e] ? _("name", e) : q[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === G) g(n); else throw e;
                }
            };
        }
        function T(e) {
            if (e != null) return D(e);
            if (s && f.pos == 0 && h("#!")) {
                v();
                p(2);
                E("comment5");
            }
            for (;;) {
                m();
                v();
                if (a) {
                    if (h("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (h("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return A(n);

                  case 46:
                    return B();

                  case 47:
                    var r = C();
                    if (r === T) continue;
                    return r;
                }
                if (Y(t)) return b();
                if (L[n]) return _("punc", l());
                if ($[n]) return F();
                if (t == 92 || W(t)) return S();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        T.context = function(e) {
            if (e) f = e;
            return f;
        };
        T.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        T.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        T.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        T.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return T;
    }
    var Qn = ae("typeof void delete -- ++ ! ~ - +");
    var Zn = ae("-- ++");
    var et = ae("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var nt = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var tt = ae("atom num string regexp name");
    function rt(e, a) {
        a = re(a, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? Kn(e, a.filename, a.html5_comments, a.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = c();
        function u(e, n) {
            return _e(f.token, e, n);
        }
        function s() {
            return f.peeked || (f.peeked = f.input());
        }
        function c() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || u("punc", ";"));
            return f.token;
        }
        function l() {
            return f.prev;
        }
        function p(e, n, t, r) {
            var i = f.input.context();
            ve(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function t(e, n) {
            p(n, e.line, e.col);
        }
        function r(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function h(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + r(e.type, e.value));
        }
        function d(e, n) {
            if (u(e, n)) return c();
            t(f.token, "Unexpected token: " + r(f.token.type, f.token.value) + ", expected: " + r(e, n));
        }
        function v(e) {
            return d("punc", e);
        }
        function _(e) {
            return e.nlb || !ye(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function m() {
            return !a.strict && (u("eof") || u("punc", "}") || _(f.token));
        }
        function g(e) {
            if (u("punc", ";")) c(); else if (!e && !m()) d("punc", ";");
        }
        function b() {
            v("(");
            var e = ee(true);
            v(")");
            return e;
        }
        function n(r) {
            return function() {
                var e = f.token;
                var n = r.apply(null, arguments);
                var t = l();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function y() {
            if (u("operator", "/") || u("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var x = n(function(e) {
            y();
            switch (f.token.type) {
              case "string":
                var n = f.in_directives;
                var t = ee(true);
                if (n) {
                    if (t instanceof jn) {
                        var r = t.start.raw.slice(1, -1);
                        f.input.add_directive(r);
                        t.value = r;
                    } else {
                        f.in_directives = n = false;
                    }
                }
                g();
                return n ? new De(t) : new Fe({
                    body: t
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return A();

              case "name":
                return _e(s(), "punc", ":") ? w() : A();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new Se({
                        start: f.token,
                        body: C(),
                        end: l()
                    });

                  case "[":
                  case "(":
                    return A();

                  case ";":
                    f.in_directives = false;
                    c();
                    return new Te();

                  default:
                    h();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    c();
                    return E(Ke);

                  case "continue":
                    c();
                    return E(Qe);

                  case "debugger":
                    c();
                    g();
                    return new ke();

                  case "do":
                    c();
                    var t = ne(x);
                    d("keyword", "while");
                    var i = b();
                    g(true);
                    return new Me({
                        body: t,
                        condition: i
                    });

                  case "while":
                    c();
                    return new qe({
                        condition: b(),
                        body: ne(x)
                    });

                  case "for":
                    c();
                    return k();

                  case "function":
                    if (!e && f.input.has_directive("use strict")) {
                        p("In strict mode code, functions can only be declared at top level or immediately within another function.");
                    }
                    c();
                    return D(Ye);

                  case "if":
                    c();
                    return F();

                  case "return":
                    if (f.in_function == 0 && !a.bare_returns) p("'return' outside of function");
                    c();
                    var r = null;
                    if (u("punc", ";")) {
                        c();
                    } else if (!m()) {
                        r = ee(true);
                        g();
                    }
                    return new Je({
                        value: r
                    });

                  case "switch":
                    c();
                    return new en({
                        expression: b(),
                        body: ne(B)
                    });

                  case "throw":
                    c();
                    if (_(f.token)) p("Illegal newline after 'throw'");
                    var r = ee(true);
                    g();
                    return new Ge({
                        value: r
                    });

                  case "try":
                    c();
                    return S();

                  case "var":
                    c();
                    var o = O();
                    g();
                    return o;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        p("Strict mode may not include a with statement");
                    }
                    c();
                    return new Ne({
                        expression: b(),
                        body: x()
                    });
                }
            }
            h();
        });
        function w() {
            var n = L(le);
            if (!ye(f.labels, function(e) {
                return e.name != n.name;
            })) {
                p("Label " + n.name + " defined twice");
            }
            v(":");
            f.labels.push(n);
            var e = x();
            f.labels.pop();
            if (!(e instanceof ze)) {
                n.references.forEach(function(e) {
                    if (e instanceof Qe) {
                        e = e.label.start;
                        p("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new Oe({
                body: e,
                label: n
            });
        }
        function A() {
            var e = ee(true);
            g();
            return new Fe({
                body: e
            });
        }
        function E(e) {
            var n = null, t;
            if (!m()) {
                n = L(pe, true);
            }
            if (n != null) {
                t = te(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) p("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) p(e.TYPE + " not inside a loop or switch");
            g();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function k() {
            v("(");
            var e = null;
            if (!u("punc", ";")) {
                e = u("keyword", "var") ? (c(), O(true)) : ee(true, true);
                if (u("operator", "in")) {
                    if (e instanceof un) {
                        if (e.definitions.length > 1) p("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!Q(e)) {
                        p("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    c();
                    return o(e);
                }
            }
            return i(e);
        }
        function i(e) {
            v(";");
            var n = u("punc", ";") ? null : ee(true);
            v(";");
            var t = u("punc", ")") ? null : ee(true);
            v(")");
            return new je({
                init: e,
                condition: n,
                step: t,
                body: ne(x)
            });
        }
        function o(e) {
            var n = ee(true);
            v(")");
            return new He({
                init: e,
                object: n,
                body: ne(x)
            });
        }
        var D = function(e) {
            var n = e === Ye;
            var t = u("name") ? L(n ? Tn : On) : null;
            if (n && !t) d("name");
            if (t && e !== Ue && !(t instanceof Cn)) h(l());
            v("(");
            var r = [];
            for (var i = true; !u("punc", ")"); ) {
                if (i) i = false; else v(",");
                r.push(L(Sn));
            }
            c();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = C(true);
            if (f.input.has_directive("use strict")) {
                if (t) U(t);
                r.forEach(U);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: r,
                body: s
            });
        };
        function F() {
            var e = b(), n = x(), t = null;
            if (u("keyword", "else")) {
                c();
                t = x();
            }
            return new Ze({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function C(e) {
            v("{");
            var n = [];
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                n.push(x(e));
            }
            c();
            return n;
        }
        function B() {
            v("{");
            var e = [], n = null, t = null, r;
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                if (u("keyword", "case")) {
                    if (t) t.end = l();
                    n = [];
                    t = new rn({
                        start: (r = f.token, c(), r),
                        expression: ee(true),
                        body: n
                    });
                    e.push(t);
                    v(":");
                } else if (u("keyword", "default")) {
                    if (t) t.end = l();
                    n = [];
                    t = new tn({
                        start: (r = f.token, c(), v(":"), r),
                        body: n
                    });
                    e.push(t);
                } else {
                    if (!n) h();
                    n.push(x());
                }
            }
            if (t) t.end = l();
            c();
            return e;
        }
        function S() {
            var e = C(), n = null, t = null;
            if (u("keyword", "catch")) {
                var r = f.token;
                c();
                v("(");
                var i = L(zn);
                v(")");
                n = new an({
                    start: r,
                    argname: i,
                    body: C(),
                    end: l()
                });
            }
            if (u("keyword", "finally")) {
                var r = f.token;
                c();
                t = new sn({
                    start: r,
                    body: C(),
                    end: l()
                });
            }
            if (!n && !t) p("Missing catch/finally blocks");
            return new on({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function T(e) {
            var n = [];
            for (;;) {
                n.push(new cn({
                    start: f.token,
                    name: L(Bn),
                    value: u("operator", "=") ? (c(), ee(false, e)) : null,
                    end: l()
                }));
                if (!u("punc", ",")) break;
                c();
            }
            return n;
        }
        var O = function(e) {
            return new un({
                start: l(),
                definitions: T(e),
                end: l()
            });
        };
        var z = function(e) {
            var n = f.token;
            d("operator", "new");
            var t = M(false), r;
            if (u("punc", "(")) {
                c();
                r = q(")");
            } else {
                r = [];
            }
            var i = new pn({
                start: n,
                expression: t,
                args: r,
                end: l()
            });
            Y(i);
            return V(i, e);
        };
        function $() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = I($n);
                break;

              case "num":
                n = new Hn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new jn({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new Nn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new Vn({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new Wn({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new Rn({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            c();
            return n;
        }
        var M = function(e) {
            if (u("operator", "new")) {
                return z(e);
            }
            var n = f.token;
            if (u("punc")) {
                switch (n.value) {
                  case "(":
                    c();
                    var t = ee(true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    v(")");
                    var o = l();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after.length = 0;
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof ln) Y(t);
                    return V(t, e);

                  case "[":
                    return V(j(), e);

                  case "{":
                    return V(N(), e);
                }
                h();
            }
            if (u("keyword", "function")) {
                c();
                var a = D(Le);
                a.start = n;
                a.end = l();
                return V(a, e);
            }
            if (tt[f.token.type]) {
                return V($(), e);
            }
            h();
        };
        function q(e, n, t) {
            var r = true, i = [];
            while (!u("punc", e)) {
                if (r) r = false; else v(",");
                if (n && u("punc", e)) break;
                if (u("punc", ",") && t) {
                    i.push(new Un({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    i.push(ee(false));
                }
            }
            c();
            return i;
        }
        var j = n(function() {
            v("[");
            return new An({
                elements: q("]", !a.strict, true)
            });
        });
        var H = n(function() {
            return D(Ue);
        });
        var N = n(function() {
            v("{");
            var e = true, n = [];
            while (!u("punc", "}")) {
                if (e) e = false; else v(",");
                if (!a.strict && u("punc", "}")) break;
                var t = f.token;
                var r = t.type;
                var i = R();
                if (r == "name" && !u("punc", ":")) {
                    var o = new ce({
                        start: f.token,
                        name: "" + R(),
                        end: l()
                    });
                    if (i == "get") {
                        n.push(new ue({
                            start: t,
                            key: o,
                            value: H(),
                            end: l()
                        }));
                        continue;
                    }
                    if (i == "set") {
                        n.push(new fe({
                            start: t,
                            key: o,
                            value: H(),
                            end: l()
                        }));
                        continue;
                    }
                }
                v(":");
                n.push(new Dn({
                    start: t,
                    quote: t.quote,
                    key: "" + i,
                    value: ee(false),
                    end: l()
                }));
            }
            c();
            return new En({
                properties: n
            });
        });
        function R() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!he[e.value]) h();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                c();
                return e.value;

              default:
                h();
            }
        }
        function P() {
            if (!u("name")) d("name");
            var e = f.token.value;
            c();
            return e;
        }
        function I(e) {
            var n = f.token.value;
            return new (n == "this" ? Mn : e)({
                name: String(n),
                start: f.token,
                end: f.token
            });
        }
        function U(e) {
            if (e.name == "arguments" || e.name == "eval") p("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function L(e, n) {
            if (!u("name")) {
                if (!n) p("Name expected");
                return null;
            }
            var t = I(e);
            if (f.input.has_directive("use strict") && t instanceof Cn) {
                U(t);
            }
            c();
            return t;
        }
        function Y(e) {
            var n = e.start;
            var t = n.comments_before;
            var r = se(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--r >= 0) {
                var i = t[r];
                if (/[@#]__PURE__/.test(i.value)) {
                    e.pure = i;
                    break;
                }
            }
        }
        var V = function(e, n) {
            var t = e.start;
            if (u("punc", ".")) {
                c();
                return V(new vn({
                    start: t,
                    expression: e,
                    property: P(),
                    end: l()
                }), n);
            }
            if (u("punc", "[")) {
                c();
                var r = ee(true);
                v("]");
                return V(new _n({
                    start: t,
                    expression: e,
                    property: r,
                    end: l()
                }), n);
            }
            if (n && u("punc", "(")) {
                c();
                var i = new ln({
                    start: t,
                    expression: e,
                    args: q(")"),
                    end: l()
                });
                Y(i);
                return V(i, true);
            }
            return e;
        };
        var W = function(e) {
            var n = f.token;
            if (u("operator") && Qn[n.value]) {
                c();
                y();
                var t = J(gn, n, W(e));
                t.start = n;
                t.end = l();
                return t;
            }
            var r = M(e);
            while (u("operator") && Zn[f.token.value] && !_(f.token)) {
                r = J(bn, f.token, r);
                r.start = n;
                r.end = f.token;
                c();
            }
            return r;
        };
        function J(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!Q(t)) p("Invalid use of " + r + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof $n && f.input.has_directive("use strict")) p("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var G = function(e, n, t) {
            var r = u("operator") ? f.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? nt[r] : null;
            if (i != null && i > n) {
                c();
                var o = G(W(true), i, t);
                return G(new yn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function X(e) {
            return G(W(true), 0, e);
        }
        var K = function(e) {
            var n = f.token;
            var t = X(e);
            if (u("operator", "?")) {
                c();
                var r = ee(false);
                v(":");
                return new xn({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: ee(false, e),
                    end: l()
                });
            }
            return t;
        };
        function Q(e) {
            return e instanceof dn || e instanceof $n;
        }
        var Z = function(e) {
            var n = f.token;
            var t = K(e), r = f.token.value;
            if (u("operator") && et[r]) {
                if (Q(t)) {
                    c();
                    return new wn({
                        start: n,
                        left: t,
                        operator: r,
                        right: Z(e),
                        end: l()
                    });
                }
                p("Invalid assignment");
            }
            return t;
        };
        var ee = function(e, n) {
            var t = f.token;
            var r = [];
            while (true) {
                r.push(Z(n));
                if (!e || !u("punc", ",")) break;
                c();
                e = true;
            }
            return r.length == 1 ? r[0] : new hn({
                start: t,
                expressions: r,
                end: s()
            });
        };
        function ne(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (a.expression) {
            y();
            return ee(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!u("eof")) n.push(x(true));
            f.input.pop_directives_stack();
            var t = l();
            var r = a.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new Pe({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function it(e, n) {
        Jn.call(this);
        this.before = e;
        this.after = n;
    }
    it.prototype = new Jn();
    (function(e) {
        function t(e, n) {
            return be(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(Ae, ie);
        e(Oe, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Fe, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Be, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Me, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(qe, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(je, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(He, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Ne, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(We, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Xe, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(Ze, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(en, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(rn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(on, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(an, function(e, n) {
            e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(fn, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(cn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Ie, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(ln, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(hn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(vn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(_n, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(mn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(yn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(xn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(An, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(En, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(kn, function(e, n) {
            e.value = e.value.transform(n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function p(e, n, t) {
        this.name = n.name;
        this.orig = [ n ];
        this.init = t;
        this.eliminated = 0;
        this.scope = e;
        this.references = [];
        this.replaced = 0;
        this.global = false;
        this.mangled_name = null;
        this.undeclared = false;
        this.id = p.next_id++;
        this.lambda = n instanceof On;
    }
    p.next_id = 1;
    p.prototype = {
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof On || this.orig[0] instanceof Tn);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t;
                if (t = this.redefined()) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = g(this.scope, e, this);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            return this.defun && this.defun.variables.get(this.name);
        }
    };
    Pe.DEFMETHOD("figure_out_scope", function(a) {
        a = re(a, {
            cache: null,
            ie8: false
        });
        var s = this;
        var f = s.parent_scope = null;
        var u = null;
        var c = new Jn(function(e, n) {
            if (e instanceof an) {
                var t = f;
                f = new Re(e);
                f.init_scope_vars(t);
                n();
                f = t;
                return true;
            }
            if (e instanceof Re) {
                e.init_scope_vars(f);
                var t = f;
                var r = u;
                u = f = e;
                n();
                f = t;
                u = r;
                return true;
            }
            if (e instanceof Ne) {
                for (var i = f; i; i = i.parent_scope) i.uses_with = true;
                return;
            }
            if (e instanceof Fn) {
                e.scope = f;
            }
            if (e instanceof le) {
                e.thedef = e;
                e.references = [];
            }
            if (e instanceof Tn) {
                (e.scope = u.parent_scope.resolve()).def_function(e, u);
            } else if (e instanceof On) {
                var o = u.def_function(e, e.name == "arguments" ? undefined : u);
                if (a.ie8) o.defun = u.parent_scope.resolve();
            } else if (e instanceof Bn) {
                u.def_variable(e, e.TYPE == "SymbolVar" ? null : undefined);
                if (u !== f) {
                    e.mark_enclosed(a);
                    var o = f.find_variable(e);
                    if (e.thedef !== o) {
                        e.thedef = o;
                    }
                    e.reference(a);
                }
            } else if (e instanceof zn) {
                f.def_variable(e).defun = u;
            }
        });
        s.walk(c);
        s.globals = new xe();
        var c = new Jn(function(e) {
            if (e instanceof Xe) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof $n) {
                var n = e.name;
                var t = e.scope.find_variable(n);
                if (!t) {
                    t = s.def_global(e);
                } else if (t.scope instanceof Ie && n == "arguments") {
                    t.scope.uses_arguments = true;
                }
                if (n == "eval") {
                    var r = c.parent();
                    if (r.TYPE == "Call" && r.expression === e) {
                        for (var i = e.scope; i && !i.uses_eval; i = i.parent_scope) {
                            i.uses_eval = true;
                        }
                    } else if (t.undeclared) {
                        s.uses_eval = true;
                    }
                }
                e.thedef = t;
                e.reference(a);
                return true;
            }
            if (e instanceof zn) {
                var o = e.definition().redefined();
                if (o) for (var i = e.scope; i; i = i.parent_scope) {
                    v(i.enclosed, o);
                    if (i === o.scope) break;
                }
                return true;
            }
        });
        s.walk(c);
        if (a.ie8) s.walk(new Jn(function(e) {
            if (e instanceof zn) {
                var n = e.thedef.defun;
                if (n.name instanceof On && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                r(e, n);
                return true;
            }
            if (e instanceof On) {
                var t = e.thedef;
                r(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            var i = n.find_variable(t);
            if (i) {
                var o;
                while (o = i.redefined()) i = o;
            } else {
                i = s.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            r.orig.concat(r.references).forEach(function(e) {
                e.thedef = i;
                e.reference(a);
            });
            if (r.lambda) i.lambda = true;
            if (i.undeclared) s.variables.set(t, i);
        }
    });
    Pe.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = new p(this, e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    Re.DEFMETHOD("init_scope_vars", function(e) {
        this.variables = new xe();
        this.functions = new xe();
        this.uses_with = false;
        this.uses_eval = false;
        this.parent_scope = e;
        this.enclosed = [];
        this.cname = -1;
    });
    Ie.DEFMETHOD("init_scope_vars", function() {
        Re.prototype.init_scope_vars.apply(this, arguments);
        this.uses_arguments = false;
        this.def_variable(new Sn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
    });
    Fn.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            v(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    v(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Fn.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Re.DEFMETHOD("find_variable", function(e) {
        if (e instanceof Fn) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Re.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof Ye) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Re.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof Le) t.init = n;
        } else {
            t = new p(this, e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    Ie.DEFMETHOD("resolve", N);
    Re.DEFMETHOD("resolve", function() {
        return this.parent_scope.resolve();
    });
    Pe.DEFMETHOD("resolve", N);
    function h(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.names_in_use = t = Object.create(e.mangled_names || null);
            e.cname_holes = [];
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && r && r.has(e.name)) {
                    t[r.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function g(e, r, n) {
        var t = h(e, r);
        var i = e.cname_holes;
        var o = Object.create(null);
        var a = [ e ];
        n.references.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in h(n, r)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = y(i[f]);
            if (o[s]) continue;
            i.splice(f, 1);
            e.names_in_use[s] = true;
            return s;
        }
        while (true) {
            s = y(++e.cname);
            if (t[s] || m[s] || r.reserved.has[s]) continue;
            if (!o[s]) break;
            i.push(e.cname);
        }
        e.names_in_use[s] = true;
        return s;
    }
    Fn.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    le.DEFMETHOD("unmangleable", ge);
    Fn.DEFMETHOD("unreferenced", function() {
        return !this.definition().references.length && !this.scope.pinned();
    });
    Fn.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    Fn.DEFMETHOD("global", function() {
        return this.definition().global;
    });
    function b(e) {
        e = re(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        v(e.reserved, "arguments");
        e.reserved.has = ae(e.reserved);
        return e;
    }
    Pe.DEFMETHOD("mangle_names", function(s) {
        s = b(s);
        var f = -1;
        if (s.cache && s.cache.props) {
            var n = this.mangled_names = Object.create(null);
            s.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var i = [];
        var u = new Jn(function(e, n) {
            if (e instanceof Oe) {
                var t = f;
                n();
                f = t;
                return true;
            }
            if (e instanceof Re) {
                n();
                if (s.cache && e instanceof Pe) {
                    e.globals.each(c);
                }
                if (e instanceof Ye && u.has_directive("use asm")) {
                    var r = new $n(e.name);
                    r.scope = e;
                    r.reference(s);
                }
                e.variables.each(function(e) {
                    if (!l(e)) c(e);
                });
                return true;
            }
            if (e instanceof le) {
                var i;
                do {
                    i = y(++f);
                } while (m[i]);
                e.mangled_name = i;
                return true;
            }
            if (!s.ie8 && e instanceof an) {
                var o = e.argname.definition();
                var a = l(o, e.argname);
                n();
                if (!a) c(o);
                return true;
            }
        });
        this.walk(u);
        i.forEach(c);
        function c(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function l(n, e) {
            var t = n.redefined();
            if (!t) return false;
            i.push(n);
            n.references.forEach(r);
            if (e) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
    });
    Pe.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(null);
        t.reserved.forEach(i);
        this.globals.each(o);
        this.walk(new Jn(function(e) {
            if (e instanceof Re) e.variables.each(o);
            if (e instanceof zn) o(e.definition());
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    Pe.DEFMETHOD("expand_names", function(r) {
        y.reset();
        y.sort();
        r = b(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(o);
        this.walk(new Jn(function(e) {
            if (e instanceof Re) e.variables.each(o);
            if (e instanceof zn) o(e.definition());
        }));
        function i() {
            var e;
            do {
                e = y(t++);
            } while (n[e] || m[e]);
            return e;
        }
        function o(e) {
            if (e.global && r.cache) return;
            if (e.unmangleable(r)) return;
            if (r.reserved.has[e.name]) return;
            var n = e.redefined();
            var t = n ? n.rename || n.name : i();
            e.rename = t;
            e.orig.forEach(function(e) {
                e.name = t;
            });
            e.references.forEach(function(e) {
                e.name = t;
            });
        }
    });
    Ae.DEFMETHOD("tail_node", N);
    hn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Pe.DEFMETHOD("compute_char_frequency", function(t) {
        t = b(t);
        y.reset();
        try {
            Ae.prototype.print = function(e, n) {
                this._print(e, n);
                if (this instanceof Fn && !this.unmangleable(t)) {
                    y.consider(this.name, -1);
                } else if (t.properties) {
                    if (this instanceof vn) {
                        y.consider(this.property, -1);
                    } else if (this instanceof _n) {
                        r(this.property);
                    }
                }
            };
            y.consider(this.print_to_string(), 1);
        } finally {
            Ae.prototype.print = Ae.prototype._print;
        }
        y.sort();
        function r(e) {
            if (e instanceof jn) {
                y.consider(e.value, -1);
            } else if (e instanceof xn) {
                r(e.consequent);
                r(e.alternative);
            } else if (e instanceof hn) {
                r(e.tail_node());
            }
        }
    });
    var y = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, o;
        function a() {
            o = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                o[e[t]] += n;
            }
        };
        function s(e, n) {
            return o[n] - o[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n.sort(s));
        };
        f.reset = a;
        a();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += r[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ot(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function at(f) {
        var e = !f;
        f = re(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = ge;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = ot;
            } else {
                u = oe;
            }
        }
        var i = 0;
        var o = 0;
        var a = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (ee(i)) {
                    if (ne(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ne(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function r(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return r > i ? n() : o();
            }
        }
        function p(e, n) {
            var t = r(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function h(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        function d(e) {
            return Q(" ", f.indent_start + i - e * f.indent_level);
        }
        var v = false;
        var _ = 0;
        var m = true;
        var g = false;
        var b = false;
        var y = false;
        var x = false;
        var w = -1;
        var A = "";
        var E, k, D = f.source_map && [];
        var F = D ? function(n, t) {
            D.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : ie;
        var C = D ? function() {
            D.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            D = [];
        } : ie;
        function B(e) {
            var n = s.lastIndexOf("\n");
            if (_ < n) _ = n;
            var t = s.slice(0, _);
            var r = s.slice(_);
            F(e, r.length - o);
            a += e;
            c += e;
            o = r.length;
            s = t;
            while (e--) s += "\n";
            s += r;
        }
        var S = f.max_line_len ? function() {
            if (m) {
                if (o > f.max_line_len) {
                    Ae.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (o > f.max_line_len) B(1);
            m = true;
            C();
        } : ie;
        var T = ae("( [ + * / - , .");
        function O(e) {
            e = String(e);
            var n = e.charAt(0);
            if (y && n) {
                y = false;
                if (n != "\n") {
                    O("\n");
                    $();
                }
            }
            if (x && n) {
                x = false;
                if (!/[\s;})]/.test(n)) {
                    z();
                }
            }
            w = -1;
            var t = A.slice(-1);
            if (b) {
                b = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || T[n]) {
                        s += ";";
                        o++;
                        c++;
                    } else {
                        S();
                        s += "\n";
                        c++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            b = true;
                        }
                    }
                    if (!f.beautify) g = false;
                }
            }
            if (g) {
                if (de(t) && (de(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == A || e == "--" && A == "!" || A == "--" && n == ">") {
                    s += " ";
                    o++;
                    c++;
                }
                if (t != "<" || e != "!") g = false;
            }
            if (E) {
                D.push({
                    token: E,
                    name: k,
                    line: a,
                    col: o
                });
                E = false;
                if (m) C();
            }
            s += e;
            v = e.slice(-1) == "(";
            c += e.length;
            var r = e.split(/\r?\n/), i = r.length - 1;
            a += i;
            o += r[0].length;
            if (i > 0) {
                S();
                o = r[i].length;
            }
            A = e;
        }
        var z = f.beautify ? function() {
            O(" ");
        } : function() {
            g = true;
        };
        var $ = f.beautify ? function(e) {
            if (f.beautify) {
                O(d(e ? .5 : 0));
            }
        } : ie;
        var M = f.beautify ? function(e, n) {
            if (e === true) e = R();
            var t = i;
            i = e;
            var r = n();
            i = t;
            return r;
        } : function(e, n) {
            return n();
        };
        var q = f.max_line_len || f.preserve_line ? function() {
            S();
            _ = s.length;
            m = false;
        } : ie;
        var j = f.beautify ? function() {
            if (w < 0) return O("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                a++;
            }
            w++;
        } : q;
        var H = f.beautify ? function() {
            O(";");
        } : function() {
            b = true;
        };
        function N() {
            if (b) O(";");
            O(";");
        }
        function R() {
            return i + f.indent_level;
        }
        function P(e) {
            var n;
            O("{");
            j();
            M(R(), function() {
                n = e();
            });
            $();
            O("}");
            return n;
        }
        function I(e) {
            O("(");
            q();
            var n = e();
            q();
            O(")");
            return n;
        }
        function U(e) {
            O("[");
            q();
            var n = e();
            q();
            O("]");
            return n;
        }
        function L() {
            q();
            O(",");
            q();
            z();
        }
        function Y() {
            O(":");
            z();
        }
        var V = D ? function(e, n) {
            E = e;
            k = n;
        } : ie;
        function W() {
            if (!m) S();
            return s;
        }
        function J() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function G(e) {
            var r = this;
            var i = e instanceof We && e.value;
            var o = s(e);
            if (!o) o = [];
            if (i) {
                var a = new Jn(function(e) {
                    var n = a.parent();
                    if (n instanceof We || n instanceof yn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof xn && n.condition === e || n instanceof vn && n.expression === e || n instanceof hn && n.expressions[0] === e || n instanceof _n && n.expression === e || n instanceof bn) {
                        var t = s(e);
                        if (t) o = o.concat(t);
                    } else {
                        return true;
                    }
                });
                a.push(e);
                e.value.walk(a);
            }
            if (c == 0) {
                if (o.length > 0 && f.shebang && o[0].type == "comment5") {
                    O("#!" + o.shift().value + "\n");
                    $();
                }
                var n = f.preamble;
                if (n) {
                    O(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            o = o.filter(u, e);
            if (o.length == 0) return;
            var t = J();
            o.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        O("\n");
                        $();
                        t = true;
                    } else if (n > 0) {
                        z();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    $();
                    t = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    O("\n");
                    $();
                } else {
                    z();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new Z();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function X(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof Ee || ye(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            var o = s.length;
            i.filter(u, e).forEach(function(e, n) {
                x = false;
                if (y) {
                    O("\n");
                    $();
                    y = false;
                } else if (e.nlb && (n > 0 || !J())) {
                    O("\n");
                    $();
                } else if (n > 0 || !t) {
                    z();
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    y = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    x = true;
                }
            });
            if (s.length > o) w = o;
        }
        var K = [];
        return {
            get: W,
            toString: W,
            indent: $,
            indentation: function() {
                return i;
            },
            current_width: function() {
                return o - i;
            },
            should_break: function() {
                return f.width && this.current_width() >= f.width;
            },
            has_parens: function() {
                return v;
            },
            newline: j,
            print: O,
            space: z,
            comma: L,
            colon: Y,
            last: function() {
                return A;
            },
            semicolon: H,
            force_semicolon: N,
            to_utf8: l,
            print_name: function(e) {
                O(h(e));
            },
            print_string: function(e, n) {
                O(p(e, n));
            },
            next_indent: R,
            with_indent: M,
            with_block: P,
            with_parens: I,
            with_square: U,
            add_mapping: V,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? ie : G,
            append_comments: e || u === ge ? ie : X,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                K.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = K.pop();
                if (e.start && e.start.line > a) {
                    B(e.start.line - a);
                }
            } : function() {
                K.pop();
            },
            parent: function(e) {
                return K[K.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        Ae.DEFMETHOD("print", function(e, n) {
            var t = this, r = t._codegen;
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                r(t, e);
                e.append_comments(t);
            }
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
        });
        Ae.DEFMETHOD("_print", Ae.prototype.print);
        Ae.DEFMETHOD("print_to_string", function(e) {
            var n = at(e);
            this.print(n);
            return n.get();
        });
        function t(e, n) {
            if (Array.isArray(e)) {
                e.forEach(function(e) {
                    t(e, n);
                });
            } else {
                e.DEFMETHOD("needs_parens", n);
            }
        }
        t(Ae, ge);
        t(Le, function(e) {
            if (!e.has_parens() && we(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof dn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof ln && n.expression === this) return true;
            }
        });
        t(En, function(e) {
            return !e.has_parens() && we(e);
        });
        t(mn, function(e) {
            var n = e.parent();
            return n instanceof dn && n.expression === this || n instanceof ln && n.expression === this;
        });
        t(hn, function(e) {
            var n = e.parent();
            return n instanceof ln || n instanceof mn || n instanceof yn || n instanceof cn || n instanceof dn && n.expression === this || n instanceof An || n instanceof kn || n instanceof xn;
        });
        t(yn, function(e) {
            var n = e.parent();
            if (n instanceof ln && n.expression === this) return true;
            if (n instanceof mn) return true;
            if (n instanceof dn && n.expression === this) return true;
            if (n instanceof yn) {
                var t = n.operator, r = nt[t];
                var i = this.operator, o = nt[i];
                if (r > o || r == o && this === n.right) {
                    return true;
                }
            }
        });
        t(dn, function(e) {
            var n = e.parent();
            if (n instanceof pn && n.expression === this) {
                var t = false;
                this.walk(new Jn(function(e) {
                    if (t || e instanceof Re) return true;
                    if (e instanceof ln) {
                        t = true;
                        return true;
                    }
                }));
                return t;
            }
        });
        t(ln, function(e) {
            var n = e.parent();
            if (n instanceof pn && n.expression === this) return true;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof Le && n instanceof dn && n.expression === this && t instanceof wn && t.left === n;
            }
        });
        t(pn, function(e) {
            var n = e.parent();
            if (!p(this, e) && (n instanceof dn || n instanceof ln && n.expression === this)) return true;
        });
        t(Hn, function(e) {
            var n = e.parent();
            if (n instanceof dn && n.expression === this) {
                var t = this.value;
                if (t < 0 || /^0/.test(d(t))) {
                    return true;
                }
            }
        });
        t([ wn, xn ], function(e) {
            var n = e.parent();
            if (n instanceof mn) return true;
            if (n instanceof yn && !(n instanceof wn)) return true;
            if (n instanceof ln && n.expression === this) return true;
            if (n instanceof xn && n.condition === this) return true;
            if (n instanceof dn && n.expression === this) return true;
        });
        e(De, function(e, n) {
            var t = e.quote;
            var r = e.value;
            switch (n.option("quote_style")) {
              case 0:
              case 2:
                if (r.indexOf('"') == -1) t = '"';
                break;

              case 1:
                if (r.indexOf("'") == -1) t = "'";
                break;
            }
            n.print(t + r + t);
            n.semicolon();
        });
        e(ke, function(e, n) {
            n.print("debugger");
            n.semicolon();
        });
        function r(e, t, r, n) {
            var i = e.length - 1;
            var o = n;
            var a = s;
            e.forEach(function(e, n) {
                if (o) {
                    if (e instanceof De) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Te)) {
                        if (e instanceof Fe && e.body instanceof jn) {
                            r.force_semicolon();
                        }
                        o = false;
                    }
                }
                if (e instanceof Te) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            s = a;
        }
        _.DEFMETHOD("_do_print_body", function(e) {
            l(this.body, e);
        });
        e(Ee, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        e(Pe, function(e, n) {
            r(e.body, true, n, true);
            n.print("");
        });
        e(Oe, function(e, n) {
            e.label.print(n);
            n.colon();
            e.body.print(n);
        });
        e(Fe, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        function i(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function o(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    r(e.body, false, n, t);
                });
            } else i(e, n);
        }
        e(Se, function(e, n) {
            o(e, n);
        });
        e(Te, function(e, n) {
            n.semicolon();
        });
        e(Me, function(e, n) {
            n.print("do");
            n.space();
            v(e.body, n);
            n.space();
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.semicolon();
        });
        e(qe, function(e, n) {
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(je, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                if (e.init) {
                    if (e.init instanceof fn) {
                        e.init.print(n);
                    } else {
                        u(e.init, n, true);
                    }
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.condition) {
                    e.condition.print(n);
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.step) {
                    e.step.print(n);
                }
            });
            n.space();
            e._do_print_body(n);
        });
        e(He, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                e.init.print(n);
                n.space();
                n.print("in");
                n.space();
                e.object.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Ne, function(e, n) {
            n.print("with");
            n.space();
            n.with_parens(function() {
                e.expression.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        Ie.DEFMETHOD("_do_print", function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            o(n, t, true);
        });
        e(Ie, function(e, n) {
            e._do_print(n);
        });
        function a(e, n, t) {
            e.print(n);
            if (t) {
                e.space();
                t.print(e);
            }
            e.semicolon();
        }
        e(Je, function(e, n) {
            a(n, "return", e.value);
        });
        e(Ge, function(e, n) {
            a(n, "throw", e.value);
        });
        e(Ke, function(e, n) {
            a(n, "break", e.label);
        });
        e(Qe, function(e, n) {
            a(n, "continue", e.label);
        });
        function f(e, n) {
            var t = e.body;
            if (n.option("braces") || n.option("ie8") && t instanceof Me) return v(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof Ze) {
                    if (!t.alternative) {
                        v(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof _) {
                    t = t.body;
                } else break;
            }
            l(e.body, n);
        }
        e(Ze, function(e, n) {
            n.print("if");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            if (e.alternative) {
                f(e, n);
                n.space();
                n.print("else");
                n.space();
                if (e.alternative instanceof Ze) e.alternative.print(n); else l(e.alternative, n);
            } else {
                e._do_print_body(n);
            }
        });
        e(en, function(e, t) {
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) i(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            });
        });
        nn.DEFMETHOD("_do_print_body", function(n) {
            n.newline();
            this.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        });
        e(tn, function(e, n) {
            n.print("default:");
            e._do_print_body(n);
        });
        e(rn, function(e, n) {
            n.print("case");
            n.space();
            e.expression.print(n);
            n.print(":");
            e._do_print_body(n);
        });
        e(on, function(e, n) {
            n.print("try");
            n.space();
            o(e, n);
            if (e.bcatch) {
                n.space();
                e.bcatch.print(n);
            }
            if (e.bfinally) {
                n.space();
                e.bfinally.print(n);
            }
        });
        e(an, function(e, n) {
            n.print("catch");
            n.space();
            n.with_parens(function() {
                e.argname.print(n);
            });
            n.space();
            o(e, n);
        });
        e(sn, function(e, n) {
            n.print("finally");
            n.space();
            o(e, n);
        });
        e(un, function(e, t) {
            t.print("var");
            t.space();
            e.definitions.forEach(function(e, n) {
                if (n) t.comma();
                e.print(t);
            });
            var n = t.parent();
            if (n && n.init !== e || !(n instanceof je || n instanceof He)) t.semicolon();
        });
        function u(e, n, t) {
            var r = false;
            if (t) e.walk(new Jn(function(e) {
                if (r || e instanceof Re) return true;
                if (e instanceof yn && e.operator == "in") {
                    r = true;
                    return true;
                }
            }));
            e.print(n, r);
        }
        e(cn, function(e, n) {
            e.name.print(n);
            if (e.value) {
                n.space();
                n.print("=");
                n.space();
                var t = n.parent(1);
                var r = t instanceof je || t instanceof He;
                u(e.value, n, r);
            }
        });
        e(ln, function(e, t) {
            e.expression.print(t);
            if (e instanceof pn && !p(e, t)) return;
            if (e.expression instanceof ln || e.expression instanceof Ie) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        });
        e(pn, function(e, n) {
            n.print("new");
            n.space();
            ln.prototype._codegen(e, n);
        });
        e(hn, function(e, t) {
            e.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(vn, function(e, n) {
            var t = e.expression;
            t.print(n);
            var r = e.property;
            if (n.option("ie8") && m[r]) {
                n.print("[");
                n.add_mapping(e.end);
                n.print_string(r);
                n.print("]");
            } else {
                if (t instanceof Hn && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(n.last())) {
                        n.print(".");
                    }
                }
                n.print(".");
                n.add_mapping(e.end);
                n.print_name(r);
            }
        });
        e(_n, function(e, n) {
            e.expression.print(n);
            n.print("[");
            e.property.print(n);
            n.print("]");
        });
        e(gn, function(e, n) {
            var t = e.operator;
            n.print(t);
            if (/^[a-z]/i.test(t) || /[+-]$/.test(t) && e.expression instanceof gn && /^[+-]/.test(e.expression.operator)) {
                n.space();
            }
            e.expression.print(n);
        });
        e(bn, function(e, n) {
            e.expression.print(n);
            n.print(e.operator);
        });
        e(yn, function(e, n) {
            e.left.print(n);
            n.space();
            n.print(e.operator);
            n.space();
            e.right.print(n);
        });
        e(xn, function(e, n) {
            e.condition.print(n);
            n.space();
            n.print("?");
            n.space();
            e.consequent.print(n);
            n.space();
            n.colon();
            e.alternative.print(n);
        });
        e(An, function(n, r) {
            r.with_square(function() {
                var e = n.elements, t = e.length;
                if (t > 0) r.space();
                e.forEach(function(e, n) {
                    if (n) r.comma();
                    e.print(r);
                    if (n === t - 1 && e instanceof Un) r.comma();
                });
                if (t > 0) r.space();
            });
        });
        e(En, function(e, t) {
            if (e.properties.length > 0) t.with_block(function() {
                e.properties.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else i(e, t);
        });
        function c(e, n, t) {
            if (t.option("quote_keys")) {
                t.print_string(e);
            } else if ("" + +e == e && e >= 0) {
                t.print(d(e));
            } else if (m[e] ? !t.option("ie8") : Gn(e)) {
                if (n && t.option("keep_quoted_props")) {
                    t.print_string(e, n);
                } else {
                    t.print_name(e);
                }
            } else {
                t.print_string(e, n);
            }
        }
        e(Dn, function(e, n) {
            c(e.key, e.quote, n);
            n.colon();
            e.value.print(n);
        });
        kn.DEFMETHOD("_print_getter_setter", function(e, n) {
            n.print(e);
            n.space();
            c(this.key.name, this.quote, n);
            this.value._do_print(n, true);
        });
        e(fe, function(e, n) {
            e._print_getter_setter("set", n);
        });
        e(ue, function(e, n) {
            e._print_getter_setter("get", n);
        });
        e(Fn, function(e, n) {
            var t = e.definition();
            n.print_name(t && t.mangled_name || e.name);
        });
        e(Un, ie);
        e(Mn, function(e, n) {
            n.print("this");
        });
        e(qn, function(e, n) {
            n.print(e.value);
        });
        e(jn, function(e, n) {
            n.print_string(e.value, e.quote);
        });
        e(Hn, function(e, n) {
            if (s && e.start && e.start.raw != null) {
                n.print(e.start.raw);
            } else {
                n.print(d(e.value));
            }
        });
        e(Nn, function(e, n) {
            var t = e.value;
            var r = t.toString();
            var i = r.lastIndexOf("/");
            if (t.raw_source) {
                r = "/" + t.raw_source + r.slice(i);
            } else if (i == 1) {
                r = "/(?:)" + r.slice(i);
            } else if (r.indexOf("/", 1) < i) {
                r = "/" + r.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + r.slice(i);
            }
            n.print(n.to_utf8(r).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var o = n.parent();
            if (o instanceof yn && /^in/.test(o.operator) && o.left === e) n.print(" ");
        });
        function l(e, n) {
            if (n.option("braces")) {
                v(e, n);
            } else {
                if (!e || e instanceof Te) n.force_semicolon(); else e.print(n);
            }
        }
        function p(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function h(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function d(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, o;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                o = n.slice(i);
                t.push(o + "e-" + (o.length + i - 1));
            } else if (r = /0+$/.exec(n)) {
                i = r[0].length;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return h(t);
        }
        function v(e, n) {
            if (!e || e instanceof Te) n.print("{}"); else if (e instanceof Se) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function n(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        n([ Ae, Oe, Pe ], ie);
        n([ An, Se, an, qn, ke, fn, De, sn, Ve, Ie, pn, En, _, Fn, en, nn, on ], function(e) {
            e.add_mapping(this.start);
        });
        n([ ue, fe ], function(e) {
            e.add_mapping(this.start, this.key.name);
        });
        n([ kn ], function(e) {
            e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function st(e, n) {
        if (!(this instanceof st)) return new st(e, n);
        it.call(this, this.before, this.after);
        this.options = re(e, {
            arguments: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && se(r, i)) {
                r[i.slice(1)] = rt(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var o = this.options["keep_fargs"];
        this.drop_fargs = o == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        } : o ? ge : oe;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !me(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = oe;
        }
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        var f = this.options["top_retain"];
        if (f instanceof RegExp) {
            this.top_retain = function(e) {
                return f.test(e.name);
            };
        } else if (typeof f == "function") {
            this.top_retain = f;
        } else if (f) {
            if (typeof f == "string") {
                f = f.split(/,/);
            }
            this.top_retain = function(e) {
                return me(e.name, f);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    st.prototype = new it();
    t(st.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.global) for (var n = 0; n < e.orig.length; n++) if (!this.toplevel[e.orig[n] instanceof Tn ? "funcs" : "vars"]) return true;
            return false;
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var r = false;
            var i = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(i);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new Jn(function() {
                        a++;
                    }));
                    Ae.info("pass " + o + ": last_count: " + t + ", count: " + a);
                    if (a < t) {
                        t = a;
                        r = false;
                    } else if (r) {
                        break;
                    } else {
                        r = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var r = e instanceof Re;
            if (r) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var i = e.optimize(this);
            if (r) {
                i.drop_unused(this);
                n(i, this);
            }
            if (i === e) i._squeezed = true;
            return i;
        }
    });
    (function(e) {
        e(Ae, function(e, n) {
            return e;
        });
        Ae.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Re.DEFMETHOD("process_expression", function(t, r) {
            var i = this;
            var o = new it(function(e) {
                if (t && e instanceof Fe) {
                    return le(Je, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof Je) {
                    return r ? r(e) : le(Fe, e, {
                        body: e.value || le(gn, e, {
                            operator: "void",
                            expression: le(Hn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Ie && e !== i) {
                    return e;
                }
                if (e instanceof Be) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(o);
                    }
                } else if (e instanceof Ze) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Ne) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            i.transform(o);
        });
        function b(e, n) {
            var t = n.getProperty();
            if (t instanceof Ae) return;
            var r;
            if (e instanceof An) {
                var i = e.elements;
                if (t == "length") return A(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof Ie) {
                if (t == "length") {
                    e.length_read = true;
                    return A(e.argnames.length, e);
                }
            } else if (e instanceof En) {
                t = "" + t;
                var o = e.properties;
                for (var a = o.length; --a >= 0; ) {
                    var s = o[a];
                    if (!(s instanceof Dn)) return;
                    if (!r && o[a].key === t) r = o[a].value;
                }
            }
            return r instanceof $n && r.fixed_value() || r;
        }
        function l(e, n) {
            if (e instanceof Yn) return v.Boolean[n];
            if (e instanceof Hn) return v.Number[n];
            if (e instanceof jn) return v.String[n];
            if (n == "valueOf") return false;
            if (e instanceof An) return v.Array[n];
            if (e instanceof Le) return v.Function[n];
            if (e instanceof En) return v.Object[n];
            if (e instanceof Nn) return v.RegExp[n] && !e.value.global;
        }
        function fe(e, n, t, r, i, o, a) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof vn && l(r, s.property)) {
                return;
            }
            var f = _e(t, s);
            if (f) return f;
            if (!o && s instanceof ln && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof Le) || !(s instanceof pn) && r.contains_this())) {
                return true;
            }
            if (s instanceof An) {
                return fe(e, n, s, s, i + 1);
            }
            if (s instanceof Dn && t === s.value) {
                var u = n.parent(i + 1);
                return fe(e, n, u, u, i + 2);
            }
            if (s instanceof dn && s.expression === t) {
                var c = b(r, s);
                return (!o || a) && fe(e, n, s, c, i + 1);
            }
        }
        function ue(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof Sn;
        }
        (function(e) {
            e(Ae, ie);
            function r(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.chained = false;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof Le && t.init !== t.scope) && t.init;
                if (t.fixed instanceof Ye && !ye(t.references, function(e) {
                    var n = e.scope;
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof Le && (n = n.parent_scope));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    r(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        p(n, e, true);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        p(n, e, true);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = ie;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof Ye && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
            }
            function f(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var r = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!r) return t.fixed;
                    } else if (r) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!h(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function u(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof Ye && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function c(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function l(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function p(e, n, t) {
                e.safe_ids[n.id] = t;
            }
            function h(e, n) {
                if (n.single_use == "m") return false;
                if (e.safe_ids[n.id]) {
                    if (n.fixed == null) {
                        if (ue(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        n.fixed = le(In, n.orig[0]);
                    }
                    return true;
                }
                return n.fixed instanceof Ye;
            }
            function d(e, n, t, r) {
                if (n.fixed === undefined) return true;
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (!se(e.safe_ids, n.id)) return false;
                if (!h(e, n)) return false;
                if (n.fixed === false) return false;
                if (n.fixed != null && (!r || n.references.length > n.assignments)) return false;
                if (n.fixed instanceof Ye) {
                    return r instanceof Ae && n.fixed.parent_scope === t;
                }
                return ye(n.orig, function(e) {
                    return !(e instanceof Tn || e instanceof On);
                });
            }
            function v(e, n, t) {
                return n.option("unused") && !t.scope.pinned() && t.references.length - t.recursive_refs == 1 && e.loop_ids[t.id] === e.in_loop;
            }
            function _(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof Ie || e instanceof Mn;
            }
            function m(e, n, t, r, i, o, a) {
                var s = e.parent(o);
                if (i && i.is_constant()) return;
                if (s instanceof wn && s.operator == "=" && r === s.right || s instanceof ln && (r !== s.expression || s instanceof pn) || s instanceof We && r === s.value && r.scope !== n.scope || s instanceof cn && r === s.value) {
                    n.escaped.push(s);
                    if (a > 1 && !(i && i.is_constant_expression(t))) a = 1;
                    if (!n.escaped.depth || n.escaped.depth > a) n.escaped.depth = a;
                    return;
                } else if (s instanceof An || s instanceof yn && de[s.operator] || s instanceof xn && r !== s.condition || s instanceof hn && r === s.tail_node()) {
                    m(e, n, t, s, s, o + 1, a);
                } else if (s instanceof Dn && r === s.value) {
                    var f = e.parent(o + 1);
                    m(e, n, t, f, f, o + 2, a);
                } else if (s instanceof dn && r === s.expression) {
                    i = b(i, s);
                    m(e, n, t, s, i, o + 1, a + 1);
                    if (i) return;
                }
                if (o > 0) return;
                if (s instanceof ln && r === s.expression) return;
                if (s instanceof hn && r !== s.tail_node()) return;
                if (s instanceof Fe) return;
                if (s instanceof mn && !y[s.operator]) return;
                n.direct_access = true;
            }
            function g(e) {
                if (!(e instanceof _n)) return;
                var n = e.expression;
                if (!(n instanceof $n)) return;
                var t = n.definition();
                if (ue(t) && e.property instanceof Hn) t.reassigned = true;
            }
            var t = new Jn(function(e) {
                if (!(e instanceof Fn)) return;
                var n = e.definition();
                if (!n) return;
                if (e instanceof $n) n.references.push(e);
                n.fixed = false;
            });
            e(Ue, function(e, n, t) {
                c(e);
                s(e, t, this);
                n();
                l(e);
                u(e, this);
                return true;
            });
            e(wn, function(e, n, t) {
                var r = this;
                var i = r.left;
                if (!(i instanceof $n)) {
                    g(i);
                    return;
                }
                if (i.fixed) delete i.fixed;
                var o = i.definition();
                var a = d(e, o, i.scope, r.right);
                o.assignments++;
                var s = o.fixed;
                if (!s && r.operator != "=") return;
                var f = r.operator == "=";
                var u = f ? r.right : r;
                if (fe(t, e, r, u, 0)) return;
                if (!f) o.chained = true;
                i.fixed = o.fixed = f ? function() {
                    return r.right;
                } : function() {
                    return le(yn, r, {
                        operator: r.operator.slice(0, -1),
                        left: s instanceof Ae ? s : s(),
                        right: r.right
                    });
                };
                if (!a) return;
                o.references.push(i);
                p(e, o, false);
                r.right.walk(e);
                p(e, o, true);
                if (f) m(e, o, i.scope, r, u, 0, 1);
                return true;
            });
            e(yn, function(e) {
                if (!de[this.operator]) return;
                this.left.walk(e);
                c(e);
                this.right.walk(e);
                l(e);
                return true;
            });
            e(ln, function(e, n) {
                e.find_parent(Re).may_call_this();
                var t = this.expression;
                if (t instanceof $n) {
                    var r = t.definition();
                    if (this.TYPE == "Call" && e.in_boolean_context()) r.bool_fn++;
                    if (!(r.fixed instanceof Ye)) return;
                    var i = f(e, r);
                    if (!i) return;
                    n();
                    i.walk(e);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof wn && t.operator == "=" && t.left instanceof $n && e.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(rn, function(e) {
                c(e);
                this.expression.walk(e);
                l(e);
                c(e);
                Ce(this, e);
                l(e);
                return true;
            });
            e(xn, function(e) {
                this.condition.walk(e);
                c(e);
                this.consequent.walk(e);
                l(e);
                c(e);
                this.alternative.walk(e);
                l(e);
                return true;
            });
            e(tn, function(e, n) {
                c(e);
                n();
                l(e);
                return true;
            });
            e(Ye, function(e, n, t) {
                var r = this.name.definition().id;
                if (e.defun_visited[r]) return true;
                if (e.defun_ids[r] !== e.safe_ids) return true;
                e.defun_visited[r] = true;
                this.inlined = false;
                c(e);
                s(e, t, this);
                n();
                l(e);
                u(e, this);
                return true;
            });
            e(Me, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                c(e);
                this.body.walk(e);
                if (w(this, e.parent())) {
                    l(e);
                    c(e);
                }
                this.condition.walk(e);
                l(e);
                e.in_loop = n;
                return true;
            });
            e(je, function(e) {
                if (this.init) this.init.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                c(e);
                if (this.condition) this.condition.walk(e);
                this.body.walk(e);
                if (this.step) {
                    if (w(this, e.parent())) {
                        l(e);
                        c(e);
                    }
                    this.step.walk(e);
                }
                l(e);
                e.in_loop = n;
                return true;
            });
            e(He, function(e) {
                this.init.walk(t);
                this.object.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                c(e);
                this.body.walk(e);
                l(e);
                e.in_loop = n;
                return true;
            });
            e(Le, function(i, e, n) {
                var o = this;
                o.inlined = false;
                c(i);
                s(i, n, o);
                var a;
                if (!o.name && (a = i.parent()) instanceof ln && a.expression === o) {
                    o.argnames.forEach(function(n, e) {
                        var t = n.definition();
                        if (t.fixed === undefined && (!o.uses_arguments || i.has_directive("use strict"))) {
                            var r = a.args[e];
                            t.fixed = function() {
                                var e = o.argnames.indexOf(n);
                                if (e < 0) return r;
                                return a.args[e] || le(In, a);
                            };
                            i.loop_ids[t.id] = i.in_loop;
                            p(i, t, true);
                        } else {
                            t.fixed = false;
                        }
                    });
                }
                e();
                l(i);
                u(i, o);
                return true;
            });
            e(Ze, function(e) {
                this.condition.walk(e);
                c(e);
                this.body.walk(e);
                l(e);
                if (this.alternative) {
                    c(e);
                    this.alternative.walk(e);
                    l(e);
                }
                return true;
            });
            e(Oe, function(e) {
                c(e);
                this.body.walk(e);
                l(e);
                return true;
            });
            e(zn, function() {
                this.definition().fixed = false;
            });
            e($n, function(e, n, t) {
                if (this.fixed) delete this.fixed;
                var r = this.definition();
                r.references.push(this);
                if (r.references.length == 1 && !r.fixed && r.orig[0] instanceof Tn) {
                    e.loop_ids[r.id] = e.in_loop;
                }
                var i;
                if (r.fixed === undefined || !h(e, r)) {
                    r.fixed = false;
                } else if (r.fixed) {
                    i = this.fixed_value();
                    var o = ee(e, r);
                    if (o) {
                        r.recursive_refs++;
                    } else if (i && v(e, t, r)) {
                        r.single_use = i instanceof Ie && !i.pinned() || r.scope === this.scope && i.is_constant_expression();
                    } else {
                        r.single_use = false;
                    }
                    if (fe(t, e, this, i, 0, _(i), o)) {
                        if (r.single_use) {
                            r.single_use = "m";
                        } else {
                            r.fixed = false;
                        }
                    }
                    if (r.fixed && e.loop_ids[r.id] !== e.in_loop) {
                        r.cross_loop = true;
                    }
                    m(e, r, this.scope, this, i, 0, 1);
                }
                var a;
                if (r.fixed instanceof Ye && !((a = e.parent()) instanceof ln && a.expression === this)) {
                    var s = f(e, r);
                    if (s) s.walk(e);
                }
            });
            e(Pe, function(n, e, t) {
                this.globals.each(function(e) {
                    r(n, t, e);
                });
                c(n);
                s(n, t, this);
                e();
                l(n);
                u(n, this);
                return true;
            });
            e(on, function(e) {
                c(e);
                Ce(this, e);
                l(e);
                if (this.bcatch) {
                    c(e);
                    this.bcatch.walk(e);
                    l(e);
                }
                if (this.bfinally) this.bfinally.walk(e);
                return true;
            });
            e(mn, function(e, n) {
                var t = this;
                if (!ve[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof $n)) {
                    g(r);
                    return;
                }
                if (r.fixed) delete r.fixed;
                var i = r.definition();
                var o = d(e, i, r.scope, true);
                i.assignments++;
                var a = i.fixed;
                if (!a) return;
                i.chained = true;
                r.fixed = i.fixed = function() {
                    return le(yn, t, {
                        operator: t.operator.slice(0, -1),
                        left: le(gn, t, {
                            operator: "+",
                            expression: a instanceof Ae ? a : a()
                        }),
                        right: le(Hn, t, {
                            value: 1
                        })
                    });
                };
                if (!o) return;
                i.references.push(r);
                p(e, i, true);
                return true;
            });
            e(cn, function(e, n) {
                var t = this;
                var r = t.name.definition();
                if (t.value) {
                    if (d(e, r, t.name.scope, t.value)) {
                        r.fixed = function() {
                            return t.value;
                        };
                        e.loop_ids[r.id] = e.in_loop;
                        p(e, r, false);
                        n();
                        p(e, r, true);
                        return true;
                    } else {
                        r.fixed = false;
                    }
                }
            });
            e(qe, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                c(e);
                n();
                l(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        Pe.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Jn(t.option("reduce_vars") ? function(e, n) {
                i(e);
                return e.reduce_vars(r, n, t);
            } : i);
            r.defun_ids = Object.create(null);
            r.defun_visited = Object.create(null);
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            this.walk(r);
            function i(e) {
                e._squeezed = false;
                e._optimized = false;
                if (e instanceof Re) delete e._var_names;
            }
        });
        Fn.DEFMETHOD("fixed_value", function(e) {
            var n = this.definition().fixed;
            if (!n) return n;
            if (!e && this.fixed) n = this.fixed;
            return n instanceof Ae ? n : n();
        });
        $n.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof On && e.scope.name === n;
        });
        function ce(e, n) {
            if (e instanceof Mn) return true;
            if (e instanceof $n) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && J[t.name];
            }
            if (e instanceof dn) {
                e = e.expression;
                if (e instanceof $n) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return ce(e, n);
            }
            return false;
        }
        function o(e, n) {
            var t, r = 0;
            while (t = e.parent(r++)) {
                if (t instanceof Re) break;
                if (t instanceof an) {
                    t = t.argname.definition().scope;
                    break;
                }
            }
            return t.find_variable(n);
        }
        function le(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function U(e, n) {
            if (n.length == 1) return n[0];
            return le(hn, e, {
                expressions: n.reduce(d, [])
            });
        }
        function A(e, n) {
            switch (typeof e) {
              case "string":
                return le(jn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return le(Pn, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? le(gn, n, {
                        operator: "-",
                        expression: le(Hn, n, {
                            value: -e
                        })
                    }) : le(Hn, n, {
                        value: e
                    });
                }
                return e < 0 ? le(gn, n, {
                    operator: "-",
                    expression: le(Ln, n)
                }) : le(Ln, n);

              case "boolean":
                return le(e ? Wn : Vn, n);

              case "undefined":
                return le(In, n);

              default:
                if (e === null) {
                    return le(Rn, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return le(Nn, n, {
                        value: e
                    });
                }
                throw new Error(P("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function L(e, n) {
            return n instanceof dn || W(n) && n.name == "eval";
        }
        function pe(e, n, t, r) {
            if (n instanceof gn && n.operator == "delete" || n.TYPE == "Call" && n.expression === t && L(e, r)) {
                return U(t, [ le(Hn, t, {
                    value: 0
                }), r ]);
            }
            return r;
        }
        function d(e, n) {
            if (n instanceof hn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function E(e) {
            if (e === null) return [];
            if (e instanceof Se) return e.body;
            if (e instanceof Te) return [];
            if (e instanceof Ee) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function Y(e) {
            if (e === null) return true;
            if (e instanceof Te) return true;
            if (e instanceof Se) return e.body.length == 0;
            return false;
        }
        function k(e) {
            if (e instanceof ze) {
                return e.body instanceof Se ? e.body : e;
            }
            return e;
        }
        function he(e) {
            while (e instanceof dn) e = e.expression;
            return e;
        }
        function V(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof Le || V(e.expression);
        }
        function W(e) {
            return e instanceof $n && e.definition().undeclared;
        }
        var n = ae("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        $n.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && n[this.name];
        });
        var J = ae("Infinity NaN undefined");
        function i(e) {
            return e instanceof Ln || e instanceof Pn || e instanceof In;
        }
        function r(e, f) {
            var ie, oe, ae;
            t();
            var se, n = 10;
            do {
                se = false;
                i(e);
                if (f.option("dead_code")) {
                    a(e, f);
                }
                if (f.option("if_return")) {
                    o(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    h(e);
                }
                if (f.option("collapse_vars")) {
                    r(e, f);
                }
            } while (se && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof an || e instanceof sn) {
                        n++;
                    } else if (e instanceof ze) {
                        ie = true;
                    } else if (e instanceof Re) {
                        ae = e;
                        break;
                    } else if (e instanceof on) {
                        oe = e;
                    }
                } while (e = f.parent(n++));
            }
            function r(t, c) {
                if (ae.pinned()) return t;
                var f;
                var u = [];
                var o = t.length;
                var l = new it(function(e, n) {
                    if (F) return e;
                    if (!D) {
                        if (e !== a[s]) return e;
                        s++;
                        if (s < a.length) return z(e);
                        D = true;
                        d = (h ? R : N)(e, 0);
                        if (d === e) F = true;
                        return e;
                    }
                    var t = l.parent();
                    if ($(e, t)) {
                        F = true;
                        return e;
                    }
                    if (!v && M(e, t)) {
                        v = t;
                    }
                    if (e.single_use && t instanceof cn && t.value === e) return e;
                    var r;
                    if (!(e instanceof Cn) && (g && _.equivalent_to(e) || b && (r = b(e, this)))) {
                        if (!S || v && (r || !w || !A)) {
                            if (!r || !h) F = true;
                            return e;
                        }
                        if (_e(e, t)) {
                            if (h && !r) {
                                B = true;
                                C++;
                            }
                            return e;
                        } else if (h) {
                            if (!r) C++;
                            return e;
                        } else {
                            C++;
                        }
                        se = F = true;
                        Ae.info("Collapsing {name} [{file}:{line},{col}]", {
                            name: e.print_to_string(),
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (p instanceof bn) {
                            return le(gn, p, p);
                        }
                        if (p instanceof cn) {
                            var i = p.name.definition();
                            if (i.references.length - i.replaced == 1 && !c.exposed(i)) {
                                i.replaced++;
                                return pe(c, t, e, p.value);
                            }
                            return le(wn, p, {
                                operator: "=",
                                left: le($n, p.name, p.name),
                                right: p.value
                            });
                        }
                        p.write_only = false;
                        return p;
                    }
                    if (q(e, t) || E(e)) {
                        d = e;
                        if (e instanceof Re) F = true;
                    }
                    if (e instanceof Ue) {
                        var o = S;
                        S = false;
                        n(e, l);
                        S = o;
                        return e;
                    }
                    return z(e);
                }, function(e) {
                    if (F) return;
                    if (d === e) F = true;
                    if (v === e) v = null;
                });
                var r = new it(function(e) {
                    if (F) return e;
                    if (!D) {
                        if (e !== a[s]) return e;
                        s++;
                        switch (a.length - s) {
                          case 0:
                            D = true;
                            if (B) return e;
                            if (e instanceof cn) return e;
                            T.replaced++;
                            var n = r.parent();
                            if (n instanceof hn && n.tail_node() !== e) {
                                h.replaced++;
                                return be.skip;
                            }
                            return Y(p);

                          case 1:
                            if (!B && e.body === p) {
                                D = true;
                                T.replaced++;
                                h.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof $n && e.name == T.name) {
                        if (!--C) F = true;
                        if (_e(e, r.parent())) return e;
                        T.replaced++;
                        h.replaced--;
                        return Y(p).clone();
                    }
                    if (e instanceof tn || e instanceof Re) return e;
                }, K);
                var i;
                while (--o >= 0) {
                    if (o == 0 && c.option("unused")) j();
                    var a = [];
                    H(t[o]);
                    while (u.length > 0) {
                        a = u.pop();
                        var s = 0;
                        var p = a[a.length - 1];
                        var h = null;
                        var d = null;
                        var v = null;
                        var _ = U(p);
                        var m = _ && _.has_side_effects(c);
                        var g = _ && !m && !ce(_, c);
                        var b = W(L(p));
                        if (!g && !b) continue;
                        var y = false;
                        var x = G(p);
                        var w = Q(_);
                        if (!m) m = Z(p);
                        var A = ee(p);
                        var E = p.may_throw(c) ? oe ? function(e) {
                            return e.has_side_effects(c);
                        } : re : ge;
                        var k = p.name instanceof Sn;
                        var D = k;
                        var F = false;
                        var C = 0;
                        var B = false;
                        var S = !f || !D;
                        if (!S) {
                            for (var e = c.self().argnames.lastIndexOf(p.name) + 1; !F && e < f.length; e++) {
                                f[e].transform(l);
                            }
                            S = true;
                        }
                        for (var n = o; !F && n < t.length; n++) {
                            t[n].transform(l);
                        }
                        if (h) {
                            var T = _.definition();
                            var O = T.references.length - T.replaced;
                            if (p instanceof wn) O--;
                            if (C && O == C) {
                                F = false;
                            } else if (p instanceof wn) {
                                u.push(a);
                                i = true;
                                continue;
                            } else {
                                C = false;
                            }
                            if (C) {
                                s = 0;
                                D = k;
                                for (var n = o; !F && n < t.length; n++) {
                                    if (!t[n].transform(r)) t.splice(n--, 1);
                                }
                                h.single_use = false;
                            }
                        }
                        if (C && !X(p)) t.splice(o, 1);
                    }
                }
                function z(e) {
                    if (e instanceof Re) return e;
                    if (e instanceof en) {
                        e.expression = e.expression.transform(l);
                        for (var n = 0; !F && n < e.body.length; n++) {
                            var t = e.body[n];
                            if (t instanceof rn) {
                                if (!D) {
                                    if (t !== a[s]) continue;
                                    s++;
                                }
                                t.expression = t.expression.transform(l);
                                if (!A) break;
                                b = false;
                            }
                        }
                        F = true;
                        return e;
                    }
                }
                function $(e, n) {
                    if (n instanceof je) return e !== n.init;
                    if (e instanceof wn) {
                        return e.operator != "=" && _.equivalent_to(e.left);
                    }
                    if (e instanceof ln) {
                        if (!(_ instanceof dn)) return false;
                        if (!_.equivalent_to(e.expression)) return false;
                        var t = Y(p);
                        return !(t instanceof Le && !t.contains_this());
                    }
                    if (e instanceof ke) return true;
                    if (e instanceof Ye) return k && _.name === e.name.name;
                    if (e instanceof ze) return !(e instanceof je);
                    if (e instanceof Xe) return true;
                    if (e instanceof on) return true;
                    if (e instanceof Ne) return true;
                    if (A) return false;
                    return e instanceof $n && !e.is_declared(c) && !(n instanceof wn && n.operator == "=" && n.left === e);
                }
                function M(e, n) {
                    if (n instanceof yn) return de[n.operator] && n.left !== e;
                    if (n instanceof rn) return n.expression !== e;
                    if (n instanceof xn) return n.condition !== e;
                    return n instanceof Ze && n.condition !== e;
                }
                function q(e, n) {
                    if (e instanceof ln) {
                        var t = e.expression;
                        if (t instanceof $n) {
                            if (t.definition().recursive_refs > 0) return true;
                            t = t.fixed_value();
                        }
                        if (!(t instanceof Ie)) return true;
                        if (t.collapse_scanning) return false;
                        t.collapse_scanning = true;
                        var r = S;
                        S = false;
                        var i = d;
                        var o = v;
                        var a = b;
                        for (var s = 0; !F && s < t.body.length; s++) {
                            var f = t.body[s];
                            if (f instanceof Je) {
                                if (f.value) f.value.transform(l);
                                break;
                            }
                            f.transform(l);
                        }
                        b = a;
                        v = o;
                        d = i;
                        S = r;
                        delete t.collapse_scanning;
                        if (!F) return false;
                        F = false;
                        return true;
                    }
                    if (e instanceof We) {
                        if (oe) {
                            if (oe.bfinally) return true;
                            if (oe.bcatch && e instanceof Ge) return true;
                        }
                        return m || _ instanceof dn || te(_);
                    }
                    if (e instanceof Le) {
                        return c.option("ie8") && e.name && x.has(e.name.name);
                    }
                    if (e instanceof dn) {
                        return m || !h && e.expression.may_throw_on_access(c);
                    }
                    if (e instanceof $n) {
                        if (ne(e, n)) {
                            return !n || n.operator != "=" || n.left !== e;
                        }
                        return m && te(e);
                    }
                    if (e instanceof Mn) return ne(e, n);
                    if (e instanceof cn) {
                        if (!e.value) return false;
                        return x.has(e.name.name) || m && te(e.name);
                    }
                    var u = _e(e.left, e);
                    if (u && x.has(u.name)) return true;
                    if (u instanceof dn) return true;
                }
                function j() {
                    var e, t = c.self();
                    if (t instanceof Le && !t.name && !t.uses_arguments && !t.pinned() && (e = c.parent()) instanceof ln && e.expression === t) {
                        var r = c.has_directive("use strict");
                        if (r && !me(r, t.body)) r = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var i = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(le(cn, a, {
                                name: a,
                                value: s
                            }));
                            if (a.name in i) continue;
                            i[a.name] = true;
                            if (!s) {
                                s = le(In, a).transform(c);
                            } else if (s instanceof Ie && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new Jn(function(e) {
                                    if (!s) return true;
                                    if (e instanceof $n && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== ae) while (n = n.parent_scope) {
                                            if (n === ae) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof Mn && (r || !this.find_parent(Re))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) u.unshift([ le(cn, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function H(e) {
                    a.push(e);
                    if (e instanceof An) {
                        e.elements.forEach(H);
                    } else if (e instanceof wn) {
                        u.push(a.slice());
                        H(e.left);
                        H(e.right);
                    } else if (e instanceof yn) {
                        H(e.left);
                        H(e.right);
                    } else if (e instanceof ln) {
                        H(e.expression);
                        e.args.forEach(H);
                    } else if (e instanceof rn) {
                        H(e.expression);
                    } else if (e instanceof xn) {
                        H(e.condition);
                        H(e.consequent);
                        H(e.alternative);
                    } else if (e instanceof fn) {
                        e.definitions.forEach(H);
                    } else if (e instanceof vn) {
                        H(e.expression);
                    } else if (e instanceof $e) {
                        H(e.condition);
                        if (!(e.body instanceof Be)) {
                            H(e.body);
                        }
                    } else if (e instanceof We) {
                        if (e.value) H(e.value);
                    } else if (e instanceof je) {
                        if (e.init) H(e.init);
                        if (e.condition) H(e.condition);
                        if (e.step) H(e.step);
                        if (!(e.body instanceof Be)) {
                            H(e.body);
                        }
                    } else if (e instanceof He) {
                        H(e.object);
                        if (!(e.body instanceof Be)) {
                            H(e.body);
                        }
                    } else if (e instanceof Ze) {
                        H(e.condition);
                        if (!(e.body instanceof Be)) {
                            H(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Be)) {
                            H(e.alternative);
                        }
                    } else if (e instanceof En) {
                        e.properties.forEach(function(e) {
                            if (e instanceof Dn) {
                                a.push(e);
                                H(e.value);
                                a.pop();
                            }
                        });
                    } else if (e instanceof hn) {
                        e.expressions.forEach(H);
                    } else if (e instanceof Fe) {
                        H(e.body);
                    } else if (e instanceof _n) {
                        H(e.expression);
                        H(e.property);
                    } else if (e instanceof en) {
                        H(e.expression);
                        e.body.forEach(H);
                    } else if (e instanceof mn) {
                        if (ve[e.operator]) {
                            u.push(a.slice());
                        } else {
                            H(e.expression);
                        }
                    } else if (e instanceof cn) {
                        if (e.value) {
                            var n = e.name.definition();
                            if (n.references.length > n.replaced) {
                                u.push(a.slice());
                            }
                            H(e.value);
                        }
                    }
                    a.pop();
                }
                function N(e, n) {
                    var t = l.parent(n);
                    if (t instanceof An) return e;
                    if (t instanceof wn) return e;
                    if (t instanceof yn) return e;
                    if (t instanceof ln) return e;
                    if (t instanceof rn) return e;
                    if (t instanceof xn) return e;
                    if (t instanceof fn) return P(t, n + 1);
                    if (t instanceof We) return e;
                    if (t instanceof Ze) return e;
                    if (t instanceof ze) return e;
                    if (t instanceof Dn) return e;
                    if (t instanceof dn) return e;
                    if (t instanceof hn) {
                        return (t.tail_node() === e ? N : P)(t, n + 1);
                    }
                    if (t instanceof Fe) return P(t, n + 1);
                    if (t instanceof en) return e;
                    if (t instanceof mn) return e;
                    if (t instanceof cn) return e;
                    return null;
                }
                function R(e, n) {
                    var t = l.parent(n);
                    if (t instanceof An) return R(t, n + 1);
                    if (t instanceof wn) {
                        if (E(t)) return e;
                        if (t.left instanceof $n) {
                            var r = t.left.name;
                            if (_.name == r) return e;
                            if (h.name == r) return e;
                        }
                        return R(t, n + 1);
                    }
                    if (t instanceof yn) {
                        if (de[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = l.parent(++n);
                            } while (t instanceof yn && t.operator == e.operator);
                            return e;
                        }
                        return R(t, n + 1);
                    }
                    if (t instanceof ln) return t;
                    if (t instanceof rn) {
                        if (t.expression !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof xn) {
                        if (t.condition !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof fn) return P(t, n + 1);
                    if (t instanceof Me) return e;
                    if (t instanceof We) return P(t, n + 1);
                    if (t instanceof je) {
                        if (t.init !== e && t.condition !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof He) {
                        if (t.init !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof Ze) {
                        if (t.condition !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof Dn) {
                        var i = l.parent(n + 1);
                        return ye(i.properties, function(e) {
                            return e instanceof Dn;
                        }) ? R(i, n + 2) : i;
                    }
                    if (t instanceof dn) return R(t, n + 1);
                    if (t instanceof hn) {
                        return (t.tail_node() === e ? R : P)(t, n + 1);
                    }
                    if (t instanceof Fe) return P(t, n + 1);
                    if (t instanceof en) {
                        if (t.expression !== e) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof mn) {
                        if (t.operator == "delete") return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof cn) {
                        var r = t.name.name;
                        if (_.name == r) return e;
                        if (h.name == r) return e;
                        return R(t, n + 1);
                    }
                    if (t instanceof qe) {
                        if (t.condition !== e) return e;
                        return R(t, n + 1);
                    }
                    return null;
                }
                function P(e, n) {
                    var t = l.parent(n);
                    if (q(e, t)) return e;
                    if (M(e, t)) return e;
                    if (t instanceof An) return P(t, n + 1);
                    if (t instanceof wn) {
                        return E(t) ? e : P(t, n + 1);
                    }
                    if (t instanceof yn) return P(t, n + 1);
                    if (t instanceof ln) return P(t, n + 1);
                    if (t instanceof rn) return P(t, n + 1);
                    if (t instanceof xn) return P(t, n + 1);
                    if (t instanceof fn) return P(t, n + 1);
                    if (t instanceof We) return P(t, n + 1);
                    if (t instanceof Ze) return P(t, n + 1);
                    if (t instanceof ze) return e;
                    if (t instanceof Dn) {
                        var r = l.parent(n + 1);
                        return ye(r.properties, function(e) {
                            return e instanceof Dn;
                        }) ? P(r, n + 2) : r;
                    }
                    if (t instanceof dn) {
                        var i = t.expression;
                        if (i === e) return P(t, n + 1);
                        var o = he(i);
                        if (!(o instanceof $n)) return P(t, n + 1);
                        var a = x.get(o.name);
                        return !a || ye(a, function(e) {
                            return !(e instanceof dn);
                        }) ? P(t, n + 1) : e;
                    }
                    if (t instanceof hn) return P(t, n + 1);
                    if (t instanceof Fe) return P(t, n + 1);
                    if (t instanceof en) return P(t, n + 1);
                    if (t instanceof mn) return P(t, n + 1);
                    if (t instanceof cn) return P(t, n + 1);
                    return null;
                }
                function I(e) {
                    if (i) {
                        i = false;
                        return;
                    }
                    if (!(e instanceof $n)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (ue(n)) return;
                    return h = n;
                }
                function U(e) {
                    if (e instanceof cn) {
                        var n = e.name.definition();
                        if (!me(e.name, n.orig)) return;
                        var t = n.references.length - n.replaced;
                        var r = n.orig.length - n.eliminated;
                        if (r > 1 && !(e.name instanceof Sn) || (t > 1 ? I(e.value) : !c.exposed(n))) {
                            return le($n, e.name, e.name);
                        }
                    } else if (e instanceof wn) {
                        var i = e.left;
                        if (e.operator == "=" && i instanceof $n) {
                            var n = i.definition();
                            if (n.references[0] === i) {
                                var t = n.references.length - n.replaced;
                                if (t > 1) I(e.right);
                            }
                        }
                        return i;
                    } else {
                        return e.expression;
                    }
                }
                function L(e) {
                    return p instanceof wn && p.operator == "=" && p.right;
                }
                function Y(e) {
                    return e[e instanceof wn ? "right" : "value"];
                }
                function V(e) {
                    if (e instanceof An) return false;
                    if (e instanceof yn && de[e.operator]) {
                        return V(e.left) && V(e.right);
                    }
                    if (e instanceof ln) return false;
                    if (e instanceof xn) {
                        return V(e.consequent) && V(e.alternative);
                    }
                    if (e instanceof En) return false;
                    return !e.has_side_effects(c);
                }
                function W(n) {
                    if (!n) return false;
                    if (n instanceof $n) {
                        var e = n.evaluate(c);
                        if (e === n) return i;
                        return J(e, i);
                    }
                    if (n instanceof Mn) return i;
                    if (n.is_truthy()) return J(true, ge);
                    if (n.is_constant()) {
                        return J(n.evaluate(c), i);
                    }
                    if (!(_ instanceof $n)) return false;
                    if (!V(n)) return false;
                    var t;
                    var r = _.definition();
                    n.walk(new Jn(function(e) {
                        if (t) return true;
                        if (e instanceof $n && e.definition() === r) {
                            t = true;
                        }
                    }));
                    return !t && i;
                    function i(e) {
                        return n.equivalent_to(e);
                    }
                }
                function J(t, r) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(c)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(c) == !t;
                            }
                        }
                        return r(e);
                    };
                }
                function G(e) {
                    var r = new xe();
                    if (p instanceof cn) r.add(p.name.name, _);
                    var i = ae instanceof Pe;
                    var o = new Jn(function(e) {
                        if (i && e.TYPE == "Call") {
                            var n = e.expression;
                            if (n instanceof dn) return;
                            if (n instanceof Le && !n.contains_this()) return;
                            y = true;
                            i = false;
                            return;
                        }
                        var t;
                        if (e instanceof $n) {
                            t = e.fixed_value() || e;
                        } else if (e instanceof Mn) {
                            t = e;
                        }
                        if (t) r.add(e.name, fe(c, o, e, t, 0));
                    });
                    e.walk(o);
                    return r;
                }
                function X(r) {
                    if (r.name instanceof Sn) {
                        var e = c.self().argnames.indexOf(r.name);
                        var n = c.parent().args;
                        if (n[e]) n[e] = le(Hn, n[e], {
                            value: 0
                        });
                        return true;
                    }
                    var i = false;
                    return t[o].transform(new it(function(e, n, t) {
                        if (i) return e;
                        if (e instanceof Re) return e;
                        if (e !== r && e.body !== r) return;
                        i = true;
                        if (e instanceof cn) {
                            e.value = null;
                            return e;
                        }
                        return t ? be.skip : null;
                    }, K));
                }
                function K(e) {
                    if (e instanceof hn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function Q(e) {
                    var n = he(e);
                    return n instanceof $n && n.definition().scope === ae && !(ie && (x.has(n.name) && x.get(n.name)[0] !== e || p instanceof mn || p instanceof wn && p.operator != "="));
                }
                function Z(e) {
                    if (e instanceof mn) return false;
                    return Y(e).has_side_effects(c);
                }
                function ee(e) {
                    if (e instanceof mn) return false;
                    if (m) return false;
                    if (h) return true;
                    if (!(_ instanceof $n)) return false;
                    var n;
                    if (e instanceof cn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = _.definition();
                    return t.references.length - t.replaced == n;
                }
                function ne(e, n) {
                    var t = x.get(e.name);
                    if (!t || ye(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== _) return true;
                    b = false;
                }
                function te(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Tn) return false;
                    if (n.scope !== ae) return true;
                    if (y && c.exposed(n)) return true;
                    return !ye(n.references, function(e) {
                        return e.scope.resolve() === ae;
                    });
                }
                function re(e, n) {
                    if (e instanceof wn) return re(e.left, true);
                    if (e instanceof mn) return re(e.expression, true);
                    if (e instanceof cn) return e.value && re(e.value);
                    if (n) {
                        if (e instanceof vn) return re(e.expression, true);
                        if (e instanceof _n) return re(e.expression, true);
                        if (e instanceof $n) return e.definition().scope !== ae;
                    }
                    return false;
                }
            }
            function i(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var r = e[t];
                    if (r instanceof Se) {
                        se = true;
                        i(r.body);
                        [].splice.apply(e, [ t, 1 ].concat(r.body));
                        t += r.body.length;
                    } else if (r instanceof Te) {
                        se = true;
                        e.splice(t, 1);
                    } else if (r instanceof De) {
                        if (!me(r.value, n)) {
                            t++;
                            n.push(r.value);
                        } else {
                            se = true;
                            e.splice(t, 1);
                        }
                    } else t++;
                }
            }
            function o(r, t) {
                var i = t.self();
                var e = _(r);
                var o = i instanceof Ie;
                for (var n = r.length; --n >= 0; ) {
                    var a = r[n];
                    var s = x(n);
                    var f = r[s];
                    if (o && !f && a instanceof Je) {
                        if (!a.value) {
                            se = true;
                            r.splice(n, 1);
                            continue;
                        }
                        if (a.value instanceof gn && a.value.operator == "void") {
                            se = true;
                            r[n] = le(Fe, a, {
                                body: a.value.expression
                            });
                            continue;
                        }
                    }
                    if (a instanceof Ze) {
                        var u = F(a.body);
                        if (g(u)) {
                            if (u.label) I(u.label.thedef.references, u);
                            se = true;
                            a = a.clone();
                            a.condition = a.condition.negate(t);
                            var c = y(a.body, u);
                            a.body = le(Se, a, {
                                body: E(a.alternative).concat(b())
                            });
                            a.alternative = le(Se, a, {
                                body: c
                            });
                            r[n] = a;
                            r[n] = a.transform(t);
                            continue;
                        }
                        if (u && !a.alternative && a.body instanceof Se && f instanceof Ve) {
                            var l = a.condition.negate(t);
                            if (l.print_to_string().length <= a.condition.print_to_string().length) {
                                se = true;
                                a = a.clone();
                                a.condition = l;
                                r[s] = a.body;
                                a.body = f;
                                r[n] = a;
                                r[n] = a.transform(t);
                                continue;
                            }
                        }
                        var p = F(a.alternative);
                        if (g(p)) {
                            if (p.label) I(p.label.thedef.references, p);
                            se = true;
                            a = a.clone();
                            a.body = le(Se, a.body, {
                                body: E(a.body).concat(b())
                            });
                            var c = y(a.alternative, p);
                            a.alternative = le(Se, a.alternative, {
                                body: c
                            });
                            r[n] = a;
                            r[n] = a.transform(t);
                            continue;
                        }
                        if (t.option("typeofs")) {
                            if (u && !p) {
                                B(a.condition, null, le(Se, i, {
                                    body: r.slice(n + 1)
                                }));
                            }
                            if (!u && p) {
                                B(a.condition, le(Se, i, {
                                    body: r.slice(n + 1)
                                }));
                            }
                        }
                    }
                    if (a instanceof Ze && a.body instanceof Je) {
                        var h = a.body.value;
                        var d = a.body.in_bool || f instanceof Je && f.in_bool;
                        if (!h && !a.alternative && (o && !f || f instanceof Je && !f.value)) {
                            se = true;
                            r[n] = le(Fe, a.condition, {
                                body: a.condition
                            });
                            continue;
                        }
                        if ((d || h) && !a.alternative && f instanceof Je) {
                            se = true;
                            a = a.clone();
                            a.alternative = f;
                            r.splice(n, 1, a.transform(t));
                            r.splice(s, 1);
                            continue;
                        }
                        if (!a.alternative && !f && o && (d || h && e)) {
                            se = true;
                            a = a.clone();
                            a.alternative = le(Je, a, {
                                value: null
                            });
                            r.splice(n, 1, a.transform(t));
                            continue;
                        }
                        var v = r[w(n)];
                        if (t.option("sequences") && o && !a.alternative && v instanceof Ze && v.body instanceof Je && x(s) == r.length && f instanceof Fe) {
                            se = true;
                            a = a.clone();
                            a.alternative = le(Se, f, {
                                body: [ f, le(Je, f, {
                                    value: null
                                }) ]
                            });
                            r.splice(n, 1, a.transform(t));
                            r.splice(s, 1);
                            continue;
                        }
                    }
                }
                function _(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof Ze && r.body instanceof Je) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function m(e) {
                    return !e || e instanceof gn && e.operator == "void";
                }
                function g(e) {
                    if (!e) return false;
                    var n = e instanceof Xe ? t.loopcontrol_target(e) : null;
                    return e instanceof Je && o && m(e.value) || e instanceof Qe && i === k(n) || e instanceof Ke && n instanceof Se && i === n;
                }
                function b() {
                    var e = r.slice(n + 1);
                    r.length = n + 1;
                    return e.filter(function(e) {
                        if (e instanceof Ye) {
                            r.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function y(e, n) {
                    var t = E(e).slice(0, -1);
                    if (n.value) {
                        t.push(le(Fe, n.value, {
                            body: n.value.expression
                        }));
                    }
                    return t;
                }
                function x(e) {
                    for (var n = e + 1; n < r.length; n++) {
                        var t = r[n];
                        if (!(t instanceof un && A(t))) {
                            break;
                        }
                    }
                    return n;
                }
                function w(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = r[n];
                        if (!(t instanceof un && A(t))) {
                            break;
                        }
                    }
                    return n;
                }
            }
            function a(n, e) {
                var t;
                var r = e.self();
                for (var i = 0, o = 0, a = n.length; i < a; i++) {
                    var s = n[i];
                    if (s instanceof Xe) {
                        var f = e.loopcontrol_target(s);
                        if (s instanceof Ke && !(f instanceof ze) && k(f) === r || s instanceof Qe && k(f) === r) {
                            if (s.label) I(s.label.thedef.references, s);
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (F(s)) {
                        t = n.slice(i + 1);
                        break;
                    }
                }
                n.length = o;
                se = o != a;
                if (t) t.forEach(function(e) {
                    x(e, n);
                });
            }
            function A(e) {
                return ye(e.definitions, function(e) {
                    return !e.value;
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = U(t[0], t);
                    n[r++] = le(Fe, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof Fe) {
                        if (t.length >= e.sequences_limit) i();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) d(t, f);
                    } else if (s instanceof fn && A(s) || s instanceof Ye) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                if (r != a) se = true;
            }
            function p(e, n) {
                if (!(e instanceof Se)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof un && A(i)) {
                        n.push(i);
                    } else if (t) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    r--;
                    se = true;
                    var n = i.body;
                    return U(n, [ n, e ]);
                }
                var r = 0, i;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (i) {
                        if (a instanceof We) {
                            a.value = t(a.value || le(In, a)).transform(n);
                        } else if (a instanceof je) {
                            if (!(a.init instanceof fn)) {
                                var s = false;
                                i.body.walk(new Jn(function(e) {
                                    if (s || e instanceof Re) return true;
                                    if (e instanceof yn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = t(a.init); else {
                                        a.init = i.body;
                                        r--;
                                        se = true;
                                    }
                                }
                            }
                        } else if (a instanceof He) {
                            a.object = t(a.object);
                        } else if (a instanceof Ze) {
                            a.condition = t(a.condition);
                        } else if (a instanceof en) {
                            a.expression = t(a.expression);
                        } else if (a instanceof Ne) {
                            a.expression = t(a.expression);
                        }
                    }
                    if (n.option("conditionals") && a instanceof Ze) {
                        var f = [];
                        var u = p(a.body, f);
                        var c = p(a.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(le(Ze, a, {
                                condition: a.condition,
                                body: u || le(Te, a.body),
                                alternative: c
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            o += l;
                            r += l + 1;
                            i = null;
                            se = true;
                            continue;
                        }
                    }
                    e[r++] = a;
                    i = a instanceof Fe ? a : null;
                }
                e.length = r;
            }
            function c(e, n) {
                var t;
                if (n instanceof wn) {
                    t = [ n ];
                } else if (n instanceof hn) {
                    t = n.expressions.slice();
                }
                if (!t) return;
                if (e instanceof fn) {
                    var r = e.definitions[e.definitions.length - 1];
                    if (l(r.name, r.value, t)) return t;
                }
                for (var i = t.length - 1; --i >= 0; ) {
                    var o = t[i];
                    if (!(o instanceof wn)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof $n)) continue;
                    var a = t.slice(i + 1);
                    if (!l(o.left, o.right, a)) continue;
                    return t.slice(0, i + 1).concat(a);
                }
            }
            function l(e, n, t) {
                if (!(n instanceof En)) return;
                var r = false;
                do {
                    var i = t[0];
                    if (!(i instanceof wn)) break;
                    if (i.operator != "=") break;
                    if (!(i.left instanceof dn)) break;
                    var o = i.left.expression;
                    if (!(o instanceof $n)) break;
                    if (e.name != o.name) break;
                    if (!i.right.is_constant_expression(ae)) break;
                    var a = i.left.property;
                    if (a instanceof Ae) {
                        a = a.evaluate(f);
                    }
                    if (a instanceof Ae) break;
                    a = "" + a;
                    var s = f.has_directive("use strict") ? function(e) {
                        return e.key != a && e.key.name != a;
                    } : function(e) {
                        return e.key.name != a;
                    };
                    if (!ye(n.properties, s)) break;
                    n.properties.push(le(Dn, i, {
                        key: a,
                        value: i.right
                    }));
                    t.shift();
                    r = true;
                } while (t.length);
                return r;
            }
            function h(r) {
                var e;
                for (var n = 0, i = -1; n < r.length; n++) {
                    var o = r[n];
                    var a = r[i];
                    if (o instanceof fn) {
                        if (a && a.TYPE == o.TYPE) {
                            a.definitions = a.definitions.concat(o.definitions);
                            se = true;
                        } else if (e && e.TYPE == o.TYPE && A(o)) {
                            e.definitions = e.definitions.concat(o.definitions);
                            se = true;
                        } else {
                            r[++i] = o;
                            e = o;
                        }
                    } else if (o instanceof We) {
                        o.value = s(o.value);
                    } else if (o instanceof je) {
                        var t = c(a, o.init);
                        if (t) {
                            se = true;
                            o.init = t.length ? U(o.init, t) : null;
                            r[++i] = o;
                        } else if (a instanceof un && (!o.init || o.init.TYPE == a.TYPE)) {
                            if (o.init) {
                                a.definitions = a.definitions.concat(o.init.definitions);
                            }
                            o.init = a;
                            r[i] = o;
                            se = true;
                        } else if (e && o.init && e.TYPE == o.init.TYPE && A(o.init)) {
                            e.definitions = e.definitions.concat(o.init.definitions);
                            o.init = null;
                            r[++i] = o;
                            se = true;
                        } else {
                            r[++i] = o;
                        }
                    } else if (o instanceof He) {
                        o.object = s(o.object);
                    } else if (o instanceof Ze) {
                        o.condition = s(o.condition);
                    } else if (o instanceof Fe) {
                        var t = c(a, o.body);
                        if (t) {
                            se = true;
                            if (!t.length) continue;
                            o.body = U(o.body, t);
                        }
                        r[++i] = o;
                    } else if (o instanceof en) {
                        o.expression = s(o.expression);
                    } else if (o instanceof Ne) {
                        o.expression = s(o.expression);
                    } else {
                        r[++i] = o;
                    }
                }
                r.length = i + 1;
                function s(e) {
                    r[++i] = o;
                    var n = c(a, e);
                    if (!n) return e;
                    se = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return U(e, n);
                }
            }
        }
        function x(e, n) {
            if (!(e instanceof Ye)) {
                Ae.warn("Dropping unreachable code [{file}:{line},{col}]", e.start);
            }
            e.walk(new Jn(function(e) {
                if (e instanceof fn) {
                    Ae.warn("Declarations in unreachable code! [{file}:{line},{col}]", e.start);
                    e.remove_initializers();
                    n.push(e);
                    return true;
                }
                if (e instanceof Ye) {
                    n.push(e);
                    return true;
                }
                if (e instanceof Re) {
                    return true;
                }
            }));
        }
        function C(e, n) {
            return e.is_undefined || e instanceof In || e instanceof gn && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(Ae, ge);
            e(An, oe);
            e(wn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Ie, oe);
            e(En, oe);
            e(Nn, oe);
            e(hn, function() {
                return this.tail_node().is_truthy();
            });
            e($n, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = ge;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(Ae, oe);
            e(An, ge);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof qn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(wn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(yn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(qn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Ie, ge);
            e(En, ge);
            e(Nn, ge);
            e(hn, function() {
                return this.tail_node().is_negative_zero();
            });
            e($n, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = oe;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(gn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            Ae.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function r(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(Ae, r);
            e(An, ge);
            e(wn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof $n)) return true;
                if (n instanceof yn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(yn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(xn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(qn, ge);
            e(vn, function(e) {
                if (!r(e)) return false;
                var n = this.expression;
                if (n instanceof $n) n = n.fixed_value();
                return !(n instanceof Ie && this.property == "prototype");
            });
            e(Ie, ge);
            e(Rn, oe);
            e(En, function(e) {
                if (!r(e)) return false;
                for (var n = this.properties.length; --n >= 0; ) if (this.properties[n].value instanceof Ue) return true;
                return false;
            });
            e(hn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e($n, function(e) {
                if (this.is_undefined) return true;
                if (!r(e)) return false;
                if (W(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (ue(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = oe;
                var t = n._dot_throw(e);
                delete this._dot_throw;
                return t;
            });
            e(gn, function() {
                return this.operator == "void";
            });
            e(bn, ge);
            e(In, oe);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(Ae, ge);
            e(An, oe);
            e(wn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(yn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(xn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(qn, oe);
            e(Ie, oe);
            e(En, oe);
            e(hn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e($n, function(e) {
                if (this.is_undefined) return false;
                if (W(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = ge;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(gn, function() {
                return this.operator != "void";
            });
            e(bn, oe);
            e(In, ge);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(Ae, ge);
            e(wn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = ae("in instanceof == != === !== < <= >= >");
            e(yn, function(e) {
                return n[this.operator] || de[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Yn, oe);
            var t = ae("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(ln, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof vn && (t[n.property] || n.property == "test" && n.expression instanceof Nn);
            });
            e(xn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(pn, ge);
            e(hn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e($n, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = ge;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = ae("! delete");
            e(gn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(Ae, ge);
            var n = ae("- * / % & | ^ << >> >>>");
            e(wn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(yn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = ae([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(ln, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof vn && (t[n.property] || W(n.expression) && n.expression.name == "Math");
            });
            e(xn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(pn, ge);
            e(Hn, oe);
            e(hn, function(e) {
                return this.tail_node().is_number(e);
            });
            e($n, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = ge;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var r = ae("+ - ~ ++ --");
            e(mn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(Ae, ge);
            e(wn, function(e) {
                return (this.operator == "=" || this.operator == "+=") && this.right.is_string(e);
            });
            e(yn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = ae([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(ln, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof vn && t[n.property];
            });
            e(xn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(hn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(jn, oe);
            e($n, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = ge;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(gn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var de = ae("&& ||");
        var ve = ae("++ --");
        var y = ae("delete ++ --");
        function _e(e, n) {
            if (n instanceof mn && y[n.operator]) return n.expression;
            if (n instanceof wn && n.left === e) return e;
        }
        (function(e) {
            function i(e, n) {
                if (e instanceof Ae) return le(e.CTOR, n, e);
                if (Array.isArray(e)) return le(An, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (se(e, r)) {
                        t.push(le(Dn, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return le(En, n, {
                        properties: t
                    });
                }
                return A(e, n);
            }
            function a(e) {
                Ae.warn("global_defs " + e.print_to_string() + " redefined [{file}:{line},{col}]", e.start);
            }
            Pe.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new it(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof dn)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (_e(r, i)) {
                        a(e);
                        return;
                    }
                    return n;
                }));
            });
            e(Ae, ie);
            e(vn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Cn, function(e) {
                if (!this.global()) return;
                if (se(e.option("global_defs"), this.name)) a(this);
            });
            e($n, function(e, n) {
                if (!this.global()) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (se(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function D(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function a(e, n, t) {
            return D(le(Fe, e, {
                body: e
            }), le(Fe, n, {
                body: n
            }), t).body;
        }
        function G(e, n, t, r) {
            return (we(e) ? a : D)(n, t, r);
        }
        function t(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = ae(n[e]);
            });
            return t;
        }
        Ie.DEFMETHOD("first_statement", function() {
            var e = this.body;
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof De)) return t;
            }
        });
        function X(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = A(t, n).optimize(e);
            return G(e, n, t, e.eval_threshold);
        }
        var s = [ "constructor", "toString", "valueOf" ];
        var v = t({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(s),
            Boolean: s,
            Function: s,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(s),
            Object: s,
            RegExp: [ "exec", "test" ].concat(s),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(s)
        });
        var _ = t({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            Ae.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var n = ae("! ~ - + void");
            Ae.DEFMETHOD("is_constant", function() {
                if (this instanceof qn) {
                    return !(this instanceof Nn);
                } else {
                    return this instanceof gn && this.expression instanceof qn && n[this.operator];
                }
            });
            e(Ee, function() {
                throw new Error(P("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Ie, N);
            e(Ae, N);
            e(qn, function() {
                return this.value;
            });
            e(wn, function(e, n, t, r) {
                if (!n) return this;
                if (this.operator != "=") return this;
                var i = this.right;
                var o = i._eval(e, n, t, r);
                return o === i ? this : o;
            });
            e(hn, function(e, n, t, r) {
                if (!n) return this;
                var i = this.tail_node();
                var o = i._eval(e, n, t, r);
                return o === i ? this : o;
            });
            e(Le, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(An, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var o = 0; o < this.elements.length; o++) {
                        var a = this.elements[o];
                        var s = a._eval(e, n, t, r);
                        if (a === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(En, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var o = 0; o < this.properties.length; o++) {
                        var a = this.properties[o];
                        var s = a.key;
                        if (s instanceof Fn) {
                            s = s.name;
                        } else if (s instanceof Ae) {
                            s = s._eval(e, n, t, r);
                            if (s === a.key) return this;
                        }
                        if (typeof Object.prototype[s] === "function") {
                            return this;
                        }
                        if (a.value instanceof Le) continue;
                        i[s] = a.value._eval(e, n, t, r);
                        if (i[s] === a.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var s = ae("! typeof void");
            e(gn, function(e, n, t, r) {
                var i = this.expression;
                if (e.option("typeofs") && this.operator == "typeof" && (i instanceof Ie || i instanceof $n && i.fixed_value() instanceof Ie)) {
                    return typeof function() {};
                }
                if (!s[this.operator]) r++;
                var o = i._eval(e, n, t, r);
                if (o === this.expression) return this;
                switch (this.operator) {
                  case "!":
                    return !o;

                  case "typeof":
                    if (o instanceof RegExp) return this;
                    return typeof o;

                  case "void":
                    return void o;

                  case "~":
                    return ~o;

                  case "-":
                    return -o;

                  case "+":
                    return +o;

                  case "++":
                  case "--":
                    if (!(i instanceof $n)) return this;
                    var a = i.definition().references;
                    if (a[a.length - 1] !== i) return this;
                    return se(i, "_eval") ? +(this.operator[0] + 1) + +o : o;
                }
                return this;
            });
            var u = ae("&& || === !==");
            e(yn, function(e, n, t, r) {
                if (!u[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var o = this.right._eval(e, n, t, r);
                if (o === this.right) return this;
                var a;
                switch (this.operator) {
                  case "&&":
                    a = i && o;
                    break;

                  case "||":
                    a = i || o;
                    break;

                  case "|":
                    a = i | o;
                    break;

                  case "&":
                    a = i & o;
                    break;

                  case "^":
                    a = i ^ o;
                    break;

                  case "+":
                    a = i + o;
                    break;

                  case "*":
                    a = i * o;
                    break;

                  case "/":
                    a = i / o;
                    break;

                  case "%":
                    a = i % o;
                    break;

                  case "-":
                    a = i - o;
                    break;

                  case "<<":
                    a = i << o;
                    break;

                  case ">>":
                    a = i >> o;
                    break;

                  case ">>>":
                    a = i >>> o;
                    break;

                  case "==":
                    a = i == o;
                    break;

                  case "===":
                    a = i === o;
                    break;

                  case "!=":
                    a = i != o;
                    break;

                  case "!==":
                    a = i !== o;
                    break;

                  case "<":
                    a = i < o;
                    break;

                  case "<=":
                    a = i <= o;
                    break;

                  case ">":
                    a = i > o;
                    break;

                  case ">=":
                    a = i >= o;
                    break;

                  default:
                    return this;
                }
                if (isNaN(a)) return e.find_parent(Ne) ? this : a;
                if (e.option("unsafe_math") && !n && a && typeof a == "number" && (this.operator == "+" || this.operator == "-")) {
                    var s = Math.max(0, f(i), f(o));
                    if (s < 16) return +a.toFixed(s);
                }
                return a;
                function f(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(xn, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var o = i ? this.consequent : this.alternative;
                var a = o._eval(e, n, t, r);
                return a === o ? this : a;
            });
            e($n, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var o;
                if (me(i, t)) {
                    o = i._eval();
                } else {
                    this._eval = N;
                    o = i._eval(e, n, t, r);
                    delete this._eval;
                    if (o === i) return this;
                    i._eval = function() {
                        return o;
                    };
                    t.push(i);
                }
                if (o && typeof o == "object") {
                    var a = this.definition().escaped;
                    switch (a.length) {
                      case 0:
                        break;

                      case 1:
                        if (s(a[0], this)) break;

                      default:
                        if (r > a.depth) return this;
                    }
                }
                return o;
                function s(e, n) {
                    var t = false;
                    e.walk(new Jn(function(e) {
                        if (t) return true;
                        if (e === n) return t = true;
                    }));
                    return t;
                }
            });
            var d = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var f = t({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var c = ae("global ignoreCase multiline source");
            e(dn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = this.property;
                    if (i instanceof Ae) {
                        i = i._eval(e, n, t, r);
                        if (i === this.property) return this;
                    }
                    var o = this.expression;
                    var a;
                    if (W(o)) {
                        var s = f[o.name];
                        if (!s || !s[i]) return this;
                        a = d[o.name];
                    } else {
                        a = o._eval(e, n, t, r + 1);
                        if (a == null || a === o) return this;
                        if (a instanceof RegExp) {
                            if (!c[i]) return this;
                        } else if (typeof a == "object") {
                            if (!se(a, i)) return this;
                        } else if (typeof a == "function") switch (i) {
                          case "name":
                            return a.node.name ? a.node.name.name : "";

                          case "length":
                            return a.node.argnames.length;

                          default:
                            return this;
                        }
                    }
                    return a[i];
                }
                return this;
            });
            e(ln, function(o, a, s, f) {
                var e = this.expression;
                var n = e instanceof $n ? e.fixed_value() : e;
                if (n instanceof Ie) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    var t = n.first_statement();
                    if (!(t instanceof Je)) return this;
                    var i = h(this.args);
                    if (!i) return this;
                    if (!t.value) return undefined;
                    if (!ye(n.argnames, function(e, n) {
                        var t = i[n];
                        var r = e.definition();
                        if (r.orig[r.orig.length - 1] !== e) return false;
                        r.references.forEach(function(e) {
                            e._eval = function() {
                                return t;
                            };
                            s.push(e);
                        });
                        return true;
                    })) return this;
                    n.evaluating = true;
                    var r = t.value._eval(o, a, s, f);
                    delete n.evaluating;
                    if (r === t.value) return this;
                    return r;
                } else if (o.option("unsafe") && e instanceof dn) {
                    var u = e.property;
                    if (u instanceof Ae) {
                        u = u._eval(o, a, s, f);
                        if (u === e.property) return this;
                    }
                    var r;
                    var c = e.expression;
                    if (W(c)) {
                        var l = _[c.name];
                        if (!l || !l[u]) return this;
                        r = d[c.name];
                    } else {
                        r = c._eval(o, a, s, f + 1);
                        if (r == null || r === c) return this;
                        var p = v[r.constructor.name];
                        if (!p || !p[u]) return this;
                        if (r instanceof RegExp && r.global && !(c instanceof Nn)) return this;
                    }
                    var i = h(this.args);
                    if (!i) return this;
                    if (u == "replace" && typeof i[1] == "function") return this;
                    try {
                        return r[u].apply(r, i);
                    } catch (e) {
                        Ae.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this.print_to_string(),
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (r instanceof RegExp) r.lastIndex = 0;
                    }
                }
                return this;
                function h(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var r = e[t];
                        var i = r._eval(o, a, s, f);
                        if (r === i) return;
                        n.push(i);
                    }
                    return n;
                }
            });
            e(pn, N);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return le(gn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function i(e, n, t) {
                var r = o(e);
                if (t) {
                    var i = le(Fe, n, {
                        body: n
                    });
                    return D(r, i) === i ? n : r;
                }
                return D(r, n);
            }
            e(Ae, function() {
                return o(this);
            });
            e(Ee, function() {
                throw new Error("Cannot negate a statement");
            });
            e(Le, function() {
                return o(this);
            });
            e(gn, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(hn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return U(this, n);
            });
            e(xn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return i(this, t, n);
            });
            e(yn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var f = ae("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        ln.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (W(n) && f[n.name]) return true;
                if (n instanceof vn && W(n.expression)) {
                    var t = _[n.expression.name];
                    return t && t[n.property];
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        Ae.DEFMETHOD("is_call_pure", ge);
        ln.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof vn)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof An) {
                r = v.Array;
            } else if (t.is_boolean(e)) {
                r = v.Boolean;
            } else if (t.is_number(e)) {
                r = v.Number;
            } else if (t instanceof Nn) {
                r = v.RegExp;
            } else if (t.is_string(e)) {
                r = v.String;
                if (i == "replace") {
                    var o = this.args[1];
                    if (o && !o.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = v.Object;
            }
            return r && r[i];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(Ae, oe);
            e(An, function(e) {
                return n(this.elements, e);
            });
            e(wn, oe);
            e(yn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Be, function(e) {
                return n(this.body, e);
            });
            e(ln, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(rn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(xn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(qn, ge);
            e(fn, function(e) {
                return n(this.definitions, e);
            });
            e(vn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Te, ge);
            e(Ze, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Oe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Ie, ge);
            e(En, function(e) {
                return n(this.properties, e);
            });
            e(kn, function(e) {
                return this.value.has_side_effects(e);
            });
            e(_n, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(hn, function(e) {
                return n(this.expressions, e);
            });
            e(Fe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(en, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(Cn, ge);
            e($n, function(e) {
                return !this.is_declared(e);
            });
            e(Mn, ge);
            e(on, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(mn, function(e) {
                return y[this.operator] || this.expression.has_side_effects(e);
            });
            e(cn, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(Ae, oe);
            e(qn, ge);
            e(Te, ge);
            e(Ie, ge);
            e(Cn, ge);
            e(Mn, ge);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(An, function(e) {
                return n(this.elements, e);
            });
            e(wn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof $n) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(yn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e);
            });
            e(Be, function(e) {
                return n(this.body, e);
            });
            e(ln, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof Ie) || n(this.expression.body, e);
            });
            e(rn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(xn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(fn, function(e) {
                return n(this.definitions, e);
            });
            e(vn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(Ze, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Oe, function(e) {
                return this.body.may_throw(e);
            });
            e(En, function(e) {
                return n(this.properties, e);
            });
            e(kn, function(e) {
                return this.value.may_throw(e);
            });
            e(Je, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(hn, function(e) {
                return n(this.expressions, e);
            });
            e(Fe, function(e) {
                return this.body.may_throw(e);
            });
            e(_n, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(en, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e($n, function(e) {
                return !this.is_declared(e);
            });
            e(on, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(mn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof $n) return false;
                return this.expression.may_throw(e);
            });
            e(cn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(Ae, ge);
            e(An, function() {
                return n(this.elements);
            });
            e(yn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression();
            });
            e(qn, oe);
            e(Ie, function(i) {
                var o = this;
                var a = true;
                var s = [];
                o.walk(new Jn(function(e, n) {
                    if (!a) return true;
                    if (e instanceof an) {
                        s.push(e.argname.scope);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Re) {
                        if (e === o) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof $n) {
                        if (o.inlined) {
                            a = false;
                            return true;
                        }
                        if (o.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (me(t.scope, s)) return true;
                        if (i) {
                            var r = i.find_variable(e);
                            if (t.undeclared ? !r : r === t) {
                                a = "f";
                                return true;
                            }
                        }
                        a = false;
                        return true;
                    }
                }));
                return a;
            });
            e(En, function() {
                return n(this.properties);
            });
            e(kn, function() {
                return this.value.is_constant_expression();
            });
            e(mn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function F(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Ee, R);
            e(Ve, N);
            function n() {
                var e = this.body.length;
                return e > 0 && F(this.body[e - 1]);
            }
            e(Se, n);
            e(nn, n);
            e(Ze, function() {
                return this.alternative && F(this.body) && F(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var u = ae([ "use asm", "use strict" ]);
        e(De, function(e, n) {
            if (n.option("directives") && (!u[e.value] || n.has_directive(e.value) !== e)) {
                return le(Te, e);
            }
            return e;
        });
        e(ke, function(e, n) {
            if (n.option("drop_debugger")) return le(Te, e);
            return e;
        });
        e(Oe, function(e, n) {
            if (e.body instanceof Ke && n.loopcontrol_target(e.body) === e.body) {
                return le(Te, e);
            }
            return e.label.references.length == 0 ? e.body : e;
        });
        e(Be, function(e, n) {
            e.body = r(e.body, n);
            return e;
        });
        e(Se, function(e, n) {
            e.body = r(e.body, n);
            switch (e.body.length) {
              case 1:
                return e.body[0];

              case 0:
                return le(Te, e);
            }
            return e;
        });
        e(Ie, function(e, n) {
            e.body = r(e.body, n);
            if (n.option("side_effects") && e.body.length == 1 && e.body[0] === n.has_directive("use strict")) {
                e.body.length = 0;
            }
            return e;
        });
        Re.DEFMETHOD("drop_unused", function(g) {
            if (!g.option("unused")) return;
            if (g.has_directive("use asm")) return;
            var b = this;
            if (b.pinned()) return;
            var y = !(b instanceof Pe) || g.toplevel.funcs;
            var x = !(b instanceof Pe) || g.toplevel.vars;
            var w = /keep_assign/.test(g.option("unused")) ? ge : function(e, n) {
                var t;
                if (e instanceof wn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof mn) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(g.option("pure_getters"))) {
                    while (t instanceof dn && !t.expression.may_throw_on_access(g)) {
                        if (t instanceof _n) n.unshift(t.property);
                        t = t.expression;
                    }
                }
                if (!(t instanceof $n)) return;
                if (g.exposed(t.definition())) return;
                if (!ye(t.definition().orig, function(e) {
                    return !(e instanceof On);
                })) return;
                return t;
            };
            var u = [];
            var A = Object.create(null);
            var E = Object.create(null);
            var c = Object.create(null);
            var l = Object.create(null);
            if (b instanceof Pe && g.top_retain) {
                b.variables.each(function(e) {
                    if (g.top_retain(e) && !(e.id in A)) {
                        A[e.id] = true;
                        u.push(e);
                    }
                });
            }
            var k = new xe();
            var p = new xe();
            var D = this;
            var h = new Jn(function(e, n) {
                if (e instanceof Ie && e.uses_arguments && !h.has_directive("use strict")) {
                    e.argnames.forEach(function(e) {
                        var n = e.definition();
                        if (!(n.id in A)) {
                            A[n.id] = true;
                            u.push(n);
                        }
                    });
                }
                if (e === b) return;
                if (e instanceof Ye) {
                    var t = e.name.definition();
                    if (!y && D === b) {
                        if (!(t.id in A)) {
                            A[t.id] = true;
                            u.push(t);
                        }
                    }
                    p.add(t.id, e);
                    return true;
                }
                if (e instanceof Sn && D === b) {
                    k.add(e.definition().id, e);
                }
                if (e instanceof fn && D === b) {
                    e.definitions.forEach(function(e) {
                        var n = e.name.definition();
                        k.add(n.id, e);
                        if (!x) {
                            if (!(n.id in A)) {
                                A[n.id] = true;
                                u.push(n);
                            }
                        }
                        if (e.value) {
                            p.add(n.id, e.value);
                            if (e.value.has_side_effects(g)) {
                                e.value.walk(h);
                            }
                            if (!n.chained && e.name.fixed_value(true) === e.value) {
                                E[n.id] = e;
                            }
                        }
                    });
                    return true;
                }
                return r(e, n, true);
            });
            b.walk(h);
            h = new Jn(r);
            for (var e = 0; e < u.length; e++) {
                var n = p.get(u[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(h);
                });
            }
            var F = g.option("keep_fnames") ? ge : g.option("ie8") ? function(e) {
                return !g.exposed(e) && !e.references.length;
            } : function(e) {
                return !(e.id in A) || e.orig.length > 1;
            };
            var C = [];
            var B = [];
            var S = [];
            var T = new it(function(c, e, n) {
                var l = T.parent();
                if (x) {
                    var t = [], r = w(c, t);
                    if (r) {
                        var i = r.definition();
                        var o = i.id in A;
                        var a;
                        if (c instanceof wn) {
                            if (!o || c.left === r && i.id in E && E[i.id] !== c) {
                                a = $(c);
                                if (c.write_only === true) {
                                    a = a.drop_side_effect_free(g) || le(Hn, c, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!o) {
                            a = le(Hn, c, {
                                value: 0
                            });
                        }
                        if (a) {
                            if (l instanceof hn && l.tail_node() !== c) {
                                a = a.drop_side_effect_free(g);
                            }
                            if (a) t.push(a);
                            switch (t.length) {
                              case 0:
                                return be.skip;

                              case 1:
                                return pe(g, l, c, t[0].transform(T));

                              default:
                                return U(c, t.map(function(e) {
                                    return e.transform(T);
                                }));
                            }
                        }
                    }
                }
                if (c instanceof ln) B.push(c);
                if (D !== b) return;
                if (c instanceof Le && c.name && F(c.name.definition())) {
                    C.push(c);
                }
                if (c instanceof Ie && !(c instanceof Ue)) {
                    var s = g.drop_fargs(c, l);
                    for (var f = c.argnames, u = f.length; --u >= 0; ) {
                        var r = f[u];
                        if (!(r.definition().id in A)) {
                            r.__unused = true;
                            if (s) {
                                O(r, "Dropping unused function argument {name} [{file}:{line},{col}]", z(r));
                                f.pop();
                            }
                        } else {
                            s = false;
                        }
                    }
                    S.push(c);
                }
                if (y && c instanceof Ye && c !== b) {
                    var i = c.name.definition();
                    if (!(i.id in A)) {
                        O(c.name, "Dropping unused function {name} [{file}:{line},{col}]", z(c.name));
                        i.eliminated++;
                        return le(Te, c);
                    }
                }
                if (c instanceof fn && !(l instanceof He && l.init === c)) {
                    var p = [], h = [], d = [];
                    var v = [];
                    c.definitions.forEach(function(e) {
                        if (e.value) e.value = e.value.transform(T);
                        var n = e.name.definition();
                        if (!x || n.id in A) {
                            if (e.value && n.id in E && E[n.id] !== e) {
                                e.value = e.value.drop_side_effect_free(g);
                            }
                            var t = k.get(n.id);
                            if (t.length > 1 && (!e.value || n.orig.indexOf(e.name) > n.eliminated)) {
                                Ae.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", z(e.name));
                                if (e.value) {
                                    var r = le($n, e.name, e.name);
                                    n.references.push(r);
                                    var i = le(wn, e, {
                                        operator: "=",
                                        left: r,
                                        right: e.value
                                    });
                                    if (E[n.id] === e) {
                                        E[n.id] = i;
                                    }
                                    v.push(i.transform(T));
                                }
                                I(t, e);
                                n.eliminated++;
                                return;
                            }
                            if (!e.value) {
                                h.push(e);
                            } else if (g.option("functions") && !g.option("ie8") && e.value === e.name.fixed_value() && e.value instanceof Le && !(e.value.name && e.value.name.definition().assignments) && u(e.value, e.name.name) && (!g.has_directive("use strict") || l instanceof Re)) {
                                Ae.warn("Declaring {name} as function [{file}:{line},{col}]", z(e.name));
                                var o = le(Ye, e, e.value);
                                o.name = le(Tn, e.name, e.name);
                                var a = e.name.scope.resolve().def_function(o.name);
                                if (e.value.name) {
                                    var s = e.value.name.definition();
                                    e.value.walk(new Jn(function(e) {
                                        if (e instanceof $n && e.definition() === s) {
                                            e.name = a.name;
                                            e.thedef = a;
                                            e.reference({});
                                        }
                                    }));
                                }
                                p.push(o);
                            } else {
                                if (v.length > 0) {
                                    if (d.length > 0) {
                                        v.push(e.value);
                                        e.value = U(e.value, v);
                                    } else {
                                        p.push(le(Fe, c, {
                                            body: U(c, v)
                                        }));
                                    }
                                    v = [];
                                }
                                d.push(e);
                            }
                        } else if (n.orig[0] instanceof zn) {
                            var f = e.value && e.value.drop_side_effect_free(g);
                            if (f) v.push(f);
                            e.value = null;
                            h.push(e);
                        } else {
                            var f = e.value && !e.value.single_use && e.value.drop_side_effect_free(g);
                            if (f) {
                                Ae.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", z(e.name));
                                v.push(f);
                            } else {
                                O(e.name, "Dropping unused variable {name} [{file}:{line},{col}]", z(e.name));
                            }
                            n.eliminated++;
                        }
                        function u(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                    });
                    if (h.length > 0 || d.length > 0) {
                        c.definitions = h.concat(d);
                        p.push(c);
                    }
                    if (v.length > 0) {
                        p.push(le(Fe, c, {
                            body: U(c, v)
                        }));
                    }
                    switch (p.length) {
                      case 0:
                        return n ? be.skip : le(Te, c);

                      case 1:
                        return p[0];

                      default:
                        return n ? be.splice(p) : le(Se, c, {
                            body: p
                        });
                    }
                }
                if (c instanceof Oe && c.body instanceof je) {
                    e(c, this);
                    if (c.body instanceof Se) {
                        var _ = c.body;
                        c.body = _.body.pop();
                        _.body.push(c);
                        return n ? be.splice(_.body) : _;
                    }
                    return c;
                }
                if (c instanceof Re) {
                    var m = D;
                    D = c;
                    e(c, this);
                    D = m;
                    return c;
                }
            }, function(e, n) {
                if (e instanceof je) {
                    var t;
                    if (e.init instanceof Se) {
                        t = e.init;
                        e.init = t.body.pop();
                        t.body.push(e);
                    }
                    if (e.init instanceof Ye) {
                        if (!t) {
                            t = le(Se, e, {
                                body: [ e ]
                            });
                        }
                        t.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Fe) {
                        e.init = e.init.body;
                    } else if (Y(e.init)) {
                        e.init = null;
                    }
                    return !t ? e : n ? be.splice(t.body) : t;
                } else if (e instanceof He) {
                    if (!x || !g.option("loops")) return;
                    if (!(e.init instanceof fn)) return;
                    var r = e.init.definitions[0].name;
                    if (r.definition().id in A) return;
                    if (!Y(e.body)) return;
                    O(r, "Dropping unused loop variable {name} [{file}:{line},{col}]", z(r));
                    var i = e.object.drop_side_effect_free(g);
                    if (i) {
                        Ae.warn("Side effects in object of for-in loop [{file}:{line},{col}]", z(r));
                        return le(Fe, e, {
                            body: i
                        });
                    }
                    return n ? be.skip : le(Te, e);
                } else if (e instanceof hn) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            T.push(g.parent());
            b.transform(T);
            C.forEach(function(e) {
                e.name = null;
            });
            B.forEach(function(e) {
                Z(e, g, S);
            });
            function O(e, n, t) {
                Ae[e.unreferenced() ? "warn" : "info"](n, t);
            }
            function z(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function d(e, n, t) {
                if (e.id in A) return;
                if (n && t) {
                    A[e.id] = true;
                    u.push(e);
                } else {
                    c[e.id] = n;
                    l[e.id] = t;
                }
            }
            function $(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof yn && de[n.operator])) return n;
                var t = e.left;
                if (!(t instanceof $n) || t.name != n.left.name) return n;
                return n.right.has_side_effects(g) ? n : n.right;
            }
            function r(e, n, t) {
                var r, i = [], o = w(e, i);
                if (o && b.variables.get(o.name) === (r = o.definition())) {
                    i.forEach(function(e) {
                        e.walk(h);
                    });
                    if (e instanceof wn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(g)) return;
                        var a = $(e);
                        if (t && e.write_only === true && r.scope === b && !a.has_side_effects(g)) {
                            p.add(r.id, a);
                        } else {
                            a.walk(h);
                        }
                        if (e.left === o) {
                            if (!r.chained && o.fixed_value(true) === a) {
                                E[r.id] = e;
                            }
                            if (!e.write_only) {
                                d(r, true, l[r.id]);
                            }
                        } else {
                            var s = o.fixed_value();
                            if (!s || !s.is_constant()) {
                                d(r, c[r.id], true);
                            }
                        }
                    }
                    return true;
                }
                if (e instanceof $n) {
                    r = e.definition();
                    if (!(r.id in A)) {
                        A[r.id] = true;
                        u.push(r);
                    }
                    return true;
                }
                if (e instanceof Re) {
                    var f = D;
                    D = e;
                    n();
                    D = f;
                    return true;
                }
            }
        });
        Re.DEFMETHOD("hoist_declarations", function(i) {
            if (i.has_directive("use asm")) return;
            var o = i.option("hoist_funs");
            var a = i.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new Jn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Re && e !== s) return true;
                    if (e instanceof un) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var f = [];
            var u = [];
            var c = new xe(), l = 0;
            var p = new it(function(e) {
                if (e === s) return;
                if (e instanceof De) {
                    f.push(e);
                    return le(Te, e);
                }
                if (o && e instanceof Ye && (p.parent() === s || !i.has_directive("use strict"))) {
                    u.push(e);
                    return le(Te, e);
                }
                if (a && e instanceof un) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments(i);
                    var t = p.parent();
                    if (t instanceof He && t.init === e) {
                        if (n) return n;
                        var r = e.definitions[0].name;
                        return le($n, r, r);
                    }
                    if (t instanceof je && t.init === e) return n;
                    if (!n) return le(Te, e);
                    return le(Fe, e, {
                        body: n
                    });
                }
                if (e instanceof Re) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof Ie && !ye(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof Fe) {
                            var r = s.body[e].body, h, d;
                            if (r instanceof wn && r.operator == "=" && (h = r.left) instanceof Fn && c.has(h.name)) {
                                var v = c.get(h.name);
                                if (v.value) break;
                                v.value = r.right;
                                I(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (r instanceof hn && (d = r.expressions[0]) instanceof wn && d.operator == "=" && (h = d.left) instanceof Fn && c.has(h.name)) {
                                var v = c.get(h.name);
                                if (v.value) break;
                                v.value = d.right;
                                I(t, v);
                                t.push(v);
                                s.body[e].body = U(r, r.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Te) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof Se) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = le(un, s, {
                        definitions: t
                    });
                    u.push(t);
                }
            }
            s.body = f.concat(u, s.body);
        });
        function c(n, t) {
            n.walk(new Jn(function(e) {
                if (e instanceof Je) {
                    t(e);
                    return true;
                }
                if (e instanceof Re && e !== n) return true;
            }));
        }
        function p(e) {
            var r = Object.create(null);
            c(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof $n) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function h(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length && !t.exposed(e);
        }
        function m(e, r) {
            c(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(r, true);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? U(e.value, [ n, le(Hn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof Ae)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? U(e.value, [ n, le(Hn, e.value, {
                            value: 1
                        }) ]) : le(Hn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Re.DEFMETHOD("process_boolean_returns", ie);
        Ye.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = p(this);
            if (!h(this.name.definition(), n, e)) return;
            m(this, e);
        });
        Le.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = p(this);
            if (this.name && !h(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof wn) {
                if (t.operator != "=") return;
                var r = t.left;
                if (!(r instanceof $n)) return;
                if (!h(r.definition(), n, e)) return;
            } else if (t instanceof ln && t.expression !== this) {
                var i = t.expression;
                if (i instanceof $n) i = i.fixed_value();
                if (!(i instanceof Ie)) return;
                if (i.uses_arguments || i.pinned()) return;
                var r = i.argnames[t.args.indexOf(this)];
                if (r && !h(r.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var o = e.in_boolean_context();
                e.push(this);
                if (!o) return;
            } else return;
            m(this, e);
        });
        Re.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Re.DEFMETHOD("make_var_name", function(e) {
            var n = this.var_names();
            e = e.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var t = e;
            for (var r = 0; n[t]; r++) t = e + "$" + r;
            n[t] = true;
            return t;
        });
        Re.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var i = f instanceof Pe && e.top_retain || ge;
            var u = Object.create(null);
            f.transform(new it(function(r, e) {
                if (r instanceof wn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (r.left.scope !== f) return;
                    if (!t(r.left, r.right, 1)) return;
                    e(r, this);
                    var i = new xe();
                    var o = [];
                    var a = [];
                    r.right.properties.forEach(function(e) {
                        var n = s(r.left, e.key);
                        a.push(le(cn, r, {
                            name: n,
                            value: null
                        }));
                        var t = le($n, r, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(le(wn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[r.left.definition().id] = i;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, le(un, r, {
                        definitions: a
                    }));
                    return U(r, o);
                }
                if (r instanceof Re) return r === f ? undefined : r;
                if (r instanceof cn) {
                    if (!t(r.name, r.value, 0)) return;
                    e(r, this);
                    var i = new xe();
                    var n = [];
                    r.value.properties.forEach(function(e) {
                        n.push(le(cn, r, {
                            name: s(r.name, e.key),
                            value: e.value
                        }));
                    });
                    u[r.name.definition().id] = i;
                    return be.splice(n);
                }
                function s(e, n) {
                    var t = le(Bn, e, {
                        name: f.make_var_name(e.name + "_" + n),
                        scope: f
                    });
                    var r = f.def_variable(t);
                    i.set(n, r);
                    f.enclosed.push(r);
                    return t;
                }
            }));
            f.transform(new it(function(e, n) {
                if (e instanceof dn) {
                    if (!(e.expression instanceof $n)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    var r = t.get(e.getProperty());
                    var i = le($n, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference({});
                    return i;
                }
                if (e instanceof mn) {
                    if (y[e.operator]) return;
                    if (!(e.expression instanceof $n)) return;
                    if (!(e.expression.definition().id in u)) return;
                    var o = e.clone();
                    o.expression = le(En, e, {
                        properties: []
                    });
                    return o;
                }
            }));
            function t(e, n, t) {
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.direct_access) return;
                if (r.escaped.depth == 1) return;
                if (r.references.length == t) return;
                if (r.single_use) return;
                if (i(r)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof En;
            }
        });
        function K(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return ye(t.references, function(e) {
                return !(e instanceof $n);
            });
        }
        (function(e) {
            function o(e, n, t) {
                var r = e.length;
                if (!r) return null;
                var i = [], o = false;
                for (var a = 0; a < r; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        i.push(s);
                        t = false;
                    }
                }
                return o ? i.length ? i : null : e;
            }
            e(Ae, N);
            e(Ue, R);
            e(An, function(e, n) {
                var t = o(this.elements, e, n);
                return t && U(this, t);
            });
            e(wn, function(e) {
                var n = this.left;
                if (n instanceof dn) {
                    var t = n.expression;
                    if (t instanceof wn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (he(n).is_constant_expression(e.find_parent(Re))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(yn, function(e, n) {
                var t = this.right.drop_side_effect_free(e, n);
                if (!t) return this.left.drop_side_effect_free(e, n);
                if (de[this.operator] && !(t instanceof Le)) {
                    var r = this;
                    if (t !== r.right) {
                        r = this.clone();
                        r.right = t.drop_side_effect_free(e);
                    }
                    return (n ? a : D)(r, le(yn, this, {
                        operator: r.operator == "&&" ? "||" : "&&",
                        left: r.left.negate(e, n),
                        right: r.right
                    }));
                } else {
                    var i = this.left.drop_side_effect_free(e, n);
                    if (!i) return t;
                    return U(this, [ i, t.drop_side_effect_free(e) ]);
                }
            });
            e(ln, function(t, e) {
                if (!this.is_expr_pure(t)) {
                    var n = this.expression;
                    if (this.is_call_pure(t)) {
                        var r = this.args.slice();
                        r.unshift(n.expression);
                        r = o(r, t, e);
                        return r && U(this, r);
                    }
                    if (n instanceof Le && (!n.name || !n.name.definition().references.length)) {
                        n.process_expression(false, function(e) {
                            var n = e.value && e.value.drop_side_effect_free(t, true);
                            return n ? le(Fe, e, {
                                body: n
                            }) : le(Te, e);
                        });
                        c(n, function(e) {
                            if (e.value) e.value = e.value.drop_side_effect_free(t);
                        });
                        return this.clone();
                    }
                    return this;
                }
                if (this.pure) Ae.warn("Dropping __PURE__ call [{file}:{line},{col}]", this.start);
                var i = o(this.args, t, e);
                return i && U(this, i);
            });
            e(xn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                if (!n) return t ? le(yn, this, {
                    operator: "||",
                    left: this.condition,
                    right: t
                }) : this.condition.drop_side_effect_free(e);
                if (!t) return le(yn, this, {
                    operator: "&&",
                    left: this.condition,
                    right: n
                });
                var r = this.clone();
                r.consequent = n;
                r.alternative = t;
                return r;
            });
            e(qn, R);
            e(vn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(Le, function(e) {
                return K(this, e) ? null : this;
            });
            e(En, function(e, n) {
                var t = o(this.properties, e, n);
                return t && U(this, t);
            });
            e(kn, function(e, n) {
                return this.value.drop_side_effect_free(e, n);
            });
            e(hn, function(e, n) {
                var t = o(this.expressions, e, n);
                if (t === this.expressions) return this;
                if (!t) return null;
                return U(this, t);
            });
            e(_n, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var r = this.property.drop_side_effect_free(e);
                if (!r) return t;
                return U(this, [ t, r ]);
            });
            e($n, function(e) {
                if (!this.is_declared(e)) return this;
                this.definition().replaced++;
                return null;
            });
            e(Mn, R);
            e(mn, function(e, n) {
                if (y[this.operator]) {
                    this.write_only = !this.expression.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && this.expression instanceof $n) {
                    this.expression.definition().replaced++;
                    return null;
                }
                var t = this.expression.drop_side_effect_free(e, n);
                if (n && t && V(t)) {
                    if (t === this.expression && this.operator == "!") return this;
                    return t.negate(e, n);
                }
                return t;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Fe, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    Ae.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return le(Te, e);
                }
                if (r !== t) {
                    return le(Fe, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(qe, function(e, n) {
            return n.option("loops") ? le(je, e, e).optimize(n) : e;
        });
        function w(n, e) {
            var t = false;
            var r = new Jn(function(e) {
                if (t || e instanceof Re) return true;
                if (e instanceof Xe && r.loopcontrol_target(e) === n) {
                    return t = true;
                }
            });
            if (e instanceof Oe) r.push(e);
            r.push(n);
            n.body.walk(r);
            return t;
        }
        e(Me, function(e, n) {
            if (!n.option("loops")) return e;
            var t = e.condition.is_truthy() || e.condition.evaluate(n, true);
            if (!(t instanceof Ae)) {
                if (t) return le(je, e, {
                    body: le(Se, e.body, {
                        body: [ e.body, le(Fe, e.condition, {
                            body: e.condition
                        }) ]
                    })
                }).optimize(n);
                if (!w(e, n.parent())) {
                    return le(Se, e.body, {
                        body: [ e.body, le(Fe, e.condition, {
                            body: e.condition
                        }) ]
                    }).optimize(n);
                }
            }
            if (e.body instanceof Fe) return le(je, e, {
                condition: U(e.condition, [ e.body.body, e.condition ]),
                body: le(Te, e)
            }).optimize(n);
            return e;
        });
        function g(n, t) {
            var e = a(n.body);
            if (t.option("dead_code") && (e instanceof Ke || e instanceof Qe && s(e) || e instanceof We)) {
                var r = [];
                if (n.init instanceof Ee) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(le(Fe, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof We;
                if (n.condition && i) {
                    r.push(le(Ze, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(le(Fe, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                x(n.body, r);
                return le(Se, n, {
                    body: r
                });
            }
            if (e instanceof Ze) {
                var o = a(e.body);
                if (o instanceof Ke && !s(o)) {
                    if (n.condition) {
                        n.condition = le(yn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = E(e.alternative);
                    x(e.body, r);
                    return f(r);
                }
                o = a(e.alternative);
                if (o instanceof Ke && !s(o)) {
                    if (n.condition) {
                        n.condition = le(yn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = E(e.body);
                    x(e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function a(e) {
                return e instanceof Se ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof Se) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = le(Se, n.body, {
                        body: e
                    }).transform(t);
                }
                return g(n, t);
            }
        }
        e(je, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof Ae) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var r = e.condition;
                    e.condition = A(t, e.condition);
                    e.condition = D(e.condition.transform(n), r);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var i = [];
                        x(e.body, i);
                        if (e.init instanceof Ee) {
                            i.push(e.init);
                        } else if (e.init) {
                            i.push(le(Fe, e.init, {
                                body: e.init
                            }));
                        }
                        i.push(le(Fe, e.condition, {
                            body: e.condition
                        }));
                        return le(Se, e, {
                            body: i
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof Ae)) {
                    e.body = le(Se, e.body, {
                        body: [ le(Fe, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return g(e, n);
        });
        function B(e, n, t, r) {
            if (!(e instanceof yn)) return;
            if (!(e.left instanceof jn)) {
                if (!r) r = e.operator;
                if (e.operator != r) return;
                switch (r) {
                  case "&&":
                  case "||":
                    B(e.left, n, t, r);
                    B(e.right, n, t, r);
                    break;
                }
                return;
            }
            if (!(e.right instanceof gn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!W(i)) return;
            var o;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                o = a ? t : n;
                break;

              case "!=":
                o = a ? n : t;
                break;

              default:
                return;
            }
            if (!o) return;
            var s = i.definition();
            var f = new Jn(function(e) {
                if (e instanceof Re) {
                    var n = f.parent();
                    if (n instanceof ln && n.expression === e) return;
                    return true;
                }
                if (e instanceof $n && e.definition() === s) e.defined = true;
            });
            o.walk(f);
        }
        e(Ze, function(e, n) {
            if (Y(e.alternative)) e.alternative = null;
            if (!n.option("conditionals")) return e;
            var t = e.condition.evaluate(n);
            if (!n.option("dead_code") && !(t instanceof Ae)) {
                var r = e.condition;
                e.condition = A(t, r);
                e.condition = D(e.condition.transform(n), r);
            }
            if (n.option("dead_code")) {
                if (t instanceof Ae) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                }
                if (!t) {
                    Ae.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [];
                    x(e.body, i);
                    i.push(le(Fe, e.condition, {
                        body: e.condition
                    }));
                    if (e.alternative) i.push(e.alternative);
                    return le(Se, e, {
                        body: i
                    }).optimize(n);
                } else if (!(t instanceof Ae)) {
                    Ae.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [];
                    if (e.alternative) x(e.alternative, i);
                    i.push(le(Fe, e.condition, {
                        body: e.condition
                    }));
                    i.push(e.body);
                    return le(Se, e, {
                        body: i
                    }).optimize(n);
                }
            }
            var o = e.condition.negate(n);
            var a = e.condition.print_to_string().length;
            var s = o.print_to_string().length;
            var f = s < a;
            if (e.alternative && f) {
                f = false;
                e.condition = o;
                var u = e.body;
                e.body = e.alternative || le(Te, e);
                e.alternative = u;
            }
            if (e.body instanceof Fe && e.alternative instanceof Fe) {
                return le(Fe, e, {
                    body: le(xn, e, {
                        condition: e.condition,
                        consequent: e.body.body,
                        alternative: e.alternative.body
                    })
                }).optimize(n);
            }
            if (Y(e.alternative) && e.body instanceof Fe) {
                if (a === s && !f && e.condition instanceof yn && e.condition.operator == "||") {
                    f = true;
                }
                if (f) return le(Fe, e, {
                    body: le(yn, e, {
                        operator: "||",
                        left: o,
                        right: e.body.body
                    }).transform(n)
                }).optimize(n);
                return le(Fe, e, {
                    body: le(yn, e, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.body
                    }).transform(n)
                }).optimize(n);
            }
            if (Y(e.body)) {
                if (Y(e.alternative)) return le(Fe, e.condition, {
                    body: e.condition.clone()
                }).optimize(n);
                if (e.alternative instanceof Fe) return le(Fe, e, {
                    body: le(yn, e, {
                        operator: "||",
                        left: e.condition,
                        right: e.alternative.body
                    }).transform(n)
                }).optimize(n);
                e = le(Ze, e, {
                    condition: o,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof We && e.alternative instanceof We && e.body.TYPE == e.alternative.TYPE) {
                var c = le(e.body.CTOR, e, {
                    value: le(xn, e, {
                        condition: e.condition,
                        consequent: e.body.value || le(In, e.body).transform(n),
                        alternative: e.alternative.value || le(In, e.alternative).transform(n)
                    })
                });
                if (c instanceof Je) {
                    c.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return c;
            }
            if (e.body instanceof Ze && !e.body.alternative && !e.alternative) {
                e = le(Ze, e, {
                    condition: le(yn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (F(e.body)) {
                if (e.alternative) {
                    var l = e.alternative;
                    e.alternative = null;
                    return le(Se, e, {
                        body: [ e, l ]
                    }).optimize(n);
                }
            }
            if (F(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = f ? o : e.condition.negate(n);
                e.alternative = null;
                return le(Se, e, {
                    body: [ e, i ]
                }).optimize(n);
            }
            if (n.option("typeofs")) B(e.condition, e.body, e.alternative);
            return e;
        });
        e(en, function(t, e) {
            if (!e.option("switches")) return t;
            var n;
            var r = t.expression.evaluate(e);
            if (!(r instanceof Ae)) {
                var i = t.expression;
                t.expression = A(r, i);
                t.expression = D(t.expression.transform(e), i);
            }
            if (!e.option("dead_code")) return t;
            if (r instanceof Ae) {
                r = t.expression.evaluate(e, true);
            }
            var o = [];
            var a = [];
            var s;
            var f;
            for (var u = 0, c = t.body.length; u < c && !f; u++) {
                n = t.body[u];
                if (n instanceof tn) {
                    var l = a[a.length - 1];
                    if (s || g(n.body[0], e) && (!l || F(l))) {
                        y(n, l);
                        continue;
                    } else {
                        s = n;
                    }
                } else if (!(r instanceof Ae)) {
                    var p = n.expression.evaluate(e);
                    if (!(p instanceof Ae) && p !== r) {
                        y(n, a[a.length - 1]);
                        continue;
                    }
                    if (p instanceof Ae) p = n.expression.evaluate(e, true);
                    if (p === r) {
                        f = n;
                        if (s) {
                            var h = a.indexOf(s);
                            a.splice(h, 1);
                            y(s, a[h - 1]);
                            s = null;
                        }
                    }
                }
                if (F(n)) {
                    var l = a[a.length - 1];
                    if (F(l) && l.body.length == n.body.length && le(Se, l, l).equivalent_to(le(Se, n, n))) {
                        l.body = [];
                    }
                }
                a.push(n);
            }
            while (u < c) y(t.body[u++], a[a.length - 1]);
            while (n = a[a.length - 1]) {
                var d = n.body[n.body.length - 1];
                if (g(d, e)) n.body.pop();
                if (n === s) {
                    if (!b(n)) break;
                } else if (n.expression.has_side_effects(e)) {
                    break;
                } else if (s) {
                    if (!b(s)) break;
                    if (a[a.length - 2] !== s) break;
                    s.body = s.body.concat(n.body);
                    n.body = [];
                } else if (!b(n)) break;
                y(n);
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return le(Se, t, {
                    body: o.concat(le(Fe, t.expression, {
                        body: t.expression
                    }))
                }).optimize(e);
            }
            a[0].body = o.concat(a[0].body);
            t.body = a;
            if (a.length == 1 && (a[0] === f || a[0] === s)) {
                var v = false;
                var _ = new Jn(function(e) {
                    if (v || e instanceof Ie || e instanceof Fe) return true;
                    if (g(e, _)) v = true;
                });
                t.walk(_);
                if (!v) {
                    var m = a[0].body.slice();
                    var p = a[0].expression;
                    if (p) m.unshift(le(Fe, p, {
                        body: p
                    }));
                    m.unshift(le(Fe, t.expression, {
                        body: t.expression
                    }));
                    return le(Se, t, {
                        body: m
                    }).optimize(e);
                }
            }
            return t;
            function g(e, n) {
                return e instanceof Ke && n.loopcontrol_target(e) === t;
            }
            function b(e) {
                return ye(e.body, function(e) {
                    return Y(e) || e instanceof Ye || e instanceof un && ye(e.definitions, function(e) {
                        return !e.value;
                    });
                });
            }
            function y(e, n) {
                if (n && !F(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    x(e, o);
                }
            }
        });
        e(on, function(e, n) {
            e.body = r(e.body, n);
            if (e.bcatch && e.bfinally && ye(e.bfinally.body, Y)) e.bfinally = null;
            if (n.option("dead_code") && ye(e.body, Y)) {
                var t = [];
                if (e.bcatch) {
                    x(e.bcatch, t);
                    t.forEach(function(e) {
                        if (!(e instanceof fn)) return;
                        e.definitions.forEach(function(e) {
                            var n = e.name.definition().redefined();
                            if (!n) return;
                            e.name = e.name.clone();
                            e.name.thedef = n;
                        });
                    });
                }
                if (e.bfinally) t = t.concat(e.bfinally.body);
                return le(Se, e, {
                    body: t
                }).optimize(n);
            }
            return e;
        });
        fn.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        fn.DEFMETHOD("to_assignments", function(e) {
            var r = e.option("reduce_vars");
            var n = this.definitions.reduce(function(e, n) {
                if (n.value) {
                    var t = le($n, n.name, n.name);
                    e.push(le(wn, n, {
                        operator: "=",
                        left: t,
                        right: n.value
                    }));
                    if (r) t.definition().fixed = false;
                }
                n = n.name.definition();
                n.eliminated++;
                n.replaced--;
                return e;
            }, []);
            if (n.length == 0) return null;
            return U(this, n);
        });
        e(fn, function(e, n) {
            return e.definitions.length ? e : le(Te, e);
        });
        function Q(e, n) {
            var t = e.expression;
            if (!(t instanceof hn)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return U(e, r);
        }
        function Z(e, n, t) {
            var r = e.expression;
            var i = r instanceof $n ? r.fixed_value() : r;
            if (!(i instanceof Ie)) return;
            if (i.uses_arguments) return;
            if (i.pinned()) return;
            if (t && t.indexOf(i) < 0) return;
            var o = e.args;
            var a = 0, s = 0;
            var f = i === r && !i.name && n.drop_fargs(i, e);
            var u = [];
            for (var c = 0; c < o.length; c++) {
                var l = c >= i.argnames.length;
                if (l || i.argnames[c].__unused) {
                    var p = o[c].drop_side_effect_free(n);
                    if (f) {
                        i.argnames.splice(c, 1);
                        o.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        o[a++] = U(e, u);
                        u = [];
                    } else if (!l) {
                        if (u.length) {
                            p = U(e, u);
                            u = [];
                        } else {
                            p = le(Hn, o[c], {
                                value: 0
                            });
                        }
                        o[a++] = p;
                        continue;
                    }
                } else {
                    u.push(o[c]);
                    o[a++] = U(e, u);
                    u = [];
                }
                s = a;
            }
            if (f) for (;c < i.argnames.length; c++) {
                if (i.argnames[c].__unused) i.argnames.splice(c--, 1);
            }
            o.length = s;
            if (!u.length) return;
            var h = U(e, u);
            o.push(o.length < i.argnames.length ? le(gn, e, {
                operator: "void",
                expression: h
            }) : h);
        }
        e(ln, function(s, f) {
            var o = s.expression;
            if (f.option("sequences")) {
                if (o instanceof dn) {
                    var e = Q(o, f);
                    if (e !== o) {
                        var n = s.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(f);
                    }
                } else if (!L(f, o.tail_node())) {
                    var e = Q(s, f);
                    if (e !== s) return e.optimize(f);
                }
            }
            if (f.option("unused")) Z(s, f);
            if (f.option("unsafe")) {
                if (W(o)) switch (o.name) {
                  case "Array":
                    if (s.args.length == 1) {
                        var t = s.args[0];
                        if (t instanceof Hn) try {
                            var r = t.value;
                            if (r > 6) break;
                            var i = Array(r);
                            for (var a = 0; a < r; a++) i[a] = le(Un, s);
                            return le(An, s, {
                                elements: i
                            });
                        } catch (e) {
                            Ae.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: r,
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(f) && !t.is_string(f)) break;
                    }
                    return le(An, s, {
                        elements: s.args
                    });

                  case "Object":
                    if (s.args.length == 0) {
                        return le(En, s, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (s.args.length == 0) return le(jn, s, {
                        value: ""
                    });
                    if (s.args.length <= 1) return le(yn, s, {
                        left: s.args[0],
                        operator: "+",
                        right: le(jn, s, {
                            value: ""
                        })
                    }).optimize(f);
                    break;

                  case "Number":
                    if (s.args.length == 0) return le(Hn, s, {
                        value: 0
                    });
                    if (s.args.length == 1) return le(gn, s, {
                        expression: s.args[0],
                        operator: "+"
                    }).optimize(f);

                  case "Boolean":
                    if (s.args.length == 0) return le(Vn, s);
                    if (s.args.length == 1) return le(gn, s, {
                        expression: le(gn, s, {
                            expression: s.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(f);
                    break;

                  case "RegExp":
                    var u = [];
                    if (ye(s.args, function(e) {
                        var n = e.evaluate(f);
                        u.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return G(f, s, le(Nn, s, {
                                value: RegExp.apply(RegExp, u)
                            }));
                        } catch (e) {
                            Ae.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: s.print_to_string(),
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof vn) switch (o.property) {
                  case "toString":
                    if (s.args.length == 0 && !o.expression.may_throw_on_access(f)) {
                        return le(yn, s, {
                            left: le(jn, s, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(f);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof An) e: {
                        var c;
                        if (s.args.length > 0) {
                            c = s.args[0].evaluate(f);
                            if (c === s.args[0]) break e;
                        }
                        var i = [];
                        var l = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(f);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    i.push(le(jn, s, {
                                        value: l.join(c)
                                    }));
                                    l.length = 0;
                                }
                                i.push(e);
                            }
                        });
                        if (l.length > 0) {
                            i.push(le(jn, s, {
                                value: l.join(c)
                            }));
                        }
                        if (i.length == 0) return le(jn, s, {
                            value: ""
                        });
                        if (i.length == 1) {
                            if (i[0].is_string(f)) {
                                return i[0];
                            }
                            return le(yn, i[0], {
                                operator: "+",
                                left: le(jn, s, {
                                    value: ""
                                }),
                                right: i[0]
                            });
                        }
                        if (c == "") {
                            var t;
                            if (i[0].is_string(f) || i[1].is_string(f)) {
                                t = i.shift();
                            } else {
                                t = le(jn, s, {
                                    value: ""
                                });
                            }
                            return i.reduce(function(e, n) {
                                return le(yn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(f);
                        }
                        var p = s.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = i;
                        return G(f, s, p);
                    }
                    break;

                  case "charAt":
                    if (s.args.length < 2) {
                        var p = le(_n, s, {
                            expression: o.expression,
                            property: s.args.length ? le(yn, s.args[0], {
                                operator: "|",
                                left: le(Hn, s, {
                                    value: 0
                                }),
                                right: s.args[0]
                            }) : le(Hn, s, {
                                value: 0
                            })
                        });
                        p.is_string = oe;
                        return p.optimize(f);
                    }
                    break;

                  case "apply":
                    if (s.args.length == 2 && s.args[1] instanceof An) {
                        var h = s.args[1].elements.slice();
                        h.unshift(s.args[0]);
                        return le(ln, s, {
                            expression: le(vn, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: h
                        }).optimize(f);
                    }
                    break;

                  case "call":
                    var d = o.expression;
                    if (d instanceof $n) {
                        d = d.fixed_value();
                    }
                    if (d instanceof Ie && !d.contains_this()) {
                        return (s.args.length ? U(this, [ s.args[0], le(ln, s, {
                            expression: o.expression,
                            args: s.args.slice(1)
                        }) ]) : le(ln, s, {
                            expression: o.expression,
                            args: []
                        })).optimize(f);
                    }
                    break;
                }
            }
            if (f.option("unsafe_Function") && W(o) && o.name == "Function") {
                if (s.args.length == 0) return le(Le, s, {
                    argnames: [],
                    body: []
                });
                if (ye(s.args, function(e) {
                    return e instanceof jn;
                })) {
                    try {
                        var v = "n(function(" + s.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + s.args[s.args.length - 1].value + "})";
                        var _ = rt(v);
                        var m = {
                            ie8: f.option("ie8")
                        };
                        _.figure_out_scope(m);
                        var g = new st(f.options);
                        _ = _.transform(g);
                        _.figure_out_scope(m);
                        _.compute_char_frequency(m);
                        _.mangle_names(m);
                        var b;
                        _.walk(new Jn(function(e) {
                            if (b) return true;
                            if (e instanceof Ie) {
                                b = e;
                                return true;
                            }
                        }));
                        var v = at();
                        Se.prototype._codegen.call(b, b, v);
                        s.args = [ le(jn, s, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), le(jn, s.args[s.args.length - 1], {
                            value: v.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return s;
                    } catch (e) {
                        if (e instanceof Xn) {
                            Ae.warn("Error parsing code passed to new Function [{file}:{line},{col}]", s.args[s.args.length - 1].start);
                            Ae.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof $n ? o.fixed_value() : o;
            var x = y instanceof Ie;
            var w = x && y.first_statement();
            var A = f.option("inline") && !s.is_expr_pure(f);
            if (A && w instanceof Je) {
                var E = w.value;
                if (o === y && (!E || E.is_constant_expression())) {
                    var h = s.args.concat(E || le(In, s));
                    return U(s, h).optimize(f);
                }
            }
            if (x) {
                var k, E, D = false;
                if (A && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof Le) && (E = O(w)) && (o === y || !ee(f, k = o.definition()) && y.is_constant_expression(o.scope)) && !y.contains_this()) {
                    if ($()) {
                        var h = s.args.slice();
                        h.push(E.clone(true).transform(new it(function(e) {
                            if (e instanceof $n) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    if (o !== y) n.references.push(e);
                                    return e;
                                }
                                var t = z(n);
                                var r = h[t];
                                if (!r) return le(In, s);
                                h[t] = null;
                                var i = this.parent();
                                return i ? pe(f, i, e, r) : r;
                            }
                        })));
                        var p = U(s, h.filter(function(e) {
                            return e;
                        })).optimize(f);
                        p = pe(f, f.parent(), f.self(), p);
                        if (G(f, s, p) === p) return p;
                    }
                    var F, C, B = -1;
                    if ((o === y || f.option("unused") && o.definition().references.length == 1) && H()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = U(s, I()).optimize(f);
                        return pe(f, f.parent(), f.self(), p);
                    }
                }
                if (f.option("side_effects") && ye(y.body, Y) && (y !== o || K(y, f))) {
                    var h = s.args.concat(le(In, s));
                    return U(s, h).optimize(f);
                }
            }
            if (f.option("drop_console")) {
                if (o instanceof dn) {
                    var S = o.expression;
                    while (S.expression) {
                        S = S.expression;
                    }
                    if (W(S) && S.name == "console") {
                        return le(In, s).optimize(f);
                    }
                }
            }
            if (f.option("negate_iife") && f.parent() instanceof Fe && V(s)) {
                return s.negate(f, true);
            }
            return X(f, s);
            function T(e) {
                if (!e) return le(In, s);
                if (e instanceof Je) {
                    if (!e.value) return le(In, s);
                    return e.value.clone(true);
                }
                if (e instanceof Fe) {
                    return le(gn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function O(e) {
                var n = y.body.length;
                if (f.option("inline") < 3) {
                    return n == 1 && T(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = y.body[t];
                    if (r instanceof un) {
                        var i = D || !ye(r.definitions, function(e) {
                            return !e.value;
                        });
                        if (i) {
                            D = true;
                            if (e) return false;
                        }
                    } else if (r instanceof Ye || r instanceof Te) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return T(e);
            }
            function z(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function $() {
                if (D) return;
                if (f.option("inline") <= 1 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length < 2 && e.orig[0] instanceof Sn;
                })) return;
                var r = false;
                var i;
                var o = [];
                var a = false;
                E.walk(new Jn(function(e) {
                    if (r) return true;
                    if (e instanceof yn && de[e.operator] || e instanceof xn) {
                        o = null;
                        return;
                    }
                    if (e instanceof Re) return r = true;
                    var n;
                    if (e instanceof $n && y.variables.get(e.name) === (n = e.definition())) {
                        if (n.init instanceof Ye) return r = true;
                        if (_e(e, this.parent())) return r = true;
                        var t = z(n);
                        if (!(i < t)) i = t;
                        if (!o) return;
                        if (a) {
                            o = null;
                        } else {
                            o.push(y.argnames[t]);
                        }
                        return;
                    }
                    if (e.has_side_effects(f)) a = true;
                }));
                if (r) return;
                var e = s.args.length;
                if (o && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > i && y.argnames[e] === o.pop()) ;
                    e++;
                }
                var n = a && f.find_parent(Re);
                return e <= i || ye(s.args.slice(i, e), a ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(f);
                });
            }
            function M(e, n) {
                return e[n] || J[n] || F.var_names()[n];
            }
            function q(e, n, t) {
                for (var r = 0; r < y.argnames.length; r++) {
                    var i = y.argnames[r];
                    if (i.__unused) continue;
                    if (!t || M(e, i.name)) return false;
                    n[i.name] = true;
                    if (C) C.push(i.definition());
                }
                return true;
            }
            function j(e, n, t) {
                for (var r = 0; r < y.body.length; r++) {
                    var i = y.body[r];
                    if (i instanceof Ye) {
                        if (!t || M(n, i.name.name)) return false;
                        continue;
                    }
                    if (!(i instanceof un)) continue;
                    if (!t) return false;
                    for (var o = i.definitions.length; --o >= 0; ) {
                        var a = i.definitions[o].name;
                        if (M(e, a.name)) return false;
                        if (C) C.push(a.definition());
                    }
                }
                return true;
            }
            function H() {
                var e = Object.create(null);
                do {
                    F = f.parent(++B);
                    if (F instanceof an) {
                        e[F.argname.name] = true;
                    } else if (F instanceof ze) {
                        C = [];
                    } else if (F instanceof $n) {
                        if (F.fixed_value() instanceof Re) return false;
                    }
                } while (!(F instanceof Re));
                var n = (!(F instanceof Pe) || f.toplevel.vars) && (o !== y || y.parent_scope === f.find_parent(Re));
                var t = f.option("inline");
                var r = Object.create(e);
                if (!q(e, r, t >= 2 && n)) return false;
                if (!j(e, r, t >= 3 && n)) return false;
                return !C || C.length == 0 || !ne(y, C);
            }
            function N(e, n, t, r) {
                var i = t.definition();
                F.variables.set(t.name, i);
                F.enclosed.push(i);
                if (!F.var_names()[t.name]) {
                    F.var_names()[t.name] = true;
                    e.push(le(cn, t, {
                        name: t,
                        value: null
                    }));
                }
                var o = le($n, t, t);
                i.references.push(o);
                if (r) n.push(le(wn, s, {
                    operator: "=",
                    left: o,
                    right: r
                }));
            }
            function R(e, n) {
                var t = y.argnames.length;
                for (var r = s.args.length; --r >= t; ) {
                    n.push(s.args[r]);
                }
                for (r = t; --r >= 0; ) {
                    var i = y.argnames[r];
                    var o = s.args[r];
                    if (i.__unused || F.var_names()[i.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = le(Bn, i, i);
                        i.definition().orig.push(a);
                        if (!o && C) o = le(In, s);
                        N(e, n, a, o);
                    }
                }
                e.reverse();
                n.reverse();
            }
            function P(e, n) {
                var t = n.length;
                for (var r = 0; r < y.body.length; r++) {
                    var i = y.body[r];
                    if (!(i instanceof un)) continue;
                    for (var o = 0; o < i.definitions.length; o++) {
                        var a = i.definitions[o];
                        var s = a.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        N(e, n, s, a.value);
                        if (C && ye(y.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = le($n, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, le(wn, a, {
                                operator: "=",
                                left: c,
                                right: le(In, s)
                            }));
                        }
                    }
                }
            }
            function I() {
                var e = [];
                var n = [];
                R(e, n);
                P(e, n);
                n.push(E);
                var t = y.body.filter(function(e) {
                    if (e instanceof Ye) {
                        var n = e.name.definition();
                        F.functions.set(n.name, n);
                        F.variables.set(n.name, n);
                        F.enclosed.push(n);
                        F.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(F.body.indexOf(f.parent(B - 1)) + 1, 0);
                if (e.length) t.push(le(un, y, {
                    definitions: e
                }));
                [].splice.apply(F.body, t);
                y.enclosed.forEach(function(e) {
                    if (F.var_names()[e.name]) return;
                    F.enclosed.push(e);
                    F.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(pn, function(e, n) {
            if (n.option("sequences")) {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var r = e.expression;
                if (W(r)) {
                    switch (r.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return le(ln, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        e(hn, function(e, i) {
            if (!i.option("side_effects")) return e;
            var o = [];
            t();
            var n = o.length - 1;
            r();
            if (n == 0) {
                e = pe(i, i.parent(), i.self(), o[0]);
                if (!(e instanceof hn)) e = e.optimize(i);
                return e;
            }
            e.expressions = o;
            return e;
            function t() {
                var t = we(i);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(i, t);
                    if (e) {
                        d(o, e);
                        t = false;
                    }
                });
            }
            function r() {
                while (n > 0 && C(o[n], i)) n--;
                if (n < o.length - 1) {
                    o[n] = le(gn, e, {
                        operator: "void",
                        expression: o[n]
                    });
                    o.length = n + 1;
                }
            }
        });
        e(bn, function(e, n) {
            if (n.option("sequences")) {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            return e;
        });
        var S = ae("+ -");
        var T = ae("* / %");
        e(gn, function(e, n) {
            var t = e.expression;
            if (n.option("evaluate") && e.operator == "delete" && !(t instanceof $n || t instanceof dn || i(t))) {
                if (t instanceof hn) {
                    t = t.expressions.slice();
                    t.push(le(Wn, e));
                    return U(e, t).optimize(n);
                }
                return U(e, [ t, le(Wn, e) ]).optimize(n);
            }
            if (n.option("sequences")) {
                var r = Q(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && e.operator == "void") {
                t = t.drop_side_effect_free(n);
                if (t) {
                    e.expression = t;
                    return e;
                } else {
                    return le(In, e).optimize(n);
                }
            }
            if (n.option("booleans")) {
                if (e.operator == "!" && t.is_truthy()) {
                    return U(e, [ t, le(Vn, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (e.operator) {
                  case "!":
                    if (t instanceof gn && t.operator == "!") {
                        return t.expression;
                    }
                    if (t instanceof yn) {
                        e = G(n, e, t.negate(n, we(n)));
                    }
                    break;

                  case "typeof":
                    Ae.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    return (t instanceof $n ? le(Wn, e) : U(e, [ t, le(Wn, e) ])).optimize(n);
                }
            }
            if (e.operator == "-" && t instanceof Ln) t = t.transform(n);
            if (n.option("evaluate") && t instanceof yn && S[e.operator] && T[t.operator] && (t.left.is_constant() || !t.right.has_side_effects(n))) {
                return le(yn, e, {
                    operator: t.operator,
                    left: le(gn, t.left, {
                        operator: e.operator,
                        expression: t.left
                    }),
                    right: t.right
                });
            }
            return e.operator == "-" && (t instanceof Hn || t instanceof Ln) ? e : X(n, e);
        });
        yn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof dn) {
                if (!(this.left.expression instanceof hn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return U(this, n);
            }
            if (this.left instanceof hn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return U(this, n);
            }
            if (this.right instanceof hn) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof $n;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var o = 0; o < i; o++) {
                    if (!r && n[o].has_side_effects(e)) break;
                }
                if (o == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return U(this, n);
                }
                if (o > 0) {
                    var t = this.clone();
                    t.right = U(this.right, n.slice(o));
                    n = n.slice(0, o);
                    n.push(t);
                    return U(this, n);
                }
            }
            return this;
        });
        var O = ae("indexOf lastIndexOf");
        var z = ae("== === != !== * & | ^");
        function $(e) {
            return e instanceof An || e instanceof Ie || e instanceof En;
        }
        e(yn, function(t, a) {
            function r() {
                return t.left.is_constant() || t.right.is_constant() || !t.left.has_side_effects(a) && !t.right.has_side_effects(a);
            }
            function e(e) {
                if (r()) {
                    if (e) t.operator = e;
                    var n = t.left;
                    t.left = t.right;
                    t.right = n;
                }
            }
            function n() {
                var e = t.right;
                t.left = le(yn, t, {
                    operator: t.operator,
                    left: t.left,
                    right: e.left,
                    start: t.left.start,
                    end: e.left.end
                });
                t.right = e.right;
                t.left = t.left.transform(a);
            }
            if (z[t.operator] && t.right.is_constant() && !t.left.is_constant() && !(t.left instanceof yn && nt[t.left.operator] >= nt[t.operator])) {
                e();
            }
            if (a.option("sequences")) {
                var i = t.lift_sequences(a);
                if (i !== t) return i.optimize(a);
            }
            if (a.option("assignments") && de[t.operator]) {
                var o = t.right;
                if (t.left instanceof $n && o instanceof wn && o.operator == "=" && t.left.equivalent_to(o.left)) {
                    t.right = o.right;
                    o.right = t;
                    return o;
                }
            }
            if (a.option("comparisons")) switch (t.operator) {
              case "===":
              case "!==":
                if (C(t.left, a) && t.right.is_defined(a)) {
                    Ae.warn("Expression always defined [{file}:{line},{col}]", t.start);
                    return U(t, [ t.right, le(t.operator == "===" ? Vn : Wn, t) ]).optimize(a);
                }
                var s = true;
                if (t.left.is_string(a) && t.right.is_string(a) || t.left.is_number(a) && t.right.is_number(a) || t.left.is_boolean(a) && t.right.is_boolean(a) || t.left.equivalent_to(t.right)) {
                    t.operator = t.operator.substr(0, 2);
                }

              case "==":
              case "!=":
                if (!s && C(t.left, a)) {
                    t.left = le(Rn, t.left);
                } else if (a.option("typeofs") && t.left instanceof jn && t.left.value == "undefined" && t.right instanceof gn && t.right.operator == "typeof") {
                    var f = t.right.expression;
                    if (f instanceof $n ? f.is_declared(a) : !(f instanceof dn && a.option("ie8"))) {
                        t.right = f;
                        t.left = le(In, t.left).optimize(a);
                        if (t.operator.length == 2) t.operator += "=";
                    }
                } else if (t.left instanceof $n && t.right instanceof $n && t.left.definition() === t.right.definition() && $(t.left.fixed_value())) {
                    return le(t.operator[0] == "=" ? Wn : Vn, t);
                }
                break;

              case "&&":
              case "||":
                var u = t.left;
                if (u.operator == t.operator) {
                    u = u.right;
                }
                if (u instanceof yn && u.operator == (t.operator == "&&" ? "!==" : "===") && t.right instanceof yn && u.operator == t.right.operator && (C(u.left, a) && t.right.left instanceof Rn || u.left instanceof Rn && C(t.right.left, a)) && !u.right.has_side_effects(a) && u.right.equivalent_to(t.right.right)) {
                    var c = le(yn, t, {
                        operator: u.operator.slice(0, -1),
                        left: le(Rn, t),
                        right: u.right
                    });
                    if (u !== t.left) {
                        c = le(yn, t, {
                            operator: t.operator,
                            left: t.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = a.option("booleans") && a.in_boolean_context();
            if (l) switch (t.operator) {
              case "+":
                var p = t.left.evaluate(a);
                var h = t.right.evaluate(a);
                if (p && typeof p == "string") {
                    Ae.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return U(t, [ t.right, le(Wn, t) ]).optimize(a);
                }
                if (h && typeof h == "string") {
                    Ae.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return U(t, [ t.left, le(Wn, t) ]).optimize(a);
                }
                break;

              case "==":
                if (t.left instanceof jn && t.left.value == "" && t.right.is_string(a)) {
                    return le(gn, t, {
                        operator: "!",
                        expression: t.right
                    }).optimize(a);
                }
                break;

              case "!=":
                if (t.left instanceof jn && t.left.value == "" && t.right.is_string(a)) {
                    return t.right.optimize(a);
                }
                break;
            }
            var d = a.parent();
            if (a.option("comparisons") && t.is_boolean(a)) {
                if (!(d instanceof yn) || d instanceof wn) {
                    var v = le(gn, t, {
                        operator: "!",
                        expression: t.negate(a, we(a))
                    });
                    t = G(a, t, v);
                }
                switch (t.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (a.option("conditionals") && de[t.operator] && t.right instanceof yn && t.operator == t.right.operator) {
                n();
            }
            if (a.option("strings") && t.operator == "+") {
                if (t.right instanceof jn && t.right.value == "" && t.left.is_string(a)) {
                    return t.left.optimize(a);
                }
                if (t.left instanceof jn && t.left.value == "" && t.right.is_string(a)) {
                    return t.right.optimize(a);
                }
                if (t.left instanceof yn && t.left.operator == "+" && t.left.left instanceof jn && t.left.left.value == "" && t.right.is_string(a)) {
                    t.left = t.left.right;
                    return t.optimize(a);
                }
                if (t.right instanceof yn && t.operator == t.right.operator && (t.left.is_string(a) && t.right.is_string(a) || t.right.left.is_string(a) && (t.left.is_constant() || !t.right.right.has_side_effects(a)))) {
                    n();
                }
            }
            if (a.option("evaluate")) {
                var _ = true;
                switch (t.operator) {
                  case "&&":
                    var p = k(t.left);
                    if (!p) {
                        Ae.warn("Condition left of && always false [{file}:{line},{col}]", t.start);
                        return pe(a, d, a.self(), t.left).optimize(a);
                    } else if (!(p instanceof Ae)) {
                        Ae.warn("Condition left of && always true [{file}:{line},{col}]", t.start);
                        return U(t, [ t.left, t.right ]).optimize(a);
                    }
                    var h = t.right.evaluate(a);
                    if (!h) {
                        if (l) {
                            Ae.warn("Boolean && always false [{file}:{line},{col}]", t.start);
                            return U(t, [ t.left, le(Vn, t) ]).optimize(a);
                        } else t.falsy = true;
                    } else if (!(h instanceof Ae)) {
                        if (l || d.operator == "&&" && d.left === a.self()) {
                            Ae.warn("Dropping side-effect-free && [{file}:{line},{col}]", t.start);
                            return t.left.optimize(a);
                        }
                    }
                    if (t.left.operator == "||") {
                        var m = t.left.right.evaluate(a, true);
                        if (!m) return le(xn, t, {
                            condition: t.left.left,
                            consequent: t.right,
                            alternative: t.left.right
                        }).optimize(a);
                    }
                    break;

                  case "||":
                    var p = k(t.left);
                    if (!p) {
                        Ae.warn("Condition left of || always false [{file}:{line},{col}]", t.start);
                        return U(t, [ t.left, t.right ]).optimize(a);
                    } else if (!(p instanceof Ae)) {
                        Ae.warn("Condition left of || always true [{file}:{line},{col}]", t.start);
                        return pe(a, d, a.self(), t.left).optimize(a);
                    }
                    var h = t.right.evaluate(a);
                    if (!h) {
                        if (l || d.operator == "||" && d.left === a.self()) {
                            Ae.warn("Dropping side-effect-free || [{file}:{line},{col}]", t.start);
                            return t.left.optimize(a);
                        }
                    } else if (!(h instanceof Ae)) {
                        if (l) {
                            Ae.warn("Boolean || always true [{file}:{line},{col}]", t.start);
                            return U(t, [ t.left, le(Wn, t) ]).optimize(a);
                        } else t.truthy = true;
                    }
                    if (t.left.operator == "&&") {
                        var m = t.left.right.is_truthy() || t.left.right.evaluate(a, true);
                        if (m && !(m instanceof Ae)) return le(xn, t, {
                            condition: t.left.left,
                            consequent: t.left.right,
                            alternative: t.right
                        }).optimize(a);
                    }
                    break;

                  case "+":
                    if (t.left instanceof qn && t.right instanceof yn && t.right.operator == "+" && t.right.left instanceof qn && t.right.is_string(a)) {
                        t = le(yn, t, {
                            operator: "+",
                            left: le(jn, t.left, {
                                value: "" + t.left.value + t.right.left.value,
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof qn && t.left instanceof yn && t.left.operator == "+" && t.left.right instanceof qn && t.left.is_string(a)) {
                        t = le(yn, t, {
                            operator: "+",
                            left: t.left.left,
                            right: le(jn, t.right, {
                                value: "" + t.left.right.value + t.right.value,
                                start: t.left.right.start,
                                end: t.right.end
                            })
                        });
                    }
                    if (t.left instanceof yn && t.left.operator == "+" && t.left.is_string(a) && t.left.right instanceof qn && t.right instanceof yn && t.right.operator == "+" && t.right.left instanceof qn && t.right.is_string(a)) {
                        t = le(yn, t, {
                            operator: "+",
                            left: le(yn, t.left, {
                                operator: "+",
                                left: t.left.left,
                                right: le(jn, t.left.right, {
                                    value: "" + t.left.right.value + t.right.left.value,
                                    start: t.left.right.start,
                                    end: t.right.left.end
                                })
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof gn && t.right.operator == "-" && t.left.is_number(a)) {
                        t = le(yn, t, {
                            operator: "-",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }
                    if (t.left instanceof gn && t.left.operator == "-" && r() && t.right.is_number(a)) {
                        t = le(yn, t, {
                            operator: "-",
                            left: t.right,
                            right: t.left.expression
                        });
                        break;
                    }
                    if (a.option("unsafe_math") && t.left instanceof yn && nt[t.left.operator] == nt[t.operator] && t.right.is_constant() && (t.right.is_boolean(a) || t.right.is_number(a)) && t.left.is_number(a) && !t.left.right.is_constant() && (t.left.left.is_boolean(a) || t.left.left.is_number(a))) {
                        t = le(yn, t, {
                            operator: t.left.operator,
                            left: le(yn, t, {
                                operator: t.operator,
                                left: t.right,
                                right: t.left.left
                            }),
                            right: t.left.right
                        });
                        break;
                    }

                  case "-":
                    if (t.right instanceof gn && t.right.operator == "-" && t.left.is_number(a) && t.right.expression.is_number(a)) {
                        t = le(yn, t, {
                            operator: "+",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    _ = a.option("unsafe_math");
                    if (t.operator != "+") {
                        if (t.left instanceof gn && t.left.operator == "+") {
                            t.left = t.left.expression;
                        }
                        if (t.right instanceof gn && t.right.operator == "+") {
                            t.right = t.right.expression;
                        }
                    }

                  case "&":
                  case "|":
                  case "^":
                    if (t.operator != "-" && t.operator != "/" && (t.left.is_boolean(a) || t.left.is_number(a)) && (t.right.is_boolean(a) || t.right.is_number(a)) && r() && !(t.left instanceof yn && t.left.operator != t.operator && nt[t.left.operator] >= nt[t.operator])) {
                        var g = le(yn, t, {
                            operator: t.operator,
                            left: t.right,
                            right: t.left
                        });
                        if (t.right instanceof qn && !(t.left instanceof qn)) {
                            t = G(a, g, t);
                        } else {
                            t = G(a, t, g);
                        }
                    }
                    if (!_ || !t.is_number(a)) break;
                    if (t.right instanceof yn && t.right.operator != "%" && nt[t.right.operator] == nt[t.operator] && t.right.is_number(a) && (t.operator != "+" || t.right.left.is_boolean(a) || t.right.left.is_number(a)) && (t.operator != "-" || !t.left.is_negative_zero()) && (t.right.left.is_constant_expression() || !t.right.right.has_side_effects(a))) {
                        t = le(yn, t, {
                            operator: A(t.operator, t.right.operator),
                            left: le(yn, t.left, {
                                operator: t.operator,
                                left: t.left,
                                right: t.right.left,
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                        if (t.operator == "+" && !t.right.is_boolean(a) && !t.right.is_number(a)) {
                            t.right = le(gn, t.right, {
                                operator: "+",
                                expression: t.right
                            });
                        }
                    }
                    if (t.right instanceof qn && t.left instanceof yn && t.left.operator != "%" && nt[t.left.operator] == nt[t.operator] && t.left.is_number(a)) {
                        if (t.left.left instanceof qn) {
                            var u = E(t.left, t.operator, t.left.left, t.right, t.left.left.start, t.right.end);
                            t = E(t, t.left.operator, u, t.left.right);
                        } else if (t.left.right instanceof qn) {
                            var b = E(t.left, A(t.left.operator, t.operator), t.left.right, t.right, t.left.right.start, t.right.end);
                            if (t.left.operator != "-" || !t.right.value || b.evaluate(a) || !t.left.left.is_negative_zero()) {
                                t = E(t, t.left.operator, t.left.left, b);
                            }
                        }
                    }
                    break;
                }
                if (t.left instanceof Hn && !t.right.is_constant()) switch (t.operator) {
                  case "+":
                    if (t.left.value == 0) {
                        if (t.right.is_boolean(a)) return le(gn, t, {
                            operator: "+",
                            expression: t.right
                        }).optimize(a);
                        if (t.right.is_number(a) && !t.right.is_negative_zero()) return t.right;
                    }
                    break;

                  case "*":
                    if (t.left.value == 1) {
                        return t.right.is_number(a) ? t.right : le(gn, t, {
                            operator: "+",
                            expression: t.right
                        }).optimize(a);
                    }
                    break;
                }
                if (t.right instanceof Hn && !t.left.is_constant()) switch (t.operator) {
                  case "+":
                    if (t.right.value == 0) {
                        if (t.left.is_boolean(a)) return le(gn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                        if (t.left.is_number(a) && !t.left.is_negative_zero()) return t.left;
                    }
                    break;

                  case "-":
                    if (t.right.value == 0) {
                        return t.left.is_number(a) ? t.left : le(gn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                    }
                    break;

                  case "/":
                    if (t.right.value == 1) {
                        return t.left.is_number(a) ? t.left : le(gn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                    }
                    break;
                }
            }
            if (a.option("typeofs")) switch (t.operator) {
              case "&&":
                B(t.left, t.right, null, "&&");
                break;

              case "||":
                B(t.left, null, t.right, "||");
                break;
            }
            if (a.option("unsafe")) {
                var y = D(t.right);
                if (l && y && (t.operator == "==" || t.operator == "!=") && t.left instanceof Hn && t.left.value == 0) {
                    return (t.operator == "==" ? le(gn, t, {
                        operator: "!",
                        expression: t.right
                    }) : t.right).optimize(a);
                }
                var x = D(t.left);
                if (a.option("comparisons") && F()) {
                    var w = le(gn, t, {
                        operator: "!",
                        expression: le(gn, t, {
                            operator: "~",
                            expression: x ? t.left : t.right
                        })
                    });
                    switch (t.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        w = le(gn, t, {
                            operator: "!",
                            expression: w
                        });
                        break;
                    }
                    return w.optimize(a);
                }
            }
            return X(a, t);
            function A(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function E(e, n, t, r, i, o) {
                if (n == "+") {
                    if (!t.is_boolean(a) && !t.is_number(a)) {
                        t = le(gn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!r.is_boolean(a) && !r.is_number(a)) {
                        r = le(gn, r, {
                            operator: "+",
                            expression: r
                        });
                    }
                }
                return le(yn, e, {
                    operator: n,
                    left: t,
                    right: r,
                    start: i,
                    end: o
                });
            }
            function k(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(a, true);
            }
            function D(e) {
                return e instanceof ln && e.expression instanceof vn && O[e.expression.property];
            }
            function F() {
                switch (t.operator) {
                  case "<=":
                    return y && t.left instanceof Hn && t.left.value == 0;

                  case "<":
                    if (x && t.right instanceof Hn && t.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!y) return false;
                    return t.left instanceof Hn && t.left.value == -1 || t.left instanceof gn && t.left.operator == "-" && t.left.expression instanceof Hn && t.left.expression.value == 1;
                }
            }
        });
        function ee(e, n) {
            var t;
            for (var r = 0; t = e.parent(r); r++) {
                if (t instanceof Ie) {
                    var i = t.name;
                    if (i && i.definition() === n) break;
                }
            }
            return t;
        }
        e($n, function(e, n) {
            if (!n.option("ie8") && W(e) && !(e.scope.uses_with && n.find_parent(Ne))) {
                switch (e.name) {
                  case "undefined":
                    return le(In, e).optimize(n);

                  case "NaN":
                    return le(Pn, e).optimize(n);

                  case "Infinity":
                    return le(Ln, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && _e(n.self(), t) !== n.self()) {
                var r = e.definition();
                var i = e.fixed_value();
                var o = r.single_use && !(t instanceof ln && t.is_expr_pure(n));
                if (o) {
                    if (i instanceof Ie) {
                        if (r.scope !== e.scope && (!n.option("reduce_funcs") || r.escaped.depth == 1 || i.inlined)) {
                            o = false;
                        } else if (ee(n, r)) {
                            o = false;
                        } else if (r.scope !== e.scope || r.orig[0] instanceof Sn) {
                            o = i.is_constant_expression(e.scope);
                            if (o == "f") {
                                var a = e.scope;
                                do {
                                    if (a instanceof Ye || a instanceof Le) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        }
                        if (o) i.parent_scope = e.scope;
                    } else if (!i || !i.is_constant_expression()) {
                        o = false;
                    }
                }
                if (o) {
                    r.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof Ye) {
                        i = le(Le, i, i);
                        i.name = le(On, i.name, i.name);
                    }
                    if (i instanceof Ie) {
                        var a = e.scope;
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            if (a.var_names()[e.name]) return;
                            a.enclosed.push(e);
                            a.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (r.recursive_refs > 0) {
                        s = i.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof On)) {
                            c = le(On, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = r.recursive_refs;
                        }
                        s.walk(new Jn(function(e) {
                            if (!(e instanceof $n)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof Ie)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (i.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var r = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = r;
                                r.references.push(e);
                            }
                        }));
                    } else {
                        s = i.optimize(n);
                    }
                    r.replaced++;
                    return s;
                }
                if (i && r.should_replace === undefined) {
                    var l;
                    if (i instanceof Mn) {
                        if (!(r.orig[0] instanceof Sn) && m(r)) {
                            l = i;
                        }
                    } else {
                        var p = i.evaluate(n);
                        if (p !== i && (!(p instanceof RegExp) || n.option("unsafe_regexp") && !r.cross_loop && m(r))) {
                            l = A(p, i);
                        }
                    }
                    if (l) {
                        var h = l.optimize(n).print_to_string().length;
                        var d;
                        if (g(i)) {
                            d = function() {
                                var e = l.optimize(n);
                                return e === l ? e.clone(true) : e;
                            };
                        } else {
                            h = Math.min(h, i.print_to_string().length);
                            d = function() {
                                var e = D(l.optimize(n), i);
                                return e === l || e === i ? e.clone(true) : e;
                            };
                        }
                        var v = r.name.length;
                        if (n.option("unused") && !n.exposed(r)) {
                            v += (v + 2 + h) / (r.references.length - r.assignments);
                        }
                        var _ = h - Math.floor(v);
                        r.should_replace = _ < n.eval_threshold ? d : false;
                    } else {
                        r.should_replace = false;
                    }
                }
                if (r.should_replace) {
                    var s = r.should_replace();
                    r.replaced++;
                    return s;
                }
            }
            return e;
            function m(e) {
                var n = e.scope.resolve();
                return ye(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function g(e) {
                var n;
                e.walk(new Jn(function(e) {
                    if (e instanceof $n) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function M(e, n) {
            return e instanceof $n || e.TYPE === n.TYPE;
        }
        e(In, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = o(n, "undefined");
                if (t) {
                    var r = le($n, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = _e(n.self(), n.parent());
            if (i && M(i, e)) return e;
            return le(gn, e, {
                operator: "void",
                expression: le(Hn, e, {
                    value: 0
                })
            });
        });
        e(Ln, function(e, n) {
            var t = _e(n.self(), n.parent());
            if (t && M(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !M(t, e)) && !o(n, "Infinity")) return e;
            return le(yn, e, {
                operator: "/",
                left: le(Hn, e, {
                    value: 1
                }),
                right: le(Hn, e, {
                    value: 0
                })
            });
        });
        e(Pn, function(e, n) {
            var t = _e(n.self(), n.parent());
            if (t && !M(t, e) || o(n, "NaN")) {
                return le(yn, e, {
                    operator: "/",
                    left: le(Hn, e, {
                        value: 0
                    }),
                    right: le(Hn, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function ne(t, n) {
            var r = false;
            var i = new Jn(function(e) {
                if (r) return true;
                if (e instanceof $n && me(e.definition(), n)) {
                    return r = true;
                }
            });
            var o = new Jn(function(e) {
                if (r) return true;
                if (e instanceof Re && e !== t) {
                    var n = o.parent();
                    if (n instanceof ln && n.expression === e) return;
                    e.walk(i);
                    return true;
                }
            });
            t.walk(o);
            return r;
        }
        var q = ae("+ - * / % >> << >>> | ^ &");
        var j = ae("* | ^ &");
        e(wn, function(o, a) {
            if (a.option("dead_code")) {
                if (o.left instanceof dn) {
                    if (o.operator == "=") {
                        var e = o.left.expression;
                        if (e instanceof Ie || !a.has_directive("use strict") && e instanceof qn && !e.may_throw_on_access(a)) {
                            return o.left instanceof vn ? o.right : U(o, [ o.left.property, o.right ]).optimize(a);
                        }
                    }
                } else if (o.left instanceof $n) {
                    if (o.left.is_immutable()) return p();
                    var n = o.left.definition();
                    var s = n.scope.resolve();
                    var t = s === a.find_parent(Ie);
                    var r = 0, i, f = o;
                    do {
                        i = f;
                        f = a.parent(r++);
                        if (f instanceof wn) {
                            if (!(f.left instanceof $n)) continue;
                            if (f.left.definition() !== n) continue;
                            if (l(r, f)) break;
                            n.fixed = false;
                            return p();
                        } else if (f instanceof We) {
                            if (!t) break;
                            if (l(r, f)) break;
                            if (ne(s, [ n ])) break;
                            n.fixed = false;
                            return p();
                        }
                    } while (f instanceof yn && f.right === i || f instanceof hn && f.tail_node() === i || f instanceof gn);
                }
            }
            if (a.option("sequences")) {
                var u = o.lift_sequences(a);
                if (u !== o) return u.optimize(a);
            }
            if (!a.option("assignments")) return o;
            if (o.operator == "=" && o.left instanceof $n && o.right instanceof yn) {
                if (o.right.left instanceof $n && o.right.left.name == o.left.name && q[o.right.operator]) {
                    o.operator = o.right.operator + "=";
                    o.right = o.right.right;
                } else if (o.right.right instanceof $n && o.right.right.name == o.left.name && j[o.right.operator] && !o.right.left.has_side_effects(a)) {
                    o.operator = o.right.operator + "=";
                    o.right = o.right.left;
                }
            }
            if ((o.operator == "-=" || o.operator == "+=" && (o.left.is_boolean(a) || o.left.is_number(a))) && o.right instanceof Hn && o.right.value == 1) {
                var c = o.operator.slice(0, -1);
                return le(gn, o, {
                    operator: c + c,
                    expression: o.left
                });
            }
            return o;
            function l(e, n) {
                var t = o.right;
                o.right = le(Rn, t);
                var r = n.may_throw(a);
                o.right = t;
                var i;
                while (i = a.parent(e++)) {
                    if (i === s) return false;
                    if (i instanceof on) {
                        if (i.bfinally) return true;
                        if (r && i.bcatch) return true;
                    }
                }
            }
            function p() {
                return (o.operator != "=" ? le(yn, o, {
                    operator: o.operator.slice(0, -1),
                    left: o.left,
                    right: o.right
                }) : pe(a, a.parent(), o, o.right)).optimize(a);
            }
        });
        e(xn, function(e, n) {
            if (!n.option("conditionals")) return e;
            if (e.condition instanceof hn) {
                var t = e.condition.expressions.slice();
                e.condition = t.pop();
                t.push(e);
                return U(e, t);
            }
            var r = e.condition.is_truthy() || e.condition.evaluate(n);
            if (!r) {
                Ae.warn("Condition always false [{file}:{line},{col}]", e.start);
                return U(e, [ e.condition, e.alternative ]).optimize(n);
            } else if (!(r instanceof Ae)) {
                Ae.warn("Condition always true [{file}:{line},{col}]", e.start);
                return U(e, [ e.condition, e.consequent ]).optimize(n);
            }
            var i = r.negate(n, we(n));
            if (G(n, r, i) === i) {
                e = le(xn, e, {
                    condition: i,
                    consequent: e.alternative,
                    alternative: e.consequent
                });
                i = r;
                r = e.condition;
            }
            var o = e.consequent;
            var a = e.alternative;
            if (r instanceof $n && o instanceof $n && r.definition() === o.definition()) {
                return le(yn, e, {
                    operator: "||",
                    left: r,
                    right: a
                });
            }
            var s = o.tail_node();
            if (s instanceof wn) {
                var f = s.operator == "=";
                var u = f ? a.tail_node() : a;
                if ((f || o === s) && u instanceof wn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof $n || !r.has_side_effects(n) && m(o) && m(a))) {
                    return le(wn, e, {
                        operator: s.operator,
                        left: s.left,
                        right: le(xn, e, {
                            condition: r,
                            consequent: g(o),
                            alternative: g(a)
                        })
                    });
                }
            }
            if (o.equivalent_to(a)) return U(e, [ r, o ]).optimize(n);
            if (o instanceof ln && a.TYPE === o.TYPE && o.args.length == a.args.length) {
                var c = _();
                if (c == -1 && !(o.expression instanceof dn) && !(a.expression instanceof dn)) {
                    var l = o.clone();
                    l.expression = le(xn, e, {
                        condition: r,
                        consequent: o.expression,
                        alternative: a.expression
                    });
                    return l;
                }
                if (c >= 0 && o.expression.equivalent_to(a.expression) && !r.has_side_effects(n) && !o.expression.has_side_effects(n)) {
                    var l = o.clone();
                    l.args[c] = le(xn, e, {
                        condition: r,
                        consequent: o.args[c],
                        alternative: a.args[c]
                    });
                    return l;
                }
            }
            if (o instanceof xn && o.alternative.equivalent_to(a)) {
                return le(xn, e, {
                    condition: le(yn, e, {
                        left: r,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: a
                });
            }
            if (o instanceof xn && o.consequent.equivalent_to(a)) {
                return le(xn, e, {
                    condition: le(yn, e, {
                        left: i,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: a,
                    alternative: o.alternative
                });
            }
            if (a instanceof xn && o.equivalent_to(a.consequent)) {
                return le(xn, e, {
                    condition: le(yn, e, {
                        left: r,
                        operator: "||",
                        right: a.condition
                    }),
                    consequent: o,
                    alternative: a.alternative
                });
            }
            if (a instanceof xn && o.equivalent_to(a.alternative)) {
                return le(xn, e, {
                    condition: le(yn, e, {
                        left: i,
                        operator: "&&",
                        right: a.condition
                    }),
                    consequent: a.consequent,
                    alternative: o
                });
            }
            if ((o instanceof hn || a instanceof hn) && o.tail_node().equivalent_to(a.tail_node())) {
                return U(e, [ le(xn, e, {
                    condition: r,
                    consequent: b(o),
                    alternative: b(a)
                }), o.tail_node() ]).optimize(n);
            }
            if (o instanceof yn && o.operator == "&&" && o.right.equivalent_to(a)) {
                return le(yn, e, {
                    operator: "&&",
                    left: le(yn, e, {
                        operator: "||",
                        left: i,
                        right: o.left
                    }),
                    right: a
                }).optimize(n);
            }
            if (o instanceof yn && o.operator == "||" && o.right.equivalent_to(a)) {
                return le(yn, e, {
                    operator: "||",
                    left: le(yn, e, {
                        operator: "&&",
                        left: r,
                        right: o.left
                    }),
                    right: a
                }).optimize(n);
            }
            if (a instanceof yn && a.operator == "&&" && a.right.equivalent_to(o)) {
                return le(yn, e, {
                    operator: "&&",
                    left: le(yn, e, {
                        operator: "||",
                        left: r,
                        right: a.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (a instanceof yn && a.operator == "||" && a.right.equivalent_to(o)) {
                return le(yn, e, {
                    operator: "||",
                    left: le(yn, e, {
                        operator: "&&",
                        left: i,
                        right: a.left
                    }),
                    right: o
                }).optimize(n);
            }
            var p = n.option("booleans") && n.in_boolean_context();
            if (d(o)) {
                if (v(a)) {
                    return h(r);
                }
                return le(yn, e, {
                    operator: "||",
                    left: h(r),
                    right: a
                });
            }
            if (v(o)) {
                if (d(a)) {
                    return h(r.negate(n));
                }
                return le(yn, e, {
                    operator: "&&",
                    left: h(r.negate(n)),
                    right: a
                });
            }
            if (d(a)) {
                return le(yn, e, {
                    operator: "||",
                    left: h(r.negate(n)),
                    right: o
                });
            }
            if (v(a)) {
                return le(yn, e, {
                    operator: "&&",
                    left: h(r),
                    right: o
                });
            }
            if (n.option("typeofs")) B(r, o, a);
            return e;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return le(gn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function d(e) {
                return e instanceof Wn || p && e instanceof qn && e.value || e instanceof gn && e.operator == "!" && e.expression instanceof qn && !e.expression.value;
            }
            function v(e) {
                return e instanceof Vn || p && (e instanceof qn && !e.value || e instanceof gn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof gn && e.operator == "!" && e.expression instanceof qn && e.expression.value;
            }
            function _() {
                var e = o.args;
                var n = a.args;
                for (var t = 0, r = e.length; t < r; t++) {
                    if (!e[t].equivalent_to(n[t])) {
                        for (var i = t + 1; i < r; i++) {
                            if (!e[i].equivalent_to(n[i])) return -2;
                        }
                        return t;
                    }
                }
                return -1;
            }
            function m(e) {
                return e === e.tail_node() || ye(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function g(e) {
                if (!(e instanceof hn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return U(e, n);
            }
            function b(e) {
                if (!(e instanceof hn)) return le(Hn, e, {
                    value: 0
                });
                return U(e, e.expressions.slice(0, -1));
            }
        });
        e(Yn, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return le(Hn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof yn && (t.operator == "==" || t.operator == "!=")) {
                Ae.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return le(Hn, e, {
                    value: +e.value
                });
            }
            return le(gn, e, {
                operator: "!",
                expression: le(Hn, e, {
                    value: 1 - e.value
                })
            });
        });
        function H(e, n) {
            if (e instanceof $n) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof Ie)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(_n, function(e, t) {
            var n = e.expression;
            var r = e.property;
            if (t.option("properties")) {
                var i = r.evaluate(t);
                if (i !== r) {
                    if (typeof i == "string") {
                        if (i == "undefined") {
                            i = undefined;
                        } else {
                            var o = parseFloat(i);
                            if (o.toString() == i) {
                                i = o;
                            }
                        }
                    }
                    r = e.property = D(r, A(i, r).transform(t));
                    var a = "" + i;
                    if (Gn(a) && a.length <= r.print_to_string().length + 1) {
                        return le(vn, e, {
                            expression: n,
                            property: a
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f, u, c;
            if (t.option("arguments") && n instanceof $n && ue(f = n.definition()) && r instanceof Hn && (u = n.scope) === w()) {
                var l = r.value;
                if (s instanceof gn && s.operator == "delete") {
                    if (!f.deleted) f.deleted = [];
                    f.deleted[l] = true;
                }
                var p = u.argnames[l];
                if (f.deleted && f.deleted[l]) {
                    p = null;
                } else if (p && t.has_directive("use strict")) {
                    var h = p.definition();
                    if (!t.option("reduce_vars") || f.reassigned || h.assignments || h.orig.length > 1) {
                        p = null;
                    }
                } else if (!p && l < u.argnames.length + 5 && t.drop_fargs(u, c)) {
                    while (l >= u.argnames.length) {
                        p = le(Sn, u, {
                            name: u.make_var_name("argument_" + u.argnames.length),
                            scope: u
                        });
                        u.argnames.push(p);
                        u.enclosed.push(u.def_variable(p));
                    }
                }
                if (p && te(function(e) {
                    return e.name === p.name;
                }, u.argnames) === p) {
                    f.reassigned = false;
                    var d = le($n, e, p);
                    d.reference({});
                    delete p.__unused;
                    return d;
                }
            }
            if (_e(t.self(), s)) return e;
            if (t.option("sequences") && t.parent().TYPE != "Call") {
                var v = Q(e, t);
                if (v !== e) return v.optimize(t);
            }
            if (i !== r) {
                var _ = e.flatten_object(a, t);
                if (_) {
                    n = e.expression = _.expression;
                    r = e.property = _.property;
                }
            }
            if (t.option("properties") && t.option("side_effects") && r instanceof Hn && n instanceof An) {
                var l = r.value;
                var m = n.elements;
                var g = m[l];
                if (H(g, t)) {
                    var b = true;
                    var y = [];
                    for (var x = m.length; --x > l; ) {
                        var o = m[x].drop_side_effect_free(t);
                        if (o) {
                            y.unshift(o);
                            if (b && o.has_side_effects(t)) b = false;
                        }
                    }
                    g = g instanceof Un ? le(In, g) : g;
                    if (!b) y.unshift(g);
                    while (--x >= 0) {
                        var o = m[x].drop_side_effect_free(t);
                        if (o) y.unshift(o); else l--;
                    }
                    if (b) {
                        y.push(g);
                        return U(e, y).optimize(t);
                    } else return le(_n, e, {
                        expression: le(An, n, {
                            elements: y
                        }),
                        property: le(Hn, r, {
                            value: l
                        })
                    });
                }
            }
            return X(t, e);
            function w() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Ie) {
                        c = t.parent(e);
                        return n;
                    }
                }
            }
        });
        Re.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new Jn(function(e) {
                if (n) return true;
                if (e instanceof Mn) return n = true;
                if (e !== t && e instanceof Re) return true;
            }));
            return n;
        });
        dn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof En) {
                var r = t.properties;
                for (var i = r.length; --i >= 0; ) {
                    var o = r[i];
                    if ("" + o.key == e) {
                        if (!ye(r, function(e) {
                            return e instanceof Dn;
                        })) break;
                        if (!H(o.value, n)) break;
                        return le(_n, this, {
                            expression: le(An, t, {
                                elements: r.map(function(e) {
                                    return e.value;
                                })
                            }),
                            property: le(Hn, this, {
                                value: i
                            })
                        });
                    }
                }
            }
        });
        e(vn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                Ae.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            if (_e(n.self(), n.parent())) return e;
            if (n.option("sequences") && n.parent().TYPE != "Call") {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof vn && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (W(r)) switch (r.name) {
                  case "Array":
                    e.expression = le(An, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = le(Le, e.expression, {
                        argnames: [],
                        body: []
                    });
                    break;

                  case "Number":
                    e.expression = le(Hn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = le(En, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = le(Nn, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = le(jn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var i = e.flatten_object(e.property, n);
            if (i) return i.optimize(n);
            return X(n, e);
        });
        e(En, function(t, n) {
            if (!n.option("objects") || n.has_directive("use strict")) return t;
            var r = new xe();
            var i = [];
            t.properties.forEach(function(e) {
                if (typeof e.key != "string") {
                    o();
                    i.push(e);
                    return;
                }
                if (e.value.has_side_effects(n)) {
                    o();
                }
                r.add(e.key, e.value);
            });
            o();
            if (t.properties.length != i.length) {
                return le(En, t, {
                    properties: i
                });
            }
            return t;
            function o() {
                r.each(function(e, n) {
                    i.push(le(Dn, t, {
                        key: n,
                        value: U(t, e)
                    }));
                });
                r = new xe();
            }
        });
        e(Je, function(e, n) {
            if (e.value && C(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var x = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var w = x.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, o = 0; i < n.length; i++) {
            var a = w[n[i]];
            t += (a & 31) << r;
            if (a & 32) {
                r += 5;
            } else {
                e[o++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return o;
    }
    function E(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += x[t];
        } while (e);
        return n;
    }
    function k() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!se(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function D(l) {
        l = re(l, {
            content: false,
            file: null,
            root: null,
            orig: null
        }, true);
        var f = k();
        var o = l.content && Object.create(null);
        var u = k();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!o || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) o[n.sources[r]] = i;
            }
        });
        var p = 1;
        var h = 0;
        var d = 0;
        var v = 1;
        var _ = 0;
        var m = 0;
        return {
            add: l.orig ? function(e, n, t, r, i, o) {
                var a = l.orig[e];
                if (a) {
                    var s = a.mappings[r - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (i >= c) f = s[u];
                        if (i <= c) break;
                    }
                    if (!f || f.length < 4) return;
                    e = a.sources[f[1]];
                    r = f[2];
                    i = f[3];
                    if (f.length > 4) o = a.names[f[4]];
                }
                g(e, n, t, r, i, o);
            } : g,
            setSourceContent: o ? function(e, n) {
                o[e] = n;
            } : ie,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.file || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: o ? f.map(function(e) {
                        return o[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function g(e, n, t, r, i, o) {
            if (p < n) {
                h = 0;
                do {
                    c += ";";
                } while (++p < n);
            } else if (c) {
                c += ",";
            }
            c += E(t - h);
            h = t;
            var a = f.index(e);
            c += E(a - d);
            d = a;
            c += E(r - v);
            v = r;
            c += E(i - _);
            _ = i;
            if (o != null) {
                var s = u.index(o);
                c += E(s - m);
                m = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Ee && e[t].body instanceof jn) {
                    e[t] = new De({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Ee && e[t].body instanceof jn)) {
                    n = false;
                }
            }
            return e;
        }
        var r = {
            Program: function(e) {
                return new Pe({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new Ye({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new Le({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Fe({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new on({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new sn(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: n.type == "Identifier" ? n.name : n.value,
                    value: u(e.value)
                };
                if (e.kind == "init") return new Dn(t);
                t.key = new ce({
                    name: t.key
                });
                t.value = new Ue(t.value);
                if (e.kind == "get") return new ue(t);
                if (e.kind == "set") return new fe(t);
            },
            ArrayExpression: function(e) {
                return new An({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Un() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new En({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new hn({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? _n : vn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? rn : tn)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new un({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new Rn(t);
                var r = e.regex;
                if (r && r.pattern) {
                    t.value = new RegExp(r.pattern, r.flags);
                    t.value.raw_source = r.pattern;
                    return new Nn(t);
                } else if (r) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new Nn(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new jn(t);

                  case "number":
                    t.value = n;
                    return new Hn(t);

                  case "boolean":
                    return new (n ? Wn : Vn)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? le : n.type == "VariableDeclarator" && n.id === e ? Bn : n.type == "FunctionExpression" ? n.id === e ? On : Sn : n.type == "FunctionDeclaration" ? n.id === e ? Tn : Sn : n.type == "CatchClause" ? zn : n.type == "BreakStatement" || n.type == "ContinueStatement" ? pe : $n)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? gn : bn)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Te);
        e("BlockStatement", Se, "body@body");
        e("IfStatement", Ze, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Oe, "label>label, body>body");
        e("BreakStatement", Ke, "label>label");
        e("ContinueStatement", Qe, "label>label");
        e("WithStatement", Ne, "object>expression, body>body");
        e("SwitchStatement", en, "discriminant>expression, cases@body");
        e("ReturnStatement", Je, "argument>value");
        e("ThrowStatement", Ge, "argument>value");
        e("WhileStatement", qe, "test>condition, body>body");
        e("DoWhileStatement", Me, "test>condition, body>body");
        e("ForStatement", je, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", He, "left>init, right>object, body>body");
        e("DebuggerStatement", ke);
        e("VariableDeclarator", cn, "id>name, init>value");
        e("CatchClause", an, "param>argname, body%body");
        e("ThisExpression", Mn);
        e("BinaryExpression", yn, "operator=operator, left>left, right>right");
        e("LogicalExpression", yn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", wn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", xn, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", pn, "callee>expression, arguments@args");
        e("CallExpression", ln, "callee>expression, arguments@args");
        c(Pe, function e(n) {
            return h("Program", n);
        });
        c(Ye, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: h("BlockStatement", n)
            };
        });
        c(Le, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: h("BlockStatement", n)
            };
        });
        c(De, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Fe, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(nn, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(on, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(an, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(fn, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(hn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(dn, function e(n) {
            var t = n instanceof _n;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(mn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof gn,
                argument: l(n.expression)
            };
        });
        c(yn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(An, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(En, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(kn, function e(n) {
            var t = {
                type: "Literal",
                value: n.key instanceof ce ? n.key.name : n.key
            };
            var r;
            if (n instanceof Dn) {
                r = "init";
            } else if (n instanceof ue) {
                r = "get";
            } else if (n instanceof fe) {
                r = "set";
            }
            return {
                type: "Property",
                kind: r,
                key: t,
                value: l(n.value)
            };
        });
        c(Fn, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Nn, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(qn, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(a, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        Yn.DEFMETHOD("to_mozilla_ast", qn.prototype.to_mozilla_ast);
        Rn.DEFMETHOD("to_mozilla_ast", qn.prototype.to_mozilla_ast);
        Un.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        Be.DEFMETHOD("to_mozilla_ast", Se.prototype.to_mozilla_ast);
        Ie.DEFMETHOD("to_mozilla_ast", Le.prototype.to_mozilla_ast);
        function i(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: i(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: i(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                o += ",\n" + i + ": ";
                a += ",\n" + t + ": ";
                switch (r) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + i + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + i + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + i;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(d, s, f, u);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, h);
            r[e] = o;
            c(n, a);
        }
        var o = null;
        function u(e) {
            o.push(e);
            var n = e != null ? r[e.type](e) : null;
            o.pop();
            return n;
        }
        Ae.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = u(e);
            o = n;
            t.walk(new Jn(function(e) {
                if (e instanceof pe) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Re) break;
                        if (t instanceof Oe && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        ve("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var r = e.start;
            var i = e.end;
            if (r.pos != null && i.endpos != null) {
                n.range = [ r.pos, i.endpos ];
            }
            if (r.line) {
                n.loc = {
                    start: {
                        line: r.line,
                        column: r.col
                    },
                    end: i.endline ? {
                        line: i.endline,
                        column: i.endcol
                    } : null
                };
                if (r.file) {
                    n.loc.source = r.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function h(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Fe && n.body[0].body instanceof jn) {
                t.unshift(l(new Te(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function F(n) {
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        function t(e) {
            v(n, e);
        }
    }
    function C(e, n) {
        e.walk(new Jn(function(e) {
            if (e instanceof Dn && e.quote) {
                t(e.key);
            } else if (e instanceof _n) {
                B(e.property, t);
            }
        }));
        function t(e) {
            v(n, e);
        }
    }
    function B(e, n) {
        e.walk(new Jn(function(e) {
            if (e instanceof hn) {
                B(e.tail_node(), n);
            } else if (e instanceof jn) {
                n(e.value);
            } else if (e instanceof xn) {
                B(e.consequent, n);
                B(e.alternative, n);
            }
            return true;
        }));
    }
    function S(e, n) {
        n = re(n, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            only_cache: false,
            regex: null,
            reserved: null
        }, true);
        var t = n.reserved;
        if (!Array.isArray(t)) t = [];
        if (!n.builtins) F(t);
        var r = -1;
        var i;
        if (n.cache) {
            i = n.cache.props;
            i.each(function(e) {
                v(t, e);
            });
        } else {
            i = new xe();
        }
        var o = n.regex;
        var a = n.debug !== false;
        var s;
        if (a) s = n.debug === true ? "" : n.debug;
        var f = [];
        var u = [];
        e.walk(new Jn(function(e) {
            if (e instanceof Dn) {
                p(e.key);
            } else if (e instanceof kn) {
                p(e.key.name);
            } else if (e instanceof vn) {
                p(e.property);
            } else if (e instanceof _n) {
                B(e.property, p);
            } else if (e instanceof ln && e.expression.print_to_string() == "Object.defineProperty") {
                B(e.args[1], p);
            }
        }));
        return e.transform(new it(function(e) {
            if (e instanceof Dn) {
                e.key = h(e.key);
            } else if (e instanceof kn) {
                e.key.name = h(e.key.name);
            } else if (e instanceof vn) {
                e.property = h(e.property);
            } else if (!n.keep_quoted && e instanceof _n) {
                e.property = d(e.property);
            } else if (e instanceof ln && e.expression.print_to_string() == "Object.defineProperty") {
                e.args[1] = d(e.args[1]);
            }
        }));
        function c(e) {
            if (u.indexOf(e) >= 0) return false;
            if (t.indexOf(e) >= 0) return false;
            if (n.only_cache) return i.has(e);
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (o && !o.test(e)) return false;
            if (t.indexOf(e) >= 0) return false;
            return i.has(e) || f.indexOf(e) >= 0;
        }
        function p(e) {
            if (c(e)) v(f, e);
            if (!l(e)) v(u, e);
        }
        function h(e) {
            if (!l(e)) {
                return e;
            }
            var n = i.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = y(++r);
                } while (!c(n));
                i.set(e, n);
            }
            return n;
        }
        function d(e) {
            return e.transform(new it(function(e) {
                if (e instanceof hn) {
                    var n = e.expressions.length - 1;
                    e.expressions[n] = d(e.expressions[n]);
                } else if (e instanceof jn) {
                    e.value = h(e.value);
                } else if (e instanceof xn) {
                    e.consequent = d(e.consequent);
                    e.alternative = d(e.alternative);
                }
                return e;
            }));
        }
    }
    "use strict";
    var T, X;
    if (typeof Buffer == "undefined") {
        T = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        T = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        T = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var o = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!o) break;
            if (o[1] == "sourceMappingURL") {
                o = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(o[2]);
                if (!o) break;
                return T(o[2]);
            }
        }
        Ae.warn("inline source map not found: " + e);
    }
    function ft(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function ut(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function ct(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new xe();
        } else if (!(e.props instanceof xe)) {
            e.props = xe.fromObject(e.props);
        }
    }
    function lt(e) {
        return {
            props: e.props.toObject()
        };
    }
    function pt(r, i) {
        try {
            i = re(i, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                warnings: false,
                wrap: false
            }, true);
            var e = i.timings && {
                start: Date.now()
            };
            if (i.rename === undefined) {
                i.rename = i.compress && i.mangle;
            }
            ut("ie8", i, [ "compress", "mangle", "output" ]);
            ut("keep_fnames", i, [ "compress", "mangle" ]);
            ut("toplevel", i, [ "compress", "mangle" ]);
            var n;
            if (i.mangle) {
                i.mangle = re(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                ct(i.mangle.cache);
                ct(i.mangle.properties.cache);
            }
            if (i.sourceMap) {
                i.sourceMap = re(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) Ae.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var o, a;
            if (r instanceof Pe) {
                a = r;
            } else {
                if (typeof r == "string") {
                    r = [ r ];
                }
                i.parse = i.parse || {};
                i.parse.toplevel = null;
                var s = i.sourceMap && i.sourceMap.content;
                if (typeof s == "string" && s != "inline") {
                    s = ft(s);
                }
                o = s && Object.create(null);
                for (var f in r) if (se(r, f)) {
                    i.parse.filename = f;
                    i.parse.toplevel = a = rt(r[f], i.parse);
                    if (o) {
                        if (s == "inline") {
                            var u = K(f, a);
                            if (u) {
                                o[f] = ft(u);
                            }
                        } else {
                            o[f] = s;
                        }
                    }
                }
            }
            if (n) {
                C(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.mangle);
                a.expand_names(i.mangle);
            }
            if (e) e.compress = Date.now();
            if (i.compress) a = new st(i.compress).compress(a);
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (i.mangle && i.mangle.properties) {
                a = S(a, i.mangle.properties);
            }
            if (e) e.output = Date.now();
            var c = {};
            if (i.output.ast) {
                c.ast = a;
            }
            if (!se(i.output, "code") || i.output.code) {
                if (i.sourceMap) {
                    i.output.source_map = D({
                        content: i.sourceMap.includeSources,
                        file: i.sourceMap.filename,
                        orig: o,
                        root: i.sourceMap.root
                    });
                    if (i.sourceMap.includeSources) {
                        if (r instanceof Pe) {
                            throw new Error("original source content unavailable");
                        } else for (var f in r) if (se(r, f)) {
                            i.output.source_map.setSourceContent(f, r[f]);
                        }
                    }
                }
                delete i.output.ast;
                delete i.output.code;
                var l = at(i.output);
                a.print(l);
                c.code = l.get();
                if (i.sourceMap) {
                    c.map = i.output.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        c.code = c.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            c.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(c.map);
                        } else {
                            c.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = lt(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = lt(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                c.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                c.warnings = t;
            }
            return c;
        } catch (e) {
            return {
                error: e
            };
        }
    }
    d["Dictionary"] = xe;
    d["List"] = be;
    d["minify"] = pt;
    d["parse"] = rt;
    d["push_uniq"] = v;
    d["TreeTransformer"] = it;
    d["TreeWalker"] = Jn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
